type token =
  | TUnknown of (Ast_c.info)
  | TCommentSpace of (Ast_c.info)
  | TCommentNewline of (Ast_c.info)
  | TComment of (Ast_c.info)
  | TInt of ((string * (Ast_c.sign * Ast_c.base)) * Ast_c.info)
  | TFloat of ((string * Ast_c.floatType) * Ast_c.info)
  | TChar of ((string * Ast_c.isWchar) * Ast_c.info)
  | TString of ((string * Ast_c.isWchar) * Ast_c.info)
  | TQuote of ((string * Ast_c.isWchar) * Ast_c.info)
  | TPct of (Ast_c.info)
  | TFormat of (string * Ast_c.info)
  | TSubString of (string * Ast_c.info)
  | TDecimal of ((string * string (*n*) * string (*p*)) * Ast_c.info)
  | TIdent of (string * Ast_c.info)
  | TKRParam of (string * Ast_c.info)
  | Tconstructorname of (string * Ast_c.info)
  | TypedefIdent of (string * Ast_c.info)
  | TOPar of (Ast_c.info)
  | TCPar of (Ast_c.info)
  | TOBrace of (Ast_c.info)
  | TCBrace of (Ast_c.info)
  | TOCro of (Ast_c.info)
  | TCCro of (Ast_c.info)
  | TDot of (Ast_c.info)
  | TComma of (Ast_c.info)
  | TPtrOp of (Ast_c.info)
  | TInc of (Ast_c.info)
  | TDec of (Ast_c.info)
  | TAssign of (Ast_c.assignOp)
  | TEq of (Ast_c.info)
  | TWhy of (Ast_c.info)
  | TTilde of (Ast_c.info)
  | TBang of (Ast_c.info)
  | TEllipsis of (Ast_c.info)
  | TDotDot of (Ast_c.info)
  | TPtVirg of (Ast_c.info)
  | TOrLog of (Ast_c.info)
  | TAndLog of (Ast_c.info)
  | TOr of (Ast_c.info)
  | TXor of (Ast_c.info)
  | TAnd of (Ast_c.info)
  | TEqEq of (Ast_c.info)
  | TNotEq of (Ast_c.info)
  | TInf of (Ast_c.info)
  | TSup of (Ast_c.info)
  | TInfEq of (Ast_c.info)
  | TSupEq of (Ast_c.info)
  | TShl of (Ast_c.info)
  | TShr of (Ast_c.info)
  | TPlus of (Ast_c.info)
  | TMinus of (Ast_c.info)
  | TMul of (Ast_c.info)
  | TDiv of (Ast_c.info)
  | TMod of (Ast_c.info)
  | TMax of (Ast_c.info)
  | TMin of (Ast_c.info)
  | Tchar of (Ast_c.info)
  | Tshort of (Ast_c.info)
  | Tint of (Ast_c.info)
  | Tdouble of (Ast_c.info)
  | Tfloat of (Ast_c.info)
  | Tlong of (Ast_c.info)
  | Tunsigned of (Ast_c.info)
  | Tsigned of (Ast_c.info)
  | Tvoid of (Ast_c.info)
  | Tsize_t of (Ast_c.info)
  | Tssize_t of (Ast_c.info)
  | Tptrdiff_t of (Ast_c.info)
  | Tauto of (Ast_c.info)
  | Tregister of (Ast_c.info)
  | Textern of (Ast_c.info)
  | Tstatic of (Ast_c.info)
  | Ttypedef of (Ast_c.info)
  | Tconst of (Ast_c.info)
  | Tvolatile of (Ast_c.info)
  | Tstruct of (Ast_c.info)
  | Tunion of (Ast_c.info)
  | Tenum of (Ast_c.info)
  | Tdecimal of (Ast_c.info)
  | Texec of (Ast_c.info)
  | Tbreak of (Ast_c.info)
  | Telse of (Ast_c.info)
  | Tswitch of (Ast_c.info)
  | Tcase of (Ast_c.info)
  | Tcontinue of (Ast_c.info)
  | Tfor of (Ast_c.info)
  | Tdo of (Ast_c.info)
  | Tif of (Ast_c.info)
  | Twhile of (Ast_c.info)
  | Treturn of (Ast_c.info)
  | Tgoto of (Ast_c.info)
  | Tdefault of (Ast_c.info)
  | Tsizeof of (Ast_c.info)
  | Tnew of (Ast_c.info)
  | Tdelete of (Ast_c.info)
  | Tdefined of (Ast_c.info)
  | TOParCplusplusInit of (Ast_c.info)
  | Tnamespace of (Ast_c.info)
  | Trestrict of (Ast_c.info)
  | Tasm of (Ast_c.info)
  | Tattribute of (Ast_c.info)
  | TattributeNoarg of (Ast_c.info)
  | Tinline of (Ast_c.info)
  | Ttypeof of (Ast_c.info)
  | TDefine of (Ast_c.info)
  | TDefParamVariadic of ((string * Ast_c.info))
  | TCppEscapedNewline of (Ast_c.info)
  | TCppConcatOp of (Ast_c.info)
  | TOParDefine of (Ast_c.info)
  | TOBraceDefineInit of (Ast_c.info)
  | TIdentDefine of ((string * Ast_c.info))
  | TDefEOL of (Ast_c.info)
  | TInclude of ((string * string * bool ref * Ast_c.info))
  | TIncludeStart of ((Ast_c.info * bool ref))
  | TIncludeFilename of ((string * Ast_c.info))
  | TIfdef of ((Ast_c.ifdef_guard * (int * int) option ref * Ast_c.info))
  | TIfdefelif of ((Ast_c.ifdef_guard * (int * int) option ref * Ast_c.info))
  | TIfdefelse of (((int * int) option ref * Ast_c.info))
  | TEndif of (((int * int) option ref * Ast_c.info))
  | TIfdefBool of ((bool * (int * int) option ref * Ast_c.info))
  | TIfdefMisc of ((bool * (int * int) option ref * Ast_c.info))
  | TIfdefVersion of ((bool * (int * int) option ref * Ast_c.info))
  | TUifdef of (Ast_c.info)
  | TUelseif of (Ast_c.info)
  | TUendif of (Ast_c.info)
  | TUndef of (Ast_c.info)
  | TPragma of (Ast_c.info)
  | TCppDirectiveOther of (Ast_c.info)
  | TMacroAttr of ((string * Ast_c.info))
  | TMacroEndAttr of ((string * Ast_c.info))
  | TMacroStmt of ((string * Ast_c.info))
  | TMacroIdentBuilder of ((string * Ast_c.info))
  | TMacroString of ((string * Ast_c.info))
  | TMacroDecl of ((string * Ast_c.info))
  | TMacroDeclConst of (Ast_c.info)
  | TMacroIterator of ((string * Ast_c.info))
  | TCommentSkipTagStart of (Ast_c.info)
  | TCommentSkipTagEnd of (Ast_c.info)
  | TCParEOL of (Ast_c.info)
  | TAction of (Ast_c.info)
  | TCommentMisc of (Ast_c.info)
  | TCommentCpp of ((Token_c.cppcommentkind * Ast_c.info))
  | EOF of (Ast_c.info)
  | TTODO of (Ast_c.info)

open Parsing;;
let _ = parse_error;;
# 2 "parsing_c/parser_c.mly"
(* Yoann Padioleau
 *
 * Copyright (C) 2002, 2006, 2007, 2008, 2009 Yoann Padioleau
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License (GPL)
 * version 2 as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * file license.txt for more details.
 *)

(**
 * This grammar has been inspired by:
 * http://www.lysator.liu.se/c/ANSI-C-grammar-y.html
 *)

open Common

open Ast_c

module LP = Lexer_parser
open Lexer_parser (* for the fields *)

open Semantic_c (* Semantic exn *)
module T = Token_c

(*****************************************************************************)
(* Wrappers *)
(*****************************************************************************)
let warning s v =
  if !Flag_parsing_c.verbose_parsing
  then Common.warning ("PARSING: " ^ s) v
  else v

let computed_warning s v = (*do not construct string unless it will be shown*)
  if !Flag_parsing_c.verbose_parsing
  then Common.warning ("PARSING: " ^ (s())) v
  else v

let pr2, pr2_once = Common.mk_pr2_wrappers Flag_parsing_c.verbose_parsing

(*****************************************************************************)
(* Parse helpers functions *)
(*****************************************************************************)

(*-------------------------------------------------------------------------- *)
(* Type related *)
(*-------------------------------------------------------------------------- *)

type shortLong      = Short  | Long | LongLong

type decl = {
  storageD: storagebis wrap;
  typeD: ((sign option) * (shortLong option) * (typeCbis option)) wrap;
  qualifD: typeQualifierbis wrap;
  inlineD: bool             wrap;
  (* note: have a full_info: parse_info list; to remember ordering
   * between storage, qualifier, type ? well this info is already in
   * the Ast_c.info, just have to sort them to get good order *)
}

let nullDecl = {
  storageD = NoSto, [];
  typeD = (None, None, None), [];
  qualifD = nullQualif;
  inlineD = false, [];
}
let fake_pi = Common.fake_parse_info

let addStorageD  = function
  | ((x,ii), ({storageD = (NoSto,[])} as v)) -> { v with storageD = (x, [ii]) }
  | ((x,ii), ({storageD = (y, ii2)} as v)) ->
      if x = y then warning "duplicate storage classes" v
      else warning "multiple storage classes, keeping the second" v

let addInlineD  = function
  | ((true,ii), ({inlineD = (false,[])} as v)) -> { v with inlineD=(true,[ii])}
  | ((true,ii), ({inlineD = (true, ii2)} as v)) -> warning "duplicate inline" v
  | _ -> raise (Impossible 86)


let addTypeD     = function
  | ((Left3 Signed,ii)   ,({typeD = ((Some Signed,  b,c),ii2)} as v)) ->
      warning "duplicate 'signed'"   v
  | ((Left3 UnSigned,ii) ,({typeD = ((Some UnSigned,b,c),ii2)} as v)) ->
      warning "duplicate 'unsigned'" v
  | ((Left3 _,ii),        ({typeD = ((Some _,b,c),ii2)} as _v)) ->
      raise (Semantic ("both signed and unsigned specified", fake_pi))
  | ((Left3 x,ii),        ({typeD = ((None,b,c),ii2)} as v))   ->
      {v with typeD = (Some x,b,c),ii @ ii2}

  | ((Middle3 Short,ii),  ({typeD = ((a,Some Short,c),ii2)} as v)) ->
      warning "duplicate 'short'" v


  (* gccext: long long allowed *)
  | ((Middle3 Long,ii),   ({typeD = ((a,Some Long ,c),ii2)} as v)) ->
      { v with typeD = (a, Some LongLong, c),ii @ ii2 }
  | ((Middle3 Long,ii),   ({typeD = ((a,Some LongLong ,c),ii2)} as v)) ->
      warning "triplicate 'long'" v


  | ((Middle3 _,ii),      ({typeD = ((a,Some _,c),ii2)} as _v)) ->
      raise (Semantic ("both long and short specified", fake_pi))
  | ((Middle3 x,ii),      ({typeD = ((a,None,c),ii2)} as v))  ->
      {v with typeD = (a, Some x,c),ii @ ii2}

  | ((Right3 t,ii),       ({typeD = ((a,b,Some x),ii2)} as v)) ->
      let mktype t ii = (({const=false;volatile=false;},[]),(t,ii)) in
      computed_warning
	(fun _ ->
	  Printf.sprintf
	    "two or more data types: dropping %s, keeping typeD %s\n"
	    (Pretty_print_c.string_of_fullType (mktype t ii))
	    (Pretty_print_c.string_of_fullType (mktype x ii2)))
	v
  | ((Right3 t,ii),       ({typeD = ((a,b,None),ii2)} as v))   ->
      {v with typeD = (a,b, Some t),ii @ ii2}


let addQualif = function
  | ({const=true},   ({const=true} as x)) ->   warning "duplicate 'const'" x
  | ({volatile=true},({volatile=true} as x))-> warning "duplicate 'volatile'" x
  | ({const=true},    v) -> {v with const=true}
  | ({volatile=true}, v) -> {v with volatile=true}
  | _ ->
      internal_error "there is no noconst or novolatile keyword"

let addQualifD ((qu,ii), ({qualifD = (v,ii2)} as x)) =
  { x with qualifD = (addQualif (qu, v),ii::ii2) }


(*-------------------------------------------------------------------------- *)
(* Declaration/Function related *)
(*-------------------------------------------------------------------------- *)


(* stdC: type section, basic integer types (and ritchie)
 * To understand the code, just look at the result (right part of the PM)
 * and go back.
 *)
let (fixDeclSpecForDecl: decl -> (fullType * (storage wrap)))  = function
 {storageD = (st,iist);
  qualifD = (qu,iiq);
  typeD = (ty,iit);
  inlineD = (inline,iinl);
  } ->
   let ty',iit' =
   (match ty with
 | (None,None,None)       ->
     (* generate fake_info, otherwise type_annotater can crash in
      * offset.
      *)
     warning "type defaults to 'int'" (defaultInt, [fakeInfo fake_pi])
 | (None, None, Some t)   -> (t, iit)

 | (Some sign,   None, (None| Some (BaseType (IntType (Si (_,CInt))))))  ->
     BaseType(IntType (Si (sign, CInt))), iit
 | ((None|Some Signed),Some x,(None|Some(BaseType(IntType (Si (_,CInt)))))) ->
     BaseType(IntType (Si (Signed, [Short,CShort; Long, CLong; LongLong, CLongLong] +> List.assoc x))), iit
 | (Some UnSigned, Some x, (None| Some (BaseType (IntType (Si (_,CInt))))))->
     BaseType(IntType (Si (UnSigned, [Short,CShort; Long, CLong; LongLong, CLongLong] +> List.assoc x))), iit
 | (Some sign,   None, (Some (BaseType (IntType CChar))))   ->
     BaseType(IntType (Si (sign, CChar2))), iit
 | (None, Some Long,(Some(BaseType(FloatType CDouble))))    ->
     BaseType (FloatType (CLongDouble)), iit

 | (Some _,_, Some _) ->
     (*mine*)
     raise (Semantic ("signed, unsigned valid only for char and int", fake_pi))
 | (_,Some _,(Some(BaseType(FloatType (CFloat|CLongDouble))))) ->
     raise (Semantic ("long or short specified with floating type", fake_pi))
 | (_,Some Short,(Some(BaseType(FloatType CDouble)))) ->
     raise (Semantic ("the only valid combination is long double", fake_pi))

 | (_, Some _, Some _) ->
     (* mine *)
     raise (Semantic ("long, short valid only for int or float", fake_pi))

     (* if do short uint i, then gcc say parse error, strange ? it is
      * not a parse error, it is just that we dont allow with typedef
      * either short/long or signed/unsigned. In fact, with
      * parse_typedef_fix2 (with et() and dt()) now I say too parse
      * error so this code is executed only when do short struct
      * {....} and never with a typedef cos now we parse short uint i
      * as short ident ident => parse error (cos after first short i
      * pass in dt() mode) *)

   )
   in
   ((qu, iiq),
   (ty', iit'))
     ,((st, inline),iist @ iinl)


let fixDeclSpecForParam = function ({storageD = (st,iist)} as r) ->
  let ((qu,ty) as v,_st) = fixDeclSpecForDecl r in
  match st with
  | (Sto Register) -> (v, true), iist
  | NoSto -> (v, false), iist
  | _ ->
      raise
        (Semantic ("storage class specified for parameter of function",
                  fake_pi))

let fixDeclSpecForMacro = function ({storageD = (st,iist)} as r) ->
  let ((qu,ty) as v,_st) = fixDeclSpecForDecl r in
  match st with
  | NoSto -> v
  | _ ->
      raise
        (Semantic ("storage class specified for macro type decl",
                  fake_pi))


let fixDeclSpecForFuncDef x =
  let (returnType,storage) = fixDeclSpecForDecl x in
  (match fst (unwrap storage) with
  | StoTypedef ->
      raise (Semantic ("function definition declared 'typedef'", fake_pi))
  | _ -> (returnType, storage)
  )


(* parameter: (this is the context where we give parameter only when
 * in func DEFINITION not in funct DECLARATION) We must have a name.
 * This function ensure that we give only parameterTypeDecl with well
 * formed Classic constructor todo?: do we accept other declaration
 * in ? so I must add them to the compound of the deffunc. I dont
 * have to handle typedef pb here cos C forbid to do VF f { ... }
 * with VF a typedef of func cos here we dont see the name of the
 * argument (in the typedef)
 *)
let (fixOldCDecl: fullType -> fullType) = fun ty ->
  match Ast_c.unwrap_typeC ty with
  | FunctionType (fullt, (params, (b, iib))) ->

      (* stdC: If the prototype declaration declares a parameter for a
       * function that you are defining (it is part of a function
       * definition), then you must write a name within the declarator.
       * Otherwise, you can omit the name. *)
      (match params with
      | [{p_namei = None; p_type = ty2},_] ->
          (match Ast_c.unwrap_typeC ty2 with
          | BaseType Void ->
              ty
          | _ ->
              pr2_once ("SEMANTIC:parameter name omitted, but I continue");
              ty
          )

      | params ->
          (params +> List.iter (fun (param,_) ->
            match param with
            | {p_namei = None} ->
              (* if majuscule, then certainly macro-parameter *)
                pr2_once ("SEMANTIC:parameter name omitted, but I continue");
	    | _ -> ()
          ));
          ty
      )

        (* todo? can we declare prototype in the decl or structdef,
           ... => length <> but good kan meme *)
  | _ ->
      (* gcc say parse error but dont see why *)
      raise (Semantic ("seems this is not a function", fake_pi))


let fixFunc (typ, compound, old_style_opt) =
  let (cp,iicp) = compound in

  let (name, ty,   (st,iist),  attrs) = typ in

  let (qu, tybis) = ty in

  match Ast_c.unwrap_typeC ty with
  | FunctionType (fullt, (params,abool)) ->
      let iifunc = Ast_c.get_ii_typeC_take_care tybis in

      let iistart = Ast_c.fakeInfo () in
      assert (qu = nullQualif);

      (match params with
      | [{p_namei= None; p_type = ty2}, _] ->
          (match Ast_c.unwrap_typeC ty2 with
          | BaseType Void ->  ()
          | _ ->
                (* failwith "internal errror: fixOldCDecl not good" *)
              ()
          )
      | params ->
          params +> List.iter (function
          | ({p_namei = Some s}, _) -> ()
	  | _ -> ()
                (* failwith "internal errror: fixOldCDecl not good" *)
          )
      );
      (* bugfix: cf tests_c/function_pointer4.c.
       * Apparemment en C on peut syntaxiquement ecrire ca:
       *
       *   void a(int)(int x);
       * mais apres gcc gueule au niveau semantique avec:
       *   xxx.c:1: error: 'a' declared as function returning a function
       * Je ne faisais pas cette verif. Sur du code comme
       *   void METH(foo)(int x) { ...} , le parser croit (a tort) que foo
       * est un typedef, et donc c'est parsé comme l'exemple precedent,
       * ce qui ensuite confuse l'unparser qui n'est pas habitué
       * a avoir dans le returnType un FunctionType et qui donc
       * pr_elem les ii dans le mauvais sens ce qui genere au final
       * une exception. Hence this fix to at least detect the error
       * at parsing time (not unparsing time).
       *)
      (match Ast_c.unwrap_typeC fullt with
      | FunctionType _ ->
          let s = Ast_c.str_of_name name in
          let iis = Ast_c.info_of_name name in
          pr2 (spf "WEIRD: %s declared as function returning a function." s);
          pr2 (spf "This is probably because of a macro. Extend standard.h");
          raise (Semantic (spf "error: %s " s, Ast_c.parse_info_of_info iis))
      | _ -> ()
      );

      (* it must be nullQualif,cos parser construct only this*)
      {f_name = name;
       f_type = (fullt, (params, abool));
       f_storage = st;
       f_body =
	if !Flag_parsing_c.parsing_header_for_types
	then []
	else cp;
       f_attr = attrs;
       f_old_c_style = old_style_opt;
      },
      (iifunc @ iicp @ [iistart] @ iist)
  | _ ->
      raise
        (Semantic
            ("you are trying to do a function definition but you dont give " ^
             "any parameter", fake_pi))


(*-------------------------------------------------------------------------- *)
(* parse_typedef_fix2 *)
(*-------------------------------------------------------------------------- *)

let dt s () =
  if !Flag_parsing_c.debug_etdt then pr2 ("<" ^ s);
  LP.disable_typedef ()

let et s () =
  if !Flag_parsing_c.debug_etdt then pr2 (">" ^ s);
  LP.enable_typedef ()


let fix_add_params_ident x =
  let (s, ty, st, _attrs) = x in
  match Ast_c.unwrap_typeC ty with
  | FunctionType (fullt, (params, bool)) ->

      (match params with
      | [{p_namei=None; p_type=ty2}, _] ->
          (match Ast_c.unwrap_typeC ty2 with
          | BaseType Void -> ()
          | _ ->
              (* failwith "internal errror: fixOldCDecl not good" *)
              ()
          )
      | params ->
          params +> List.iter (function
          | ({p_namei= Some name}, _) ->
              LP.add_ident (Ast_c.str_of_name s)
	  | _ ->
              ()
                (* failwith "internal errror: fixOldCDecl not good" *)
          )
      )
  | _ -> ()

(*-------------------------------------------------------------------------- *)
(* shortcuts *)
(*-------------------------------------------------------------------------- *)

let mk_e e ii = Ast_c.mk_e e ii

let mk_string_wrap (s,info) = (s, [info])

(*-------------------------------------------------------------------------- *)
(* support for functions with no return type *)
(*-------------------------------------------------------------------------- *)

let args_are_params l =
  match l with
    [Right (ArgAction(ActMisc [x])), ii] when Ast_c.is_fake x -> true
  | _ -> List.for_all (function Right (ArgType x), ii -> true | _ -> false) l
let args_to_params l pb =
  let pi =
    match pb with Some pb -> Ast_c.parse_info_of_info pb | None -> fake_pi in
  match l with
    [(Right (ArgAction(ActMisc [x])), ii)] when Ast_c.is_fake x -> []
  | l ->
      List.map
	(function
	    Right (ArgType x), ii -> x, ii
	  | x ->
	      raise
		(Semantic
		   ("function with no return type must have types in param list",
		    pi)))
	l

# 565 "parsing_c/parser_c.ml"
let yytransl_const = [|
    0|]

let yytransl_block = [|
  257 (* TUnknown *);
  258 (* TCommentSpace *);
  259 (* TCommentNewline *);
  260 (* TComment *);
  261 (* TInt *);
  262 (* TFloat *);
  263 (* TChar *);
  264 (* TString *);
  265 (* TQuote *);
  266 (* TPct *);
  267 (* TFormat *);
  268 (* TSubString *);
  269 (* TDecimal *);
  270 (* TIdent *);
  271 (* TKRParam *);
  272 (* Tconstructorname *);
  273 (* TypedefIdent *);
  274 (* TOPar *);
  275 (* TCPar *);
  276 (* TOBrace *);
  277 (* TCBrace *);
  278 (* TOCro *);
  279 (* TCCro *);
  280 (* TDot *);
  281 (* TComma *);
  282 (* TPtrOp *);
  283 (* TInc *);
  284 (* TDec *);
  285 (* TAssign *);
  286 (* TEq *);
  287 (* TWhy *);
  288 (* TTilde *);
  289 (* TBang *);
  290 (* TEllipsis *);
  291 (* TDotDot *);
  292 (* TPtVirg *);
  293 (* TOrLog *);
  294 (* TAndLog *);
  295 (* TOr *);
  296 (* TXor *);
  297 (* TAnd *);
  298 (* TEqEq *);
  299 (* TNotEq *);
  300 (* TInf *);
  301 (* TSup *);
  302 (* TInfEq *);
  303 (* TSupEq *);
  304 (* TShl *);
  305 (* TShr *);
  306 (* TPlus *);
  307 (* TMinus *);
  308 (* TMul *);
  309 (* TDiv *);
  310 (* TMod *);
  311 (* TMax *);
  312 (* TMin *);
  313 (* Tchar *);
  314 (* Tshort *);
  315 (* Tint *);
  316 (* Tdouble *);
  317 (* Tfloat *);
  318 (* Tlong *);
  319 (* Tunsigned *);
  320 (* Tsigned *);
  321 (* Tvoid *);
  322 (* Tsize_t *);
  323 (* Tssize_t *);
  324 (* Tptrdiff_t *);
  325 (* Tauto *);
  326 (* Tregister *);
  327 (* Textern *);
  328 (* Tstatic *);
  329 (* Ttypedef *);
  330 (* Tconst *);
  331 (* Tvolatile *);
  332 (* Tstruct *);
  333 (* Tunion *);
  334 (* Tenum *);
  335 (* Tdecimal *);
  336 (* Texec *);
  337 (* Tbreak *);
  338 (* Telse *);
  339 (* Tswitch *);
  340 (* Tcase *);
  341 (* Tcontinue *);
  342 (* Tfor *);
  343 (* Tdo *);
  344 (* Tif *);
  345 (* Twhile *);
  346 (* Treturn *);
  347 (* Tgoto *);
  348 (* Tdefault *);
  349 (* Tsizeof *);
  350 (* Tnew *);
  351 (* Tdelete *);
  352 (* Tdefined *);
  353 (* TOParCplusplusInit *);
  354 (* Tnamespace *);
  355 (* Trestrict *);
  356 (* Tasm *);
  357 (* Tattribute *);
  358 (* TattributeNoarg *);
  359 (* Tinline *);
  360 (* Ttypeof *);
  361 (* TDefine *);
  362 (* TDefParamVariadic *);
  363 (* TCppEscapedNewline *);
  364 (* TCppConcatOp *);
  365 (* TOParDefine *);
  366 (* TOBraceDefineInit *);
  367 (* TIdentDefine *);
  368 (* TDefEOL *);
  369 (* TInclude *);
  370 (* TIncludeStart *);
  371 (* TIncludeFilename *);
  372 (* TIfdef *);
  373 (* TIfdefelif *);
  374 (* TIfdefelse *);
  375 (* TEndif *);
  376 (* TIfdefBool *);
  377 (* TIfdefMisc *);
  378 (* TIfdefVersion *);
  379 (* TUifdef *);
  380 (* TUelseif *);
  381 (* TUendif *);
  382 (* TUndef *);
  383 (* TPragma *);
  384 (* TCppDirectiveOther *);
  385 (* TMacroAttr *);
  386 (* TMacroEndAttr *);
  387 (* TMacroStmt *);
  388 (* TMacroIdentBuilder *);
  389 (* TMacroString *);
  390 (* TMacroDecl *);
  391 (* TMacroDeclConst *);
  392 (* TMacroIterator *);
  393 (* TCommentSkipTagStart *);
  394 (* TCommentSkipTagEnd *);
  395 (* TCParEOL *);
  396 (* TAction *);
  397 (* TCommentMisc *);
  398 (* TCommentCpp *);
    0 (* EOF *);
  399 (* TTODO *);
    0|]

let yylhs = "\255\255\
\001\000\006\000\006\000\006\000\008\000\008\000\009\000\010\000\
\010\000\012\000\012\000\012\000\011\000\011\000\011\000\013\000\
\013\000\004\000\004\000\015\000\015\000\015\000\016\000\016\000\
\018\000\018\000\018\000\018\000\018\000\018\000\018\000\018\000\
\018\000\018\000\018\000\018\000\018\000\018\000\018\000\018\000\
\018\000\018\000\018\000\018\000\018\000\017\000\017\000\020\000\
\020\000\020\000\020\000\020\000\020\000\020\000\020\000\020\000\
\020\000\020\000\020\000\025\000\025\000\025\000\025\000\025\000\
\025\000\024\000\024\000\024\000\024\000\024\000\024\000\024\000\
\023\000\023\000\023\000\023\000\023\000\023\000\023\000\023\000\
\023\000\023\000\028\000\028\000\028\000\028\000\028\000\028\000\
\028\000\028\000\028\000\028\000\028\000\031\000\031\000\035\000\
\035\000\036\000\037\000\037\000\037\000\040\000\040\000\040\000\
\039\000\041\000\044\000\021\000\022\000\003\000\045\000\045\000\
\045\000\045\000\045\000\045\000\045\000\045\000\045\000\045\000\
\046\000\046\000\046\000\046\000\053\000\053\000\055\000\055\000\
\055\000\034\000\057\000\057\000\059\000\059\000\059\000\060\000\
\060\000\060\000\060\000\060\000\047\000\047\000\048\000\048\000\
\048\000\048\000\048\000\049\000\049\000\049\000\049\000\049\000\
\049\000\049\000\049\000\050\000\050\000\050\000\050\000\050\000\
\050\000\032\000\032\000\051\000\051\000\065\000\067\000\067\000\
\067\000\067\000\067\000\052\000\052\000\052\000\052\000\069\000\
\069\000\069\000\069\000\070\000\070\000\068\000\071\000\071\000\
\071\000\071\000\071\000\071\000\071\000\071\000\071\000\071\000\
\071\000\071\000\071\000\071\000\071\000\071\000\071\000\071\000\
\071\000\071\000\071\000\071\000\071\000\071\000\071\000\071\000\
\071\000\071\000\071\000\071\000\071\000\071\000\071\000\071\000\
\071\000\071\000\071\000\071\000\072\000\072\000\072\000\072\000\
\072\000\072\000\072\000\072\000\072\000\072\000\072\000\072\000\
\072\000\072\000\072\000\072\000\072\000\072\000\072\000\027\000\
\075\000\075\000\075\000\076\000\076\000\077\000\077\000\078\000\
\078\000\078\000\078\000\080\000\080\000\079\000\079\000\079\000\
\079\000\079\000\079\000\082\000\083\000\087\000\087\000\087\000\
\088\000\088\000\088\000\088\000\088\000\088\000\088\000\088\000\
\088\000\086\000\086\000\090\000\090\000\090\000\090\000\038\000\
\092\000\092\000\093\000\095\000\095\000\095\000\095\000\096\000\
\081\000\081\000\081\000\081\000\005\000\005\000\097\000\098\000\
\098\000\098\000\098\000\100\000\100\000\100\000\105\000\105\000\
\105\000\105\000\105\000\105\000\105\000\105\000\105\000\105\000\
\104\000\104\000\104\000\104\000\106\000\106\000\054\000\091\000\
\107\000\107\000\107\000\102\000\109\000\108\000\108\000\108\000\
\110\000\110\000\103\000\103\000\103\000\029\000\029\000\114\000\
\114\000\114\000\114\000\114\000\116\000\116\000\116\000\030\000\
\030\000\117\000\117\000\117\000\122\000\122\000\122\000\122\000\
\123\000\123\000\123\000\123\000\123\000\123\000\124\000\124\000\
\126\000\126\000\126\000\127\000\127\000\073\000\118\000\130\000\
\128\000\129\000\120\000\120\000\074\000\074\000\074\000\135\000\
\135\000\136\000\061\000\138\000\138\000\139\000\139\000\137\000\
\137\000\137\000\140\000\141\000\141\000\143\000\143\000\142\000\
\142\000\062\000\062\000\062\000\062\000\062\000\062\000\145\000\
\145\000\145\000\144\000\144\000\144\000\144\000\144\000\144\000\
\144\000\144\000\144\000\144\000\144\000\144\000\148\000\148\000\
\148\000\148\000\148\000\063\000\063\000\063\000\063\000\063\000\
\063\000\063\000\149\000\149\000\149\000\149\000\007\000\007\000\
\002\000\002\000\002\000\002\000\002\000\002\000\002\000\002\000\
\056\000\058\000\132\000\134\000\112\000\113\000\119\000\121\000\
\084\000\085\000\033\000\033\000\064\000\064\000\066\000\066\000\
\026\000\026\000\101\000\101\000\146\000\146\000\131\000\131\000\
\125\000\125\000\125\000\133\000\133\000\133\000\099\000\099\000\
\099\000\089\000\089\000\042\000\042\000\043\000\043\000\014\000\
\014\000\014\000\115\000\115\000\150\000\150\000\094\000\111\000\
\147\000\147\000\019\000\019\000\000\000\000\000\000\000\000\000\
\000\000"

let yylen = "\002\000\
\002\000\000\000\002\000\006\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\003\000\002\000\004\000\001\000\
\003\000\001\000\003\000\001\000\003\000\003\000\001\000\005\000\
\001\000\003\000\003\000\003\000\003\000\003\000\003\000\003\000\
\003\000\003\000\003\000\003\000\003\000\003\000\003\000\003\000\
\003\000\003\000\003\000\003\000\003\000\001\000\004\000\001\000\
\002\000\002\000\002\000\002\000\004\000\002\000\005\000\002\000\
\004\000\002\000\004\000\004\000\003\000\004\000\003\000\001\000\
\004\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\004\000\004\000\003\000\003\000\003\000\002\000\002\000\
\005\000\007\000\001\000\001\000\001\000\001\000\003\000\001\000\
\001\000\003\000\001\000\002\000\003\000\000\000\002\000\002\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\002\000\005\000\006\000\001\000\004\000\
\003\000\004\000\006\000\003\000\001\000\001\000\002\000\003\000\
\002\000\003\000\000\000\001\000\001\000\001\000\002\000\001\000\
\001\000\001\000\001\000\001\000\001\000\002\000\005\000\007\000\
\005\000\009\000\011\000\005\000\007\000\006\000\007\000\006\000\
\007\000\005\000\004\000\002\000\001\000\001\000\001\000\002\000\
\003\000\001\000\001\000\002\000\001\000\002\000\001\000\004\000\
\007\000\001\000\000\000\000\000\004\000\003\000\002\000\000\000\
\003\000\003\000\004\000\000\000\003\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\006\000\004\000\001\000\004\000\004\000\001\000\
\001\000\001\000\001\000\003\000\001\000\002\000\001\000\001\000\
\002\000\002\000\003\000\001\000\001\000\001\000\003\000\003\000\
\004\000\003\000\004\000\001\000\001\000\001\000\001\000\002\000\
\003\000\002\000\003\000\003\000\004\000\002\000\003\000\003\000\
\004\000\001\000\003\000\001\000\002\000\002\000\001\000\001\000\
\001\000\002\000\001\000\001\000\001\000\002\000\002\000\001\000\
\001\000\001\000\002\000\002\000\001\000\002\000\001\000\002\000\
\003\000\006\000\008\000\002\000\001\000\000\000\001\000\001\000\
\001\000\001\000\001\000\002\000\002\000\002\000\002\000\002\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\003\000\004\000\001\000\001\000\001\000\002\000\002\000\
\004\000\005\000\001\000\004\000\002\000\001\000\003\000\001\000\
\004\000\002\000\003\000\003\000\002\000\003\000\005\000\001\000\
\000\000\005\000\004\000\002\000\001\000\001\000\002\000\002\000\
\001\000\001\000\005\000\005\000\001\000\001\000\003\000\002\000\
\001\000\002\000\003\000\001\000\002\000\001\000\001\000\001\000\
\001\000\001\000\001\000\000\000\005\000\006\000\002\000\001\000\
\003\000\001\000\001\000\001\000\002\000\001\000\002\000\002\000\
\003\000\003\000\001\000\002\000\001\000\003\000\004\000\001\000\
\002\000\002\000\004\000\007\000\003\000\004\000\001\000\003\000\
\002\000\001\000\001\000\001\000\001\000\001\000\002\000\002\000\
\001\000\005\000\006\000\004\000\005\000\000\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\005\000\005\000\004\000\002\000\001\000\001\000\
\005\000\001\000\001\000\001\000\001\000\005\000\001\000\001\000\
\001\000\001\000\001\000\001\000\001\000\001\000\001\000\001\000\
\001\000\001\000\001\000\002\000\001\000\002\000\001\000\003\000\
\001\000\003\000\001\000\003\000\001\000\002\000\001\000\002\000\
\001\000\004\000\003\000\001\000\004\000\003\000\001\000\004\000\
\003\000\001\000\003\000\001\000\002\000\000\000\002\000\000\000\
\001\000\003\000\001\000\002\000\001\000\002\000\001\000\001\000\
\001\000\000\000\001\000\000\000\002\000\002\000\002\000\002\000\
\002\000"

let yydefred = "\000\000\
\002\000\000\000\000\000\000\000\000\000\000\000\237\001\000\000\
\007\000\000\000\237\000\183\001\222\000\229\000\223\000\225\000\
\224\000\230\000\232\000\231\000\221\000\226\000\227\000\228\000\
\059\001\060\001\058\001\057\001\062\001\241\000\242\000\000\000\
\000\000\000\000\000\000\000\000\243\000\000\000\000\000\000\000\
\000\000\000\000\000\000\164\001\166\001\165\001\167\001\168\001\
\169\001\170\001\000\000\000\000\143\001\245\000\184\001\238\001\
\178\001\000\000\000\000\176\001\175\001\179\001\181\001\240\000\
\233\000\234\000\000\000\000\000\000\000\063\001\000\000\000\000\
\064\001\000\000\110\001\000\000\111\001\123\001\000\000\131\001\
\133\001\180\001\084\000\085\000\088\000\000\000\000\000\089\000\
\000\000\011\000\000\000\185\001\000\000\000\000\070\000\071\000\
\141\000\072\000\066\000\068\000\069\000\067\000\000\000\158\000\
\000\000\000\000\157\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\119\000\000\000\000\000\000\000\239\001\000\000\083\000\
\000\000\000\000\018\000\020\000\000\000\000\000\046\000\000\000\
\000\000\000\000\073\000\000\000\112\000\110\000\111\000\113\000\
\114\000\115\000\000\000\000\000\000\000\000\000\009\000\241\001\
\000\000\000\000\032\001\000\000\000\000\001\000\003\000\193\001\
\000\000\229\001\095\001\000\000\096\001\005\000\006\000\187\001\
\000\000\000\000\000\000\000\000\000\000\000\000\061\001\055\001\
\000\000\000\000\138\001\000\000\000\000\000\000\174\001\053\001\
\054\001\056\001\000\000\040\001\253\000\252\000\254\000\000\000\
\000\000\000\000\000\000\000\000\069\001\000\000\215\001\132\001\
\000\000\044\001\052\001\191\001\000\000\000\000\128\001\124\001\
\126\001\000\000\000\000\000\000\000\000\097\000\000\000\000\000\
\000\000\000\000\000\000\049\000\000\000\050\000\000\000\000\000\
\107\000\025\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\012\000\156\000\000\000\052\000\000\000\000\000\
\000\000\000\000\000\000\064\000\000\000\056\000\000\000\058\000\
\000\000\000\000\014\000\000\000\000\000\000\000\000\000\142\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\079\000\080\000\051\000\
\162\000\163\000\195\001\000\000\116\000\000\000\000\000\000\000\
\137\000\000\000\136\000\134\000\000\000\132\000\000\000\138\000\
\139\000\140\000\030\001\031\001\000\000\000\000\000\000\000\000\
\039\001\000\000\038\001\000\000\020\001\194\001\218\001\134\001\
\000\000\000\000\024\001\000\000\230\001\000\000\122\001\000\000\
\212\001\000\000\000\000\002\000\000\000\000\000\244\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\141\001\000\000\205\001\000\000\
\000\000\000\000\102\000\103\000\203\001\104\000\106\000\000\000\
\000\000\000\000\232\001\071\001\000\000\000\000\004\001\000\000\
\000\000\033\001\034\001\249\000\000\000\000\000\041\001\068\001\
\000\000\000\000\000\000\000\000\098\001\000\000\000\000\101\001\
\102\001\000\000\000\000\112\001\097\001\207\001\000\000\000\000\
\130\001\125\001\129\001\127\001\098\000\096\000\087\000\095\000\
\016\000\000\000\090\000\093\000\000\000\217\000\218\000\220\000\
\219\000\000\000\214\000\209\000\210\000\207\000\208\000\213\000\
\190\000\191\000\193\000\192\000\211\000\212\000\000\000\201\000\
\200\000\205\000\206\000\204\000\194\000\195\000\199\000\198\000\
\197\000\196\000\203\000\202\000\183\000\184\000\185\000\186\000\
\187\000\189\000\188\000\216\000\215\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\126\000\124\000\125\000\000\000\000\000\000\000\000\000\099\000\
\000\000\201\001\100\000\101\000\105\000\000\000\000\000\000\000\
\000\000\000\000\000\000\159\001\160\001\162\001\163\001\161\001\
\000\000\225\001\000\000\000\000\019\000\121\000\021\000\022\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\026\000\027\000\030\000\029\000\028\000\109\000\000\000\
\076\000\000\000\000\000\077\000\078\000\196\001\000\000\000\000\
\000\000\186\001\130\000\135\000\014\001\000\000\010\001\000\000\
\000\000\000\000\000\000\000\000\002\000\135\001\000\000\000\000\
\000\000\000\000\027\001\021\001\022\001\000\000\000\000\000\000\
\000\000\236\000\000\000\000\000\000\000\000\000\197\001\000\000\
\239\000\238\000\000\000\000\000\000\000\000\000\000\000\189\001\
\000\000\000\000\000\000\080\001\000\000\000\000\078\001\000\000\
\227\001\152\001\151\001\139\001\145\001\000\000\142\001\206\001\
\223\001\000\000\000\000\173\001\255\000\000\000\000\000\005\001\
\000\000\000\001\002\001\000\000\035\001\036\001\251\000\217\001\
\000\000\000\000\075\001\066\001\000\000\000\000\000\000\000\000\
\000\000\113\001\104\001\000\000\000\000\209\001\000\000\000\000\
\192\001\091\001\208\001\072\001\000\000\000\000\000\000\000\000\
\000\000\120\000\175\000\000\000\000\000\122\000\000\000\000\000\
\000\000\000\000\000\000\000\000\061\000\000\000\063\000\000\000\
\221\001\000\000\000\000\000\000\057\000\059\000\000\000\000\000\
\000\000\015\000\000\000\155\000\000\000\000\000\000\000\047\000\
\075\000\074\000\000\000\009\001\011\001\015\001\012\001\000\000\
\016\001\000\000\000\000\019\001\219\001\026\001\000\000\214\001\
\000\000\188\001\117\001\121\001\000\000\177\001\000\000\000\000\
\170\000\000\000\199\001\198\001\182\001\000\000\000\000\000\000\
\000\000\000\000\085\001\000\000\000\000\000\000\190\001\000\000\
\082\001\000\000\228\001\144\001\171\001\172\001\204\001\000\000\
\000\000\001\001\003\001\216\001\067\001\000\000\077\001\000\000\
\090\001\000\000\000\000\109\001\000\000\103\001\000\000\114\001\
\106\001\017\000\000\000\174\000\000\000\000\000\000\000\000\000\
\145\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\148\000\060\000\062\000\000\000\202\001\065\000\117\000\000\000\
\000\000\226\001\154\000\024\000\081\000\000\000\013\001\017\001\
\004\000\118\001\213\001\235\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\086\001\000\000\084\001\079\001\000\000\
\000\000\083\001\073\001\000\000\000\000\042\001\000\000\000\000\
\000\000\211\001\000\000\107\001\181\000\000\000\000\000\000\000\
\173\000\123\000\150\000\000\000\152\000\000\000\000\000\000\000\
\118\000\000\000\000\000\182\000\000\000\000\000\200\001\000\000\
\000\000\140\001\000\000\233\001\154\001\081\001\074\001\076\001\
\000\000\100\001\099\001\210\001\000\000\177\000\178\000\151\000\
\153\000\149\000\144\000\000\000\082\000\168\000\000\000\000\000\
\087\001\043\001\179\000\000\000\000\000\000\000\000\000\146\000\
\000\000\000\000\169\000\147\000"

let yydgoto = "\006\000\
\007\000\056\000\201\001\127\000\152\000\008\000\159\000\051\002\
\127\001\128\000\151\000\130\000\146\001\225\001\131\000\132\000\
\133\000\134\000\234\001\135\000\136\000\000\002\137\000\138\000\
\243\000\209\001\059\000\139\000\053\002\032\002\215\000\140\000\
\077\001\141\000\216\000\142\001\210\001\100\001\212\001\101\001\
\102\001\213\001\103\001\200\002\142\000\143\000\144\000\145\000\
\146\000\147\000\078\001\190\001\202\001\203\001\044\001\148\000\
\045\001\011\002\046\001\047\001\061\000\049\001\050\001\038\002\
\039\002\162\002\163\002\021\003\208\002\104\002\191\001\064\000\
\065\000\066\000\067\000\068\000\136\001\193\000\194\000\195\000\
\117\001\112\001\074\002\056\001\064\001\065\001\014\002\058\001\
\066\001\067\001\068\001\028\002\029\002\163\000\155\000\156\000\
\059\001\070\000\196\000\071\000\104\001\122\001\084\002\175\000\
\073\000\074\000\197\000\198\000\199\000\108\001\109\001\054\002\
\177\002\055\002\056\002\057\002\075\000\076\000\206\000\131\001\
\098\002\077\000\132\001\133\001\093\002\094\002\095\002\096\002\
\201\002\134\001\135\001\170\000\072\001\155\002\073\001\074\001\
\078\000\211\000\212\000\079\000\080\000\200\000\081\000\092\001\
\096\001\097\001\029\003\226\001\082\000\164\000"

let yysindex = "\127\003\
\000\000\071\009\116\016\039\020\061\026\000\000\000\000\145\009\
\000\000\032\255\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\162\255\
\162\255\027\001\118\255\041\255\000\000\137\255\229\255\114\016\
\011\000\220\254\108\255\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\181\255\217\255\000\000\000\000\000\000\000\000\
\000\000\231\255\114\016\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\114\016\114\016\026\002\000\000\168\255\183\255\
\000\000\114\016\000\000\028\001\000\000\000\000\013\025\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\078\255\000\000\
\014\000\000\000\069\018\000\000\039\020\039\020\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\063\000\000\000\
\082\000\039\020\000\000\113\000\116\016\139\000\154\000\039\020\
\157\255\108\000\039\020\007\026\117\018\148\255\047\255\163\000\
\099\000\000\000\174\000\000\000\200\000\000\000\103\255\000\000\
\000\000\168\000\000\000\000\000\061\000\252\005\000\000\061\026\
\219\001\039\020\000\000\039\255\000\000\000\000\000\000\000\000\
\000\000\000\000\222\000\133\015\014\000\203\000\000\000\000\000\
\061\026\061\026\000\000\097\255\246\000\000\000\000\000\000\000\
\087\023\000\000\000\000\162\255\000\000\000\000\000\000\000\000\
\253\000\020\000\039\020\006\001\039\255\036\001\000\000\000\000\
\074\017\241\012\000\000\190\000\048\255\022\012\000\000\000\000\
\000\000\000\000\002\001\000\000\000\000\000\000\000\000\107\255\
\207\255\208\255\068\002\053\000\000\000\023\255\000\000\000\000\
\040\001\000\000\000\000\000\000\063\001\003\022\000\000\000\000\
\000\000\026\002\086\025\107\000\060\001\000\000\098\001\078\255\
\074\001\024\000\110\001\000\000\061\026\000\000\057\027\039\020\
\000\000\000\000\001\001\223\016\068\001\039\020\039\020\203\000\
\014\000\039\020\000\000\000\000\009\016\000\000\061\026\122\001\
\142\001\131\012\153\001\000\000\169\001\000\000\046\255\000\000\
\039\255\185\001\000\000\202\001\092\001\245\009\039\020\000\000\
\009\016\039\020\039\020\039\020\039\020\039\020\039\020\039\020\
\039\020\039\020\039\020\039\020\039\020\039\020\039\020\039\020\
\039\020\039\020\039\020\039\020\039\020\039\020\039\020\039\020\
\174\001\098\010\039\020\020\000\020\000\000\000\000\000\000\000\
\000\000\000\000\000\000\039\255\000\000\000\000\039\020\171\001\
\000\000\197\001\000\000\000\000\227\001\000\000\133\015\000\000\
\000\000\000\000\000\000\000\000\044\001\165\018\201\000\233\023\
\000\000\075\001\000\000\240\001\000\000\000\000\000\000\000\000\
\244\001\246\001\000\000\117\001\000\000\020\000\000\000\249\001\
\000\000\008\002\177\000\000\000\037\255\020\002\000\000\022\002\
\032\002\116\016\055\255\092\001\021\018\000\000\103\255\000\000\
\133\015\000\000\183\001\205\001\000\000\207\010\000\000\210\001\
\213\001\168\001\000\000\000\000\000\000\000\000\000\000\057\255\
\050\002\202\255\000\000\000\000\000\000\208\255\000\000\213\018\
\087\023\000\000\000\000\000\000\068\002\013\002\000\000\000\000\
\022\012\005\019\022\012\003\022\000\000\059\002\061\002\000\000\
\000\000\085\000\063\002\000\000\000\000\000\000\003\022\107\255\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\004\002\000\000\000\000\174\001\000\000\000\000\000\000\
\000\000\084\002\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\046\255\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\079\002\057\027\031\001\
\039\020\009\016\055\019\055\019\106\002\065\001\076\001\203\000\
\000\000\000\000\000\000\174\001\060\011\169\011\241\001\000\000\
\089\001\000\000\000\000\000\000\000\000\039\020\039\020\107\002\
\114\002\039\255\039\020\000\000\000\000\000\000\000\000\000\000\
\103\001\000\000\116\016\129\001\000\000\000\000\000\000\000\000\
\203\000\100\002\045\022\132\005\185\009\009\021\124\021\141\004\
\141\004\133\002\133\002\133\002\133\002\021\003\021\003\139\002\
\139\002\000\000\000\000\000\000\000\000\000\000\000\000\103\019\
\000\000\151\001\179\001\000\000\000\000\000\000\083\001\009\016\
\009\016\000\000\000\000\000\000\000\000\117\002\000\000\115\002\
\075\001\244\001\151\019\087\023\000\000\000\000\160\023\148\005\
\162\255\059\001\000\000\000\000\000\000\249\001\186\004\116\002\
\039\020\000\000\039\020\123\024\192\000\109\002\000\000\110\002\
\000\000\000\000\060\002\039\255\136\002\175\001\014\000\000\000\
\039\020\213\000\120\002\000\000\131\002\181\017\000\000\185\000\
\000\000\000\000\000\000\000\000\000\000\196\001\000\000\000\000\
\000\000\115\255\022\012\000\000\000\000\039\255\141\002\000\000\
\137\002\000\000\000\000\244\001\000\000\000\000\000\000\000\000\
\013\002\204\001\000\000\000\000\181\017\208\001\063\002\022\012\
\022\012\000\000\000\000\162\255\111\000\000\000\126\002\039\020\
\000\000\000\000\000\000\000\000\148\002\144\002\151\002\057\027\
\158\001\000\000\000\000\116\016\135\002\000\000\199\019\247\019\
\039\020\116\016\116\016\144\002\000\000\209\001\000\000\217\001\
\000\000\030\026\022\012\188\001\000\000\000\000\130\002\149\002\
\232\001\000\000\092\001\000\000\116\016\039\020\229\017\000\000\
\000\000\000\000\009\016\000\000\000\000\000\000\000\000\150\002\
\000\000\244\001\196\024\000\000\000\000\000\000\116\002\000\000\
\186\004\000\000\000\000\000\000\152\002\000\000\154\002\063\000\
\000\000\171\002\000\000\000\000\000\000\157\002\158\002\039\255\
\001\015\125\000\000\000\021\018\021\018\155\002\000\000\131\002\
\000\000\021\018\000\000\000\000\000\000\000\000\000\000\160\002\
\039\255\000\000\000\000\000\000\000\000\131\002\000\000\104\255\
\000\000\234\001\236\001\000\000\051\001\000\000\039\020\000\000\
\000\000\000\000\084\002\000\000\039\020\184\002\185\002\057\027\
\000\000\009\016\116\016\237\001\116\016\253\001\001\002\118\002\
\000\000\000\000\000\000\153\001\000\000\000\000\000\000\167\002\
\116\016\000\000\000\000\000\000\000\000\131\002\000\000\000\000\
\000\000\000\000\000\000\000\000\039\020\181\002\192\000\039\020\
\130\002\188\002\096\002\000\000\039\020\000\000\000\000\186\002\
\189\002\000\000\000\000\194\002\189\002\000\000\005\019\182\002\
\183\002\000\000\051\001\000\000\000\000\000\002\158\001\158\001\
\000\000\000\000\000\000\116\016\000\000\116\016\205\002\116\016\
\000\000\140\002\200\002\000\000\206\002\025\003\000\000\018\002\
\167\002\000\000\011\003\000\000\000\000\000\000\000\000\000\000\
\000\003\000\000\000\000\000\000\158\001\000\000\000\000\000\000\
\000\000\000\000\000\000\020\001\000\000\000\000\019\003\205\002\
\000\000\000\000\000\000\116\016\116\016\039\020\169\002\000\000\
\023\003\116\016\000\000\000\000"

let yyrindex = "\000\000\
\000\000\162\002\000\000\000\000\000\000\000\000\000\000\162\002\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\058\001\
\062\001\000\000\000\000\000\000\000\000\000\000\000\000\078\020\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\090\020\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\103\020\132\020\000\000\000\000\000\000\181\021\
\000\000\142\020\000\000\000\000\000\000\000\000\162\002\000\000\
\000\000\000\000\000\000\000\000\000\000\191\004\035\003\000\000\
\181\025\000\000\113\026\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\010\003\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\057\005\000\000\000\000\000\000\000\000\
\220\025\000\000\000\000\000\000\168\006\045\004\000\000\000\000\
\176\005\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\035\255\209\002\047\004\000\000\000\000\
\097\000\080\001\000\000\023\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\112\255\000\000\000\000\000\000\000\000\
\202\003\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\182\255\000\000\000\000\000\000\061\255\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\169\022\
\000\000\226\020\187\002\000\000\000\000\135\000\000\000\000\000\
\000\000\000\000\000\000\000\000\069\004\027\003\000\000\000\000\
\000\000\000\000\162\002\000\000\000\000\000\000\000\000\035\003\
\000\000\000\000\000\000\000\000\000\000\000\000\013\003\000\000\
\000\000\000\000\000\000\162\002\000\000\000\000\000\000\015\003\
\234\004\000\000\000\000\000\000\162\002\000\000\000\000\000\000\
\051\002\000\000\223\005\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\092\002\000\000\000\000\000\000\
\162\002\000\000\000\000\020\003\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\097\005\000\000\092\022\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\191\255\000\000\
\000\000\000\000\000\000\000\000\050\024\000\000\026\000\000\000\
\000\000\029\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\040\003\000\000\062\255\000\000\000\000\000\000\039\003\
\000\000\079\001\000\000\000\000\042\003\000\000\000\000\000\000\
\000\000\000\000\000\000\092\002\000\000\117\013\208\002\249\013\
\162\002\125\014\210\002\000\000\000\000\000\000\000\000\000\000\
\212\002\061\255\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\008\023\086\021\000\000\000\000\
\000\000\000\000\000\000\000\000\180\003\000\000\000\000\000\000\
\094\002\000\000\094\002\027\003\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\041\003\082\255\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\083\003\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\201\026\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\013\003\000\000\
\000\000\162\002\000\000\000\000\000\000\000\000\000\000\048\003\
\000\000\000\000\000\000\000\000\000\000\000\000\097\002\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\043\003\000\000\011\002\144\000\123\008\082\008\044\008\232\007\
\014\008\073\007\111\007\153\007\190\007\250\006\031\007\129\006\
\208\006\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\032\000\
\077\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\049\000\000\000\000\000\000\000\000\000\000\000\000\000\050\024\
\080\255\045\255\000\000\000\000\000\000\039\003\064\003\000\000\
\000\000\000\000\000\000\162\002\110\000\067\003\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\109\027\000\000\
\000\000\000\000\000\000\000\000\039\003\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\061\255\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\094\002\
\094\002\000\000\000\000\089\000\000\000\000\000\148\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\013\003\
\001\027\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\046\006\000\000\000\000\000\000\000\000\
\000\000\000\000\094\002\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\183\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\162\002\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\151\000\000\000\
\000\000\203\255\000\000\000\000\000\000\000\000\000\000\000\000\
\182\255\000\000\000\000\000\000\064\003\000\000\000\000\039\003\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\039\003\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\201\026\000\000\000\000\000\000\000\000\013\003\
\000\000\162\002\000\000\000\000\000\000\000\000\000\000\206\008\
\000\000\000\000\000\000\089\006\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\039\003\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\110\000\000\000\
\237\002\000\000\000\000\000\000\000\000\000\000\000\000\238\002\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\001\027\001\027\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\239\002\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\001\027\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\240\002\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000"

let yygindex = "\000\000\
\000\000\000\000\005\000\012\000\191\000\214\254\096\004\243\255\
\001\000\196\255\253\255\170\255\000\000\031\003\190\255\235\000\
\231\000\118\021\000\000\238\000\015\001\198\254\000\000\000\000\
\233\001\091\255\027\000\000\000\019\255\001\254\203\003\120\255\
\024\004\205\255\000\000\000\000\000\000\033\001\000\000\018\254\
\000\000\215\002\069\003\164\255\000\000\000\000\079\255\000\000\
\000\000\000\000\040\255\109\254\056\255\017\000\000\000\000\000\
\000\000\000\000\020\255\095\255\121\255\255\255\018\000\000\000\
\132\002\000\000\186\001\114\001\061\253\225\001\000\000\000\000\
\000\000\000\000\234\008\234\255\192\255\161\255\070\255\000\000\
\000\000\000\000\101\002\248\255\012\255\235\254\171\255\231\254\
\000\000\000\000\004\000\000\000\000\000\238\255\000\000\144\255\
\000\000\000\000\000\000\000\000\181\254\239\001\177\001\016\000\
\034\000\000\000\000\000\000\000\190\254\000\000\037\003\156\254\
\209\253\225\255\000\000\121\002\000\000\000\000\229\003\055\003\
\098\002\000\000\000\000\000\000\000\000\118\253\000\000\086\002\
\247\001\054\003\000\000\023\004\123\003\045\002\005\254\000\000\
\000\000\000\000\177\254\000\000\000\000\000\000\000\000\031\002\
\000\000\000\000\000\000\070\002\000\000\000\000"

let yytablesize = 7333
let yytable = "\129\000\
\062\000\161\000\058\000\035\001\192\000\069\000\110\001\126\000\
\191\000\162\000\162\000\069\000\048\001\227\000\165\000\150\000\
\089\001\072\000\060\000\063\000\169\000\085\002\037\001\072\000\
\060\000\006\001\236\000\207\000\007\001\017\002\151\002\153\000\
\217\001\036\002\018\002\152\002\035\001\191\002\081\002\219\000\
\051\001\052\001\090\001\107\002\033\001\082\002\033\001\086\002\
\008\001\160\000\195\001\080\002\120\001\174\002\172\000\131\000\
\230\001\248\000\002\003\149\000\055\001\042\001\205\000\006\001\
\249\000\094\001\012\002\038\003\039\003\006\001\057\001\037\002\
\044\002\176\000\178\000\066\002\022\002\209\000\075\001\222\001\
\023\001\067\002\210\000\071\001\183\002\222\001\023\001\213\000\
\228\001\214\000\102\002\076\002\184\000\130\001\072\000\208\000\
\028\001\051\003\025\001\116\001\185\000\186\000\218\000\223\000\
\025\001\129\000\070\001\203\000\058\002\235\000\081\001\070\001\
\035\001\229\000\053\001\099\001\002\002\070\001\054\001\121\001\
\036\003\250\000\105\001\232\000\075\002\231\001\191\000\255\000\
\231\001\045\002\231\001\231\001\191\000\120\001\092\000\171\000\
\231\001\189\000\000\001\254\002\221\002\069\001\244\000\044\000\
\129\000\116\002\231\001\231\001\190\000\191\000\181\002\069\000\
\041\001\120\000\173\000\006\002\006\001\235\002\095\001\137\001\
\139\001\149\000\153\000\072\000\043\001\247\000\235\000\048\001\
\046\001\034\001\233\000\034\001\115\001\090\000\129\000\208\001\
\249\002\123\000\070\001\153\000\153\000\091\001\086\001\006\001\
\062\002\113\001\216\001\208\001\229\001\087\001\253\002\231\001\
\232\001\072\000\088\001\068\002\006\002\004\002\005\002\222\001\
\023\001\030\003\007\002\153\000\128\001\032\003\106\001\153\002\
\234\000\048\001\140\001\133\000\204\002\055\001\210\000\208\001\
\042\001\016\002\025\001\070\002\149\000\166\000\179\000\129\001\
\187\000\160\000\072\000\138\001\026\002\111\001\019\003\210\000\
\153\000\129\000\147\002\192\001\107\001\166\000\027\002\071\001\
\210\000\198\001\199\001\072\000\196\001\200\001\174\000\153\000\
\182\000\110\002\231\001\026\002\072\000\129\000\146\002\120\000\
\017\002\128\002\042\001\025\002\210\000\059\002\039\000\191\000\
\120\000\153\000\183\000\130\001\194\002\195\002\188\002\233\001\
\072\000\111\002\112\002\073\002\071\002\079\002\130\001\123\000\
\235\000\235\000\192\000\208\001\177\000\142\002\191\000\145\002\
\123\000\233\000\054\000\180\000\090\000\158\001\003\002\118\002\
\120\002\037\001\147\001\129\000\006\001\201\000\133\000\007\001\
\255\000\020\002\069\000\041\001\129\000\007\001\099\001\083\002\
\099\001\191\000\120\000\046\001\009\003\202\000\072\000\043\001\
\230\001\092\002\235\000\008\001\046\001\191\000\025\001\181\000\
\176\002\008\001\220\000\222\000\009\000\118\001\129\000\029\001\
\226\000\035\001\123\000\167\002\225\000\129\000\043\002\187\002\
\119\001\002\001\003\001\246\000\069\000\041\001\078\002\110\001\
\238\000\127\000\149\000\224\000\109\002\113\001\187\000\190\002\
\072\000\043\001\105\002\221\000\221\000\184\002\028\001\080\001\
\032\001\108\001\028\001\028\001\209\000\003\003\028\001\090\002\
\091\002\217\000\128\001\108\001\108\001\189\000\092\000\120\000\
\171\000\239\000\228\000\028\001\028\001\128\001\171\000\197\002\
\190\000\028\001\208\001\208\001\007\001\129\001\237\000\129\000\
\171\000\226\000\198\002\244\002\028\001\225\000\153\000\123\000\
\129\001\230\002\085\002\149\001\230\000\232\002\245\002\065\001\
\008\001\153\000\044\000\035\001\044\000\046\001\044\000\007\001\
\044\000\167\000\065\001\231\000\105\001\204\001\044\000\167\000\
\251\000\044\000\044\000\044\000\044\000\044\000\144\002\105\001\
\026\002\167\000\252\000\008\001\127\000\035\001\129\000\253\000\
\120\000\063\001\110\002\034\002\156\002\210\000\157\002\159\002\
\071\001\035\002\001\001\128\000\028\001\009\000\049\002\242\002\
\050\002\072\000\046\001\042\000\170\002\160\002\178\002\105\001\
\123\000\254\000\053\001\191\000\043\000\191\000\054\001\129\000\
\252\002\124\002\166\000\255\000\028\001\167\000\129\002\132\002\
\051\000\052\000\053\000\226\000\226\000\226\000\226\000\226\000\
\226\000\226\000\226\000\226\000\226\000\226\000\226\000\226\000\
\226\000\226\000\226\000\226\000\226\000\226\000\226\000\044\000\
\099\001\037\001\162\000\060\001\129\000\129\000\150\002\089\001\
\020\002\010\003\045\000\210\000\210\000\226\000\182\002\149\000\
\168\000\225\000\211\001\187\000\191\000\099\001\099\001\072\000\
\072\000\076\001\044\000\235\000\226\000\209\000\211\001\035\001\
\225\000\090\001\193\001\194\001\171\002\161\002\128\000\069\000\
\166\000\166\000\189\000\167\000\167\000\093\001\168\000\204\000\
\035\001\108\002\237\000\072\000\060\000\190\000\079\001\255\000\
\099\001\123\001\211\001\226\000\046\001\053\001\013\002\052\002\
\149\000\054\001\071\001\228\002\187\000\162\000\141\001\093\001\
\149\000\196\002\093\001\094\001\024\002\093\001\094\001\140\001\
\054\001\094\001\204\000\114\002\189\000\090\002\226\000\145\001\
\063\001\255\000\225\000\189\000\160\000\029\001\115\002\190\000\
\019\002\029\001\029\001\120\001\255\000\029\001\190\000\120\001\
\129\000\220\001\143\001\122\002\221\001\120\000\129\000\129\000\
\209\002\123\002\029\001\029\001\193\001\139\002\216\002\217\002\
\029\001\130\002\212\002\214\002\215\002\222\001\211\001\131\002\
\148\001\129\000\149\000\029\001\092\002\123\000\024\002\129\000\
\191\000\227\002\054\001\205\001\246\002\247\002\210\000\052\003\
\053\003\063\001\250\002\133\002\244\000\235\000\069\000\140\001\
\027\003\123\002\072\000\042\000\197\001\189\000\120\000\206\001\
\238\002\223\001\072\000\060\000\043\000\129\000\120\000\226\000\
\190\000\137\002\020\003\225\000\091\001\086\001\214\001\123\002\
\051\000\052\000\053\000\205\002\087\001\206\002\123\000\207\002\
\072\000\088\001\248\000\029\001\083\002\125\002\123\000\215\001\
\255\001\169\002\092\002\209\000\149\000\224\001\191\000\131\002\
\024\002\138\002\218\001\255\000\054\001\008\002\129\000\129\000\
\008\000\129\000\222\002\029\001\255\000\210\000\180\002\011\003\
\006\003\013\003\188\000\219\001\123\002\129\000\189\002\189\000\
\120\000\072\000\192\002\218\002\067\002\018\003\136\002\009\002\
\067\002\123\002\190\000\219\002\026\001\211\001\211\001\161\002\
\027\001\123\002\028\001\020\003\029\001\030\001\031\001\010\002\
\123\000\226\000\225\002\024\003\000\003\225\000\001\003\012\003\
\255\000\140\001\067\002\021\002\067\002\255\000\062\001\226\000\
\129\000\226\000\129\000\225\000\129\000\225\000\023\002\014\003\
\040\003\031\002\041\003\015\003\043\003\255\000\037\003\226\000\
\255\000\255\000\149\000\225\000\226\000\045\000\187\000\045\000\
\052\002\045\000\120\000\045\000\048\003\033\002\040\002\149\000\
\041\002\045\000\255\000\187\000\045\000\045\000\045\000\045\000\
\129\000\129\000\042\002\098\001\063\001\189\000\129\000\149\002\
\055\003\056\003\123\000\226\000\060\002\188\000\060\003\052\002\
\190\000\063\002\189\000\064\002\069\002\237\000\226\000\237\000\
\237\000\237\000\225\000\237\000\088\002\190\000\089\002\237\000\
\237\000\237\000\013\000\097\002\237\000\237\000\237\000\237\000\
\237\000\237\000\237\000\237\000\237\000\237\000\237\000\237\000\
\237\000\237\000\237\000\237\000\237\000\237\000\237\000\237\000\
\237\000\237\000\237\000\103\002\189\000\226\000\224\001\101\002\
\222\001\052\002\106\002\220\001\224\001\042\000\222\001\190\000\
\120\000\220\001\045\000\113\002\207\001\126\002\043\000\001\000\
\002\000\003\000\004\000\005\000\127\002\120\000\134\002\140\002\
\154\002\141\002\051\000\052\000\053\000\030\000\031\000\037\002\
\123\000\165\002\226\000\226\000\166\002\045\000\052\002\052\002\
\226\000\168\002\172\002\173\002\052\002\123\000\185\002\072\002\
\090\002\202\002\237\000\135\002\203\002\223\002\037\000\224\002\
\039\000\210\002\236\002\237\002\231\002\226\000\240\002\248\002\
\241\002\225\000\251\002\250\000\016\001\017\001\018\001\019\001\
\020\001\021\001\022\001\023\001\024\001\237\000\020\001\021\001\
\022\001\023\001\024\001\239\002\054\000\007\003\008\003\016\003\
\248\000\119\001\017\003\022\003\248\000\248\000\025\003\026\003\
\248\000\175\002\028\003\248\000\031\003\008\000\008\000\008\000\
\008\000\034\003\035\003\226\000\045\003\044\003\008\000\225\000\
\046\003\008\000\008\000\008\000\008\000\008\000\008\000\008\000\
\008\000\008\000\008\000\008\000\008\000\008\000\008\000\008\000\
\042\003\008\000\008\000\008\000\008\000\008\000\008\000\008\000\
\008\000\008\000\008\000\008\000\008\000\008\000\008\000\008\000\
\008\000\008\000\008\000\008\000\008\000\008\000\008\000\008\000\
\008\000\008\000\008\000\008\000\008\000\008\000\008\000\008\000\
\008\000\008\000\008\000\008\000\008\000\008\000\008\000\008\000\
\008\000\008\000\008\000\008\000\008\000\008\000\008\000\008\000\
\047\003\049\003\008\000\050\003\054\003\058\003\248\000\046\001\
\008\000\059\003\248\000\094\000\023\000\159\000\240\001\116\001\
\172\000\008\000\160\000\008\000\008\000\008\000\236\001\008\000\
\008\000\008\000\018\001\089\001\165\000\115\001\248\000\147\001\
\008\000\150\001\008\000\146\001\092\001\248\000\018\001\019\001\
\020\001\021\001\022\001\023\001\024\001\235\001\008\000\008\000\
\008\000\008\000\008\000\161\000\088\001\164\000\008\000\013\000\
\013\000\013\000\013\000\008\000\156\001\234\001\157\001\155\001\
\013\000\057\000\220\002\013\000\013\000\013\000\013\000\013\000\
\013\000\013\000\013\000\013\000\013\000\013\000\013\000\013\000\
\013\000\013\000\046\002\013\000\013\000\013\000\013\000\013\000\
\013\000\013\000\013\000\013\000\013\000\013\000\013\000\013\000\
\013\000\013\000\013\000\013\000\013\000\013\000\013\000\013\000\
\013\000\013\000\013\000\013\000\013\000\013\000\013\000\013\000\
\013\000\013\000\013\000\013\000\013\000\013\000\013\000\013\000\
\013\000\013\000\013\000\013\000\013\000\013\000\013\000\013\000\
\013\000\013\000\144\001\036\001\013\000\121\002\065\002\057\003\
\023\003\164\002\013\000\005\003\100\002\186\002\255\002\033\003\
\179\002\124\001\087\002\013\000\199\002\013\000\013\000\013\000\
\193\002\013\000\013\000\013\000\099\002\004\003\086\000\070\001\
\030\002\250\000\013\000\234\002\013\000\250\000\250\000\243\002\
\226\002\250\000\000\000\000\000\250\000\000\000\000\000\000\000\
\013\000\013\000\013\000\013\000\013\000\000\000\000\000\119\001\
\013\000\000\000\119\001\119\001\119\001\013\000\119\001\119\001\
\119\001\000\000\119\001\000\000\000\000\000\000\119\001\119\001\
\119\001\010\000\000\000\119\001\119\001\119\001\119\001\119\001\
\119\001\119\001\119\001\119\001\119\001\119\001\119\001\119\001\
\119\001\119\001\119\001\119\001\119\001\119\001\119\001\119\001\
\119\001\119\001\119\001\119\001\119\001\119\001\119\001\119\001\
\119\001\119\001\119\001\119\001\119\001\119\001\119\001\119\001\
\119\001\119\001\119\001\119\001\119\001\119\001\119\001\119\001\
\119\001\000\000\000\000\000\000\000\000\000\000\000\000\250\000\
\000\000\000\000\000\000\250\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\119\001\000\000\119\001\000\000\
\119\001\119\001\000\000\000\000\000\000\119\001\000\000\250\000\
\091\000\119\001\000\000\000\000\000\000\000\000\250\000\023\000\
\000\000\023\000\000\000\023\000\000\000\023\000\000\000\000\000\
\000\000\000\000\119\001\000\000\000\000\119\001\023\000\023\000\
\023\000\000\000\092\001\000\000\119\001\092\001\092\001\092\001\
\000\000\092\001\092\001\092\001\000\000\092\001\000\000\000\000\
\092\000\092\001\092\001\092\001\000\000\000\000\092\001\092\001\
\092\001\092\001\092\001\092\001\092\001\092\001\092\001\092\001\
\092\001\092\001\092\001\092\001\092\001\092\001\092\001\092\001\
\092\001\092\001\092\001\092\001\092\001\092\001\092\001\092\001\
\092\001\092\001\092\001\092\001\092\001\092\001\092\001\092\001\
\092\001\092\001\092\001\092\001\092\001\092\001\092\001\092\001\
\092\001\092\001\092\001\092\001\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\023\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\092\001\
\000\000\092\001\000\000\092\001\092\001\000\000\000\000\048\000\
\092\001\000\000\000\000\000\000\092\001\000\000\000\000\023\000\
\012\001\013\001\014\001\015\001\016\001\017\001\018\001\019\001\
\020\001\021\001\022\001\023\001\024\001\092\001\162\000\233\000\
\092\001\000\000\090\000\000\000\000\000\000\000\000\000\092\001\
\086\000\086\000\000\000\086\000\086\000\086\000\086\000\086\000\
\086\000\086\000\086\000\086\000\086\000\086\000\054\000\000\000\
\086\000\086\000\086\000\086\000\086\000\086\000\086\000\086\000\
\086\000\086\000\086\000\086\000\086\000\086\000\086\000\086\000\
\086\000\086\000\086\000\086\000\086\000\086\000\086\000\000\000\
\000\000\000\000\000\000\010\000\010\000\000\000\010\000\010\000\
\010\000\010\000\010\000\010\000\010\000\010\000\010\000\010\000\
\010\000\000\000\000\000\010\000\010\000\010\000\010\000\010\000\
\010\000\010\000\010\000\010\000\010\000\010\000\010\000\010\000\
\010\000\010\000\010\000\010\000\010\000\010\000\010\000\010\000\
\010\000\010\000\042\000\000\000\000\000\120\000\000\000\000\000\
\000\000\000\000\000\000\043\000\000\000\053\000\086\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\051\000\
\052\000\053\000\000\000\000\000\000\000\123\000\000\000\000\000\
\163\000\000\000\000\000\162\000\000\000\000\000\000\000\000\000\
\000\000\086\000\091\000\091\000\000\000\091\000\091\000\091\000\
\091\000\091\000\091\000\091\000\091\000\091\000\091\000\091\000\
\055\000\010\000\091\000\091\000\091\000\091\000\091\000\091\000\
\091\000\091\000\091\000\091\000\091\000\091\000\091\000\091\000\
\091\000\091\000\091\000\091\000\091\000\091\000\091\000\091\000\
\091\000\000\000\092\000\092\000\010\000\092\000\092\000\092\000\
\092\000\092\000\092\000\092\000\092\000\092\000\092\000\092\000\
\031\000\000\000\092\000\092\000\092\000\092\000\092\000\092\000\
\092\000\092\000\092\000\092\000\092\000\092\000\092\000\092\000\
\092\000\092\000\092\000\092\000\092\000\092\000\092\000\092\000\
\092\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\149\000\000\000\000\000\000\000\024\002\013\002\025\000\
\091\000\054\001\007\001\008\001\009\001\010\001\011\001\012\001\
\013\001\014\001\015\001\016\001\017\001\018\001\019\001\020\001\
\021\001\022\001\023\001\024\001\189\000\163\000\000\000\000\000\
\000\000\000\000\048\000\091\000\048\000\000\000\048\000\190\000\
\048\000\000\000\000\000\000\000\048\000\048\000\048\000\032\000\
\092\000\048\000\048\000\048\000\048\000\048\000\048\000\048\000\
\048\000\048\000\048\000\048\000\048\000\048\000\048\000\048\000\
\048\000\048\000\048\000\048\000\048\000\048\000\048\000\048\000\
\000\000\000\000\000\000\092\000\000\000\000\000\000\000\000\000\
\000\000\054\000\000\000\054\000\000\000\054\000\000\000\054\000\
\000\000\033\000\000\000\054\000\054\000\054\000\000\000\120\000\
\054\000\054\000\054\000\054\000\054\000\054\000\054\000\054\000\
\054\000\054\000\054\000\054\000\054\000\054\000\054\000\054\000\
\054\000\054\000\054\000\054\000\054\000\054\000\054\000\123\000\
\000\000\000\000\004\001\000\000\000\000\000\000\034\000\048\000\
\005\001\006\001\007\001\008\001\009\001\010\001\011\001\012\001\
\013\001\014\001\015\001\016\001\017\001\018\001\019\001\020\001\
\021\001\022\001\023\001\024\001\000\000\000\000\000\000\000\000\
\000\000\000\000\048\000\000\000\000\000\000\000\000\000\000\000\
\053\000\000\000\053\000\000\000\053\000\000\000\053\000\000\000\
\035\000\000\000\053\000\053\000\053\000\000\000\054\000\053\000\
\053\000\053\000\053\000\053\000\053\000\053\000\053\000\053\000\
\053\000\053\000\053\000\053\000\053\000\053\000\053\000\053\000\
\053\000\053\000\053\000\053\000\053\000\053\000\000\000\000\000\
\000\000\054\000\000\000\055\000\000\000\055\000\036\000\055\000\
\000\000\055\000\000\000\000\000\000\000\055\000\055\000\055\000\
\000\000\000\000\055\000\055\000\055\000\055\000\055\000\055\000\
\055\000\055\000\055\000\055\000\055\000\055\000\055\000\055\000\
\055\000\055\000\055\000\055\000\055\000\055\000\055\000\055\000\
\055\000\000\000\000\000\031\000\000\000\031\000\000\000\031\000\
\037\000\031\000\000\000\000\000\000\000\053\000\000\000\031\000\
\000\000\000\000\031\000\031\000\031\000\031\000\031\000\031\000\
\031\000\031\000\031\000\031\000\031\000\031\000\031\000\031\000\
\031\000\031\000\031\000\031\000\000\000\000\000\000\000\000\000\
\053\000\000\000\025\000\000\000\025\000\038\000\025\000\000\000\
\025\000\000\000\000\000\000\000\000\000\000\000\025\000\000\000\
\055\000\025\000\025\000\025\000\025\000\025\000\025\000\025\000\
\025\000\025\000\025\000\025\000\025\000\025\000\025\000\025\000\
\025\000\025\000\025\000\025\000\025\000\025\000\025\000\025\000\
\000\000\000\000\032\000\055\000\032\000\000\000\032\000\039\000\
\032\000\000\000\000\000\000\000\000\000\000\000\032\000\000\000\
\031\000\032\000\032\000\032\000\032\000\032\000\032\000\032\000\
\032\000\032\000\032\000\032\000\032\000\032\000\032\000\032\000\
\032\000\032\000\032\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\031\000\033\000\040\000\033\000\000\000\
\033\000\000\000\033\000\000\000\000\000\000\000\000\000\025\000\
\033\000\000\000\000\000\033\000\033\000\033\000\033\000\033\000\
\033\000\033\000\033\000\033\000\033\000\033\000\033\000\033\000\
\033\000\033\000\033\000\041\000\000\000\000\000\000\000\000\000\
\000\000\034\000\025\000\034\000\000\000\034\000\000\000\034\000\
\000\000\000\000\000\000\000\000\000\000\034\000\000\000\032\000\
\034\000\034\000\034\000\034\000\034\000\034\000\034\000\034\000\
\034\000\034\000\034\000\034\000\034\000\034\000\034\000\034\000\
\000\000\043\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\032\000\035\000\000\000\035\000\000\000\035\000\
\000\000\035\000\000\000\000\000\000\000\000\000\000\000\035\000\
\000\000\033\000\035\000\035\000\035\000\035\000\035\000\035\000\
\035\000\035\000\035\000\035\000\035\000\035\000\035\000\035\000\
\000\000\000\000\042\000\000\000\000\000\000\000\000\000\000\000\
\000\000\036\000\000\000\036\000\033\000\036\000\000\000\036\000\
\000\000\000\000\000\000\000\000\000\000\036\000\034\000\000\000\
\036\000\036\000\036\000\036\000\036\000\036\000\036\000\036\000\
\036\000\036\000\036\000\036\000\036\000\036\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\034\000\000\000\037\000\000\000\037\000\000\000\037\000\
\000\000\037\000\000\000\000\000\000\000\000\000\000\000\037\000\
\035\000\000\000\037\000\037\000\037\000\037\000\037\000\037\000\
\037\000\037\000\037\000\037\000\037\000\037\000\037\000\037\000\
\000\000\000\000\000\000\000\000\000\000\143\000\000\000\000\000\
\038\000\000\000\038\000\035\000\038\000\000\000\038\000\000\000\
\000\000\000\000\000\000\000\000\038\000\000\000\036\000\038\000\
\038\000\038\000\038\000\038\000\038\000\038\000\038\000\038\000\
\038\000\038\000\038\000\038\000\038\000\000\000\154\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\036\000\039\000\000\000\039\000\000\000\039\000\000\000\
\039\000\000\000\000\000\000\000\000\000\000\000\039\000\000\000\
\037\000\039\000\039\000\039\000\039\000\039\000\039\000\039\000\
\039\000\039\000\039\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\040\000\000\000\040\000\037\000\040\000\000\000\040\000\000\000\
\000\000\000\000\000\000\000\000\040\000\038\000\000\000\040\000\
\040\000\040\000\040\000\040\000\040\000\040\000\040\000\040\000\
\040\000\000\000\000\000\000\000\000\000\000\000\041\000\000\000\
\041\000\000\000\041\000\000\000\041\000\000\000\055\000\000\000\
\038\000\000\000\041\000\000\000\000\000\041\000\041\000\041\000\
\041\000\041\000\041\000\041\000\041\000\000\000\000\000\039\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\043\000\000\000\043\000\000\000\
\043\000\000\000\043\000\000\000\000\000\000\000\000\000\000\000\
\043\000\154\000\039\000\043\000\043\000\043\000\043\000\043\000\
\043\000\043\000\000\000\000\000\000\000\040\000\000\000\000\000\
\000\000\000\000\154\000\154\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\042\000\000\000\042\000\
\158\000\042\000\000\000\042\000\000\000\000\000\000\000\000\000\
\040\000\042\000\154\000\041\000\042\000\042\000\042\000\042\000\
\042\000\042\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\114\001\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\041\000\154\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\043\000\000\000\000\000\000\000\000\000\154\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\143\000\143\000\143\000\143\000\143\000\000\000\
\154\000\000\000\143\000\143\000\043\000\143\000\143\000\143\000\
\000\000\143\000\143\000\000\000\000\000\000\000\000\000\000\000\
\143\000\143\000\042\000\000\000\000\000\143\000\143\000\000\000\
\000\000\143\000\000\000\143\000\000\000\000\000\143\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\143\000\
\143\000\143\000\000\000\000\000\000\000\042\000\143\000\143\000\
\143\000\143\000\143\000\143\000\143\000\143\000\143\000\143\000\
\143\000\143\000\143\000\143\000\143\000\143\000\143\000\143\000\
\143\000\143\000\143\000\143\000\143\000\143\000\143\000\000\000\
\143\000\143\000\143\000\143\000\143\000\143\000\143\000\143\000\
\143\000\143\000\143\000\143\000\143\000\143\000\000\000\000\000\
\143\000\143\000\143\000\000\000\143\000\143\000\143\000\000\000\
\000\000\143\000\000\000\000\000\000\000\143\000\000\000\143\000\
\000\000\143\000\143\000\143\000\143\000\143\000\143\000\143\000\
\143\000\000\000\143\000\143\000\143\000\143\000\143\000\000\000\
\143\000\143\000\143\000\143\000\009\000\143\000\010\000\011\000\
\000\000\000\000\000\000\000\000\000\000\000\000\077\002\000\000\
\000\000\000\000\000\000\000\000\000\000\154\000\000\000\000\000\
\000\000\000\000\012\000\000\000\000\000\000\000\000\000\000\000\
\154\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\013\000\
\014\000\015\000\016\000\017\000\018\000\019\000\020\000\021\000\
\022\000\023\000\024\000\025\000\026\000\027\000\028\000\029\000\
\030\000\031\000\032\000\033\000\034\000\035\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\010\000\011\000\000\000\000\000\000\000\000\000\000\000\000\000\
\036\000\037\000\038\000\039\000\000\000\040\000\041\000\042\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\043\000\000\000\044\000\045\000\046\000\047\000\048\000\049\000\
\050\000\000\000\000\000\000\000\051\000\052\000\053\000\054\000\
\000\000\013\000\014\000\015\000\016\000\017\000\018\000\019\000\
\020\000\021\000\022\000\023\000\024\000\025\000\026\000\027\000\
\028\000\029\000\030\000\031\000\032\000\033\000\034\000\035\000\
\008\001\009\001\010\001\011\001\012\001\013\001\014\001\015\001\
\016\001\017\001\018\001\019\001\020\001\021\001\022\001\023\001\
\024\001\000\000\157\000\037\000\000\000\039\000\000\000\040\000\
\041\000\083\000\084\000\085\000\086\000\087\000\000\000\000\000\
\000\000\088\000\149\000\061\001\000\000\011\000\091\000\227\001\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\093\000\
\094\000\054\000\000\000\000\000\095\000\096\000\000\000\000\000\
\000\000\000\000\098\000\000\000\000\000\099\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\100\000\101\000\
\102\000\000\000\000\000\000\000\000\000\013\000\014\000\015\000\
\016\000\017\000\018\000\019\000\020\000\021\000\022\000\023\000\
\024\000\025\000\026\000\027\000\028\000\029\000\030\000\031\000\
\032\000\033\000\034\000\035\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\115\000\116\000\117\000\118\000\000\000\000\000\037\000\
\000\000\039\000\000\000\040\000\041\000\000\000\000\000\000\000\
\120\000\000\000\000\000\000\000\000\000\000\000\083\000\084\000\
\085\000\086\000\087\000\000\000\000\000\000\000\088\000\149\000\
\061\001\000\000\011\000\091\000\001\002\054\000\000\000\000\000\
\123\000\124\000\000\000\000\000\093\000\094\000\000\000\000\000\
\207\001\095\000\096\000\000\000\000\000\000\000\000\000\098\000\
\000\000\000\000\099\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\100\000\101\000\102\000\000\000\000\000\
\000\000\000\000\013\000\014\000\015\000\016\000\017\000\018\000\
\019\000\020\000\021\000\022\000\023\000\024\000\025\000\026\000\
\027\000\028\000\029\000\030\000\031\000\032\000\033\000\034\000\
\035\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\115\000\116\000\
\117\000\118\000\000\000\000\000\037\000\000\000\039\000\000\000\
\040\000\041\000\000\000\000\000\000\000\120\000\000\000\000\000\
\000\000\000\000\000\000\083\000\084\000\085\000\086\000\087\000\
\000\000\000\000\000\000\088\000\149\000\061\001\000\000\011\000\
\091\000\061\002\054\000\000\000\000\000\123\000\124\000\000\000\
\000\000\093\000\094\000\000\000\000\000\207\001\095\000\096\000\
\000\000\000\000\000\000\000\000\098\000\000\000\000\000\099\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\100\000\101\000\102\000\000\000\000\000\000\000\000\000\013\000\
\014\000\015\000\016\000\017\000\018\000\019\000\020\000\021\000\
\022\000\023\000\024\000\025\000\026\000\027\000\028\000\029\000\
\030\000\031\000\032\000\033\000\034\000\035\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\115\000\116\000\117\000\118\000\000\000\
\000\000\037\000\000\000\039\000\000\000\040\000\041\000\000\000\
\000\000\000\000\120\000\000\000\000\000\000\000\000\000\000\000\
\083\000\084\000\085\000\086\000\087\000\000\000\000\000\000\000\
\088\000\149\000\061\001\000\000\011\000\091\000\117\002\054\000\
\000\000\000\000\123\000\124\000\000\000\000\000\093\000\094\000\
\000\000\000\000\207\001\095\000\096\000\000\000\000\000\000\000\
\000\000\098\000\000\000\000\000\099\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\100\000\101\000\102\000\
\000\000\000\000\000\000\000\000\013\000\014\000\015\000\016\000\
\017\000\018\000\019\000\020\000\021\000\022\000\023\000\024\000\
\025\000\026\000\027\000\028\000\029\000\030\000\031\000\032\000\
\033\000\034\000\035\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\115\000\116\000\117\000\118\000\000\000\000\000\037\000\000\000\
\039\000\000\000\040\000\041\000\000\000\000\000\000\000\120\000\
\000\000\000\000\000\000\000\000\000\000\083\000\084\000\085\000\
\086\000\087\000\000\000\000\000\000\000\088\000\149\000\061\001\
\000\000\011\000\091\000\119\002\054\000\000\000\000\000\123\000\
\124\000\000\000\000\000\093\000\094\000\000\000\000\000\207\001\
\095\000\096\000\000\000\000\000\000\000\000\000\098\000\000\000\
\000\000\099\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\100\000\101\000\102\000\000\000\000\000\000\000\
\000\000\013\000\014\000\015\000\016\000\017\000\018\000\019\000\
\020\000\021\000\022\000\023\000\024\000\025\000\026\000\027\000\
\028\000\029\000\030\000\031\000\032\000\033\000\034\000\035\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\115\000\116\000\117\000\
\118\000\000\000\000\000\037\000\000\000\039\000\000\000\040\000\
\041\000\000\000\000\000\000\000\120\000\000\000\000\000\000\000\
\000\000\000\000\083\000\084\000\085\000\086\000\087\000\000\000\
\000\000\000\000\088\000\149\000\061\001\000\000\011\000\091\000\
\000\000\054\000\000\000\000\000\123\000\124\000\000\000\000\000\
\093\000\094\000\000\000\000\000\207\001\095\000\096\000\000\000\
\000\000\000\000\000\000\098\000\000\000\000\000\099\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\100\000\
\101\000\102\000\000\000\000\000\000\000\000\000\013\000\014\000\
\015\000\016\000\017\000\018\000\019\000\020\000\021\000\022\000\
\023\000\024\000\025\000\026\000\027\000\028\000\029\000\030\000\
\031\000\032\000\033\000\034\000\035\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\115\000\116\000\117\000\118\000\000\000\000\000\
\037\000\000\000\039\000\000\000\040\000\041\000\000\000\000\000\
\000\000\120\000\000\000\000\000\000\000\000\000\000\000\083\000\
\084\000\085\000\086\000\087\000\000\000\000\000\000\000\088\000\
\149\000\061\001\000\000\011\000\091\000\000\000\054\000\000\000\
\000\000\123\000\124\000\000\000\000\000\093\000\094\000\000\000\
\000\000\098\001\095\000\096\000\000\000\000\000\000\000\000\000\
\098\000\000\000\000\000\099\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\100\000\101\000\102\000\000\000\
\000\000\000\000\000\000\013\000\014\000\015\000\016\000\017\000\
\018\000\019\000\020\000\021\000\022\000\023\000\024\000\025\000\
\026\000\027\000\028\000\029\000\030\000\031\000\032\000\033\000\
\034\000\035\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\115\000\
\116\000\117\000\118\000\000\000\000\000\037\000\000\000\039\000\
\000\000\040\000\041\000\000\000\000\000\000\000\120\000\000\000\
\000\000\000\000\000\000\000\000\000\000\083\000\084\000\085\000\
\086\000\087\000\000\000\000\000\000\000\088\000\089\000\000\000\
\010\000\038\001\091\000\054\000\092\000\000\000\123\000\124\000\
\000\000\000\000\000\000\093\000\094\000\000\000\207\001\000\000\
\095\000\096\000\000\000\000\000\097\000\000\000\098\000\000\000\
\000\000\099\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\100\000\101\000\102\000\000\000\000\000\000\000\
\000\000\013\000\014\000\015\000\016\000\017\000\018\000\019\000\
\020\000\021\000\022\000\023\000\024\000\025\000\026\000\027\000\
\028\000\029\000\030\000\031\000\032\000\033\000\034\000\035\000\
\103\000\104\000\000\000\105\000\106\000\107\000\108\000\082\001\
\110\000\111\000\112\000\113\000\114\000\115\000\116\000\117\000\
\118\000\000\000\000\000\037\000\083\001\039\000\000\000\040\000\
\041\000\042\000\000\000\000\000\120\000\084\001\085\001\000\000\
\000\000\000\000\043\000\000\000\044\000\045\000\046\000\047\000\
\048\000\049\000\050\000\121\000\000\000\000\000\051\000\052\000\
\053\000\054\000\000\000\122\000\123\000\124\000\000\000\000\000\
\125\000\137\000\137\000\137\000\137\000\137\000\000\000\000\000\
\000\000\137\000\137\000\000\000\137\000\137\000\137\000\000\000\
\137\000\000\000\000\000\000\000\000\000\000\000\000\000\137\000\
\137\000\000\000\000\000\000\000\137\000\137\000\000\000\000\000\
\137\000\000\000\137\000\000\000\000\000\137\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\137\000\137\000\
\137\000\000\000\000\000\000\000\000\000\137\000\137\000\137\000\
\137\000\137\000\137\000\137\000\137\000\137\000\137\000\137\000\
\137\000\137\000\137\000\137\000\137\000\137\000\137\000\137\000\
\137\000\137\000\137\000\137\000\137\000\137\000\000\000\137\000\
\137\000\137\000\137\000\137\000\137\000\137\000\137\000\137\000\
\137\000\137\000\137\000\137\000\137\000\000\000\000\000\137\000\
\137\000\137\000\000\000\137\000\137\000\137\000\000\000\000\000\
\137\000\000\000\000\000\000\000\148\001\000\000\137\000\000\000\
\137\000\137\000\137\000\137\000\137\000\137\000\137\000\137\000\
\000\000\000\000\137\000\137\000\137\000\137\000\000\000\137\000\
\137\000\137\000\137\000\000\000\137\000\136\000\136\000\136\000\
\136\000\136\000\000\000\000\000\000\000\136\000\136\000\000\000\
\136\000\136\000\136\000\000\000\136\000\000\000\000\000\000\000\
\000\000\000\000\000\000\136\000\136\000\000\000\000\000\000\000\
\136\000\136\000\000\000\000\000\136\000\000\000\136\000\000\000\
\000\000\136\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\136\000\136\000\136\000\000\000\000\000\000\000\
\000\000\136\000\136\000\136\000\136\000\136\000\136\000\136\000\
\136\000\136\000\136\000\136\000\136\000\136\000\136\000\136\000\
\136\000\136\000\136\000\136\000\136\000\136\000\136\000\136\000\
\136\000\136\000\000\000\136\000\136\000\136\000\136\000\136\000\
\136\000\136\000\136\000\136\000\136\000\136\000\136\000\136\000\
\136\000\000\000\000\000\136\000\136\000\136\000\000\000\136\000\
\136\000\136\000\000\000\000\000\136\000\000\000\000\000\000\000\
\149\001\000\000\136\000\000\000\136\000\136\000\136\000\136\000\
\136\000\136\000\136\000\136\000\000\000\000\000\136\000\136\000\
\136\000\136\000\000\000\136\000\136\000\136\000\136\000\000\000\
\136\000\138\000\138\000\138\000\138\000\138\000\000\000\000\000\
\000\000\138\000\138\000\000\000\138\000\138\000\138\000\000\000\
\138\000\000\000\000\000\000\000\000\000\000\000\000\000\138\000\
\138\000\000\000\000\000\000\000\138\000\138\000\000\000\000\000\
\138\000\000\000\138\000\000\000\000\000\138\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\138\000\138\000\
\138\000\000\000\000\000\000\000\000\000\138\000\138\000\138\000\
\138\000\138\000\138\000\138\000\138\000\138\000\138\000\138\000\
\138\000\138\000\138\000\138\000\138\000\138\000\138\000\138\000\
\138\000\138\000\138\000\138\000\138\000\138\000\000\000\138\000\
\138\000\138\000\138\000\138\000\138\000\138\000\138\000\138\000\
\138\000\138\000\138\000\138\000\138\000\000\000\000\000\138\000\
\138\000\138\000\000\000\138\000\138\000\138\000\000\000\000\000\
\138\000\000\000\000\000\000\000\153\001\000\000\138\000\000\000\
\138\000\138\000\138\000\138\000\138\000\138\000\138\000\138\000\
\000\000\000\000\138\000\138\000\138\000\138\000\000\000\138\000\
\138\000\138\000\138\000\000\000\138\000\083\000\084\000\085\000\
\086\000\087\000\000\000\000\000\000\000\088\000\089\000\000\000\
\010\000\038\001\091\000\000\000\092\000\000\000\000\000\000\000\
\000\000\000\000\000\000\093\000\094\000\000\000\000\000\000\000\
\095\000\096\000\000\000\000\000\097\000\000\000\098\000\000\000\
\000\000\099\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\100\000\101\000\102\000\000\000\000\000\000\000\
\000\000\013\000\014\000\015\000\016\000\017\000\018\000\019\000\
\020\000\021\000\022\000\023\000\024\000\025\000\026\000\027\000\
\028\000\029\000\030\000\031\000\032\000\033\000\034\000\035\000\
\103\000\104\000\000\000\105\000\106\000\107\000\108\000\082\001\
\110\000\111\000\112\000\113\000\114\000\115\000\116\000\117\000\
\118\000\000\000\000\000\037\000\083\001\039\000\000\000\040\000\
\041\000\042\000\000\000\000\000\120\000\000\000\085\001\000\000\
\000\000\000\000\043\000\000\000\044\000\045\000\046\000\047\000\
\048\000\049\000\050\000\121\000\000\000\000\000\051\000\052\000\
\053\000\054\000\000\000\122\000\123\000\124\000\000\000\000\000\
\125\000\083\000\084\000\085\000\086\000\087\000\000\000\000\000\
\000\000\088\000\089\000\000\000\010\000\038\001\091\000\000\000\
\092\000\000\000\000\000\000\000\000\000\000\000\000\000\093\000\
\094\000\000\000\000\000\000\000\095\000\096\000\000\000\000\000\
\097\000\000\000\098\000\000\000\000\000\099\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\100\000\101\000\
\102\000\000\000\000\000\000\000\000\000\013\000\014\000\015\000\
\016\000\017\000\018\000\019\000\020\000\021\000\022\000\023\000\
\024\000\025\000\026\000\027\000\028\000\029\000\030\000\031\000\
\032\000\033\000\034\000\035\000\103\000\104\000\000\000\105\000\
\039\001\107\000\108\000\109\000\110\000\111\000\112\000\113\000\
\040\001\115\000\116\000\117\000\118\000\000\000\000\000\037\000\
\119\000\039\000\000\000\040\000\041\000\042\000\000\000\000\000\
\120\000\000\000\000\000\000\000\000\000\000\000\043\000\000\000\
\044\000\045\000\046\000\047\000\048\000\049\000\050\000\121\000\
\000\000\000\000\051\000\052\000\053\000\054\000\000\000\122\000\
\123\000\124\000\000\000\000\000\125\000\083\000\084\000\085\000\
\086\000\087\000\000\000\000\000\000\000\088\000\089\000\000\000\
\000\000\038\001\091\000\000\000\092\000\000\000\000\000\000\000\
\000\000\000\000\000\000\093\000\094\000\000\000\000\000\000\000\
\095\000\096\000\000\000\000\000\097\000\000\000\098\000\000\000\
\000\000\099\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\100\000\101\000\102\000\000\000\000\000\000\000\
\000\000\013\000\014\000\015\000\016\000\017\000\018\000\019\000\
\020\000\021\000\022\000\023\000\024\000\025\000\026\000\027\000\
\028\000\029\000\030\000\031\000\032\000\033\000\034\000\035\000\
\103\000\104\000\000\000\105\000\106\000\107\000\108\000\109\000\
\110\000\111\000\112\000\113\000\114\000\115\000\116\000\117\000\
\118\000\000\000\000\000\037\000\119\000\039\000\000\000\040\000\
\041\000\000\000\000\000\000\000\120\000\000\000\000\000\000\000\
\083\000\084\000\085\000\086\000\087\000\000\000\000\000\000\000\
\088\000\089\000\011\000\121\000\090\000\091\000\000\000\092\000\
\000\000\054\000\000\000\122\000\123\000\124\000\093\000\094\000\
\125\000\000\000\000\000\095\000\096\000\000\000\000\000\097\000\
\000\000\098\000\000\000\000\000\099\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\100\000\101\000\102\000\
\000\000\000\000\013\000\014\000\015\000\016\000\017\000\018\000\
\019\000\020\000\021\000\022\000\023\000\024\000\025\000\026\000\
\027\000\028\000\029\000\030\000\031\000\032\000\033\000\034\000\
\035\000\000\000\000\000\103\000\104\000\000\000\105\000\106\000\
\107\000\108\000\109\000\110\000\111\000\112\000\113\000\114\000\
\115\000\116\000\117\000\118\000\037\000\000\000\039\000\119\000\
\040\000\041\000\000\000\000\000\000\000\000\000\000\000\120\000\
\000\000\000\000\000\000\083\000\084\000\085\000\086\000\087\000\
\000\000\000\000\000\000\088\000\149\000\000\000\121\000\011\000\
\091\000\000\000\054\000\000\000\000\000\000\000\122\000\123\000\
\124\000\093\000\094\000\125\000\000\000\000\000\095\000\096\000\
\000\000\000\000\097\000\000\000\098\000\000\000\000\000\099\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\100\000\101\000\102\000\000\000\000\000\000\000\000\000\013\000\
\014\000\015\000\016\000\017\000\018\000\019\000\020\000\021\000\
\022\000\023\000\024\000\025\000\026\000\027\000\028\000\029\000\
\030\000\031\000\032\000\033\000\034\000\035\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\115\000\116\000\117\000\118\000\000\000\
\000\000\037\000\000\000\039\000\000\000\040\000\041\000\000\000\
\000\000\000\000\120\000\000\000\000\000\000\000\083\000\084\000\
\085\000\086\000\087\000\000\000\000\000\000\000\088\000\149\000\
\000\000\000\000\011\000\091\000\000\000\000\000\000\000\054\000\
\000\000\000\000\123\000\124\000\093\000\094\000\000\000\000\000\
\000\000\095\000\096\000\000\000\000\000\000\000\000\000\098\000\
\000\000\000\000\099\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\100\000\101\000\102\000\000\000\000\000\
\000\000\000\000\013\000\014\000\015\000\016\000\017\000\018\000\
\019\000\020\000\021\000\022\000\023\000\024\000\000\000\000\000\
\000\000\000\000\000\000\030\000\031\000\032\000\033\000\034\000\
\035\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\115\000\116\000\
\117\000\118\000\000\000\000\000\037\000\000\000\000\000\000\000\
\000\000\041\000\000\000\000\000\000\000\120\000\000\000\000\000\
\000\000\083\000\084\000\085\000\086\000\087\000\000\000\000\000\
\000\000\088\000\047\002\000\000\000\000\167\000\091\000\000\000\
\048\002\175\002\049\002\000\000\050\002\123\000\124\000\093\000\
\094\000\000\000\000\000\000\000\095\000\096\000\000\000\000\000\
\000\000\000\000\098\000\000\000\000\000\099\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\100\000\101\000\
\102\000\083\000\084\000\085\000\086\000\087\000\000\000\000\000\
\000\000\088\000\047\002\000\000\000\000\167\000\091\000\000\000\
\048\002\229\002\049\002\000\000\050\002\000\000\000\000\093\000\
\094\000\000\000\000\000\000\000\095\000\096\000\000\000\000\000\
\000\000\000\000\098\000\000\000\000\000\099\000\000\000\000\000\
\000\000\115\000\116\000\117\000\118\000\000\000\100\000\101\000\
\102\000\083\000\084\000\085\000\086\000\087\000\000\000\000\000\
\120\000\088\000\047\002\000\000\000\000\167\000\091\000\000\000\
\048\002\000\000\049\002\000\000\050\002\000\000\000\000\093\000\
\094\000\000\000\000\000\000\000\095\000\096\000\000\000\000\000\
\123\000\124\000\098\000\000\000\000\000\099\000\000\000\000\000\
\000\000\115\000\116\000\117\000\118\000\000\000\100\000\101\000\
\102\000\083\000\084\000\085\000\086\000\087\000\000\000\000\000\
\120\000\088\000\149\000\000\000\000\000\000\000\091\000\000\000\
\092\000\000\000\000\000\000\000\000\000\000\000\000\000\093\000\
\094\000\000\000\000\000\000\000\095\000\096\000\000\000\000\000\
\123\000\124\000\098\000\000\000\000\000\099\000\000\000\000\000\
\000\000\115\000\116\000\117\000\118\000\000\000\100\000\101\000\
\102\000\083\000\084\000\085\000\086\000\087\000\000\000\000\000\
\120\000\088\000\149\000\000\000\000\000\000\000\091\000\000\000\
\000\000\000\000\245\000\000\000\000\000\000\000\000\000\093\000\
\094\000\000\000\000\000\000\000\095\000\096\000\000\000\000\000\
\123\000\124\000\098\000\000\000\000\000\099\000\000\000\000\000\
\000\000\115\000\116\000\117\000\118\000\000\000\100\000\101\000\
\102\000\083\000\084\000\085\000\086\000\087\000\000\000\000\000\
\120\000\088\000\149\000\000\000\000\000\000\000\091\000\000\000\
\000\000\000\000\000\000\015\002\000\000\000\000\000\000\093\000\
\094\000\000\000\000\000\000\000\095\000\096\000\000\000\000\000\
\123\000\124\000\098\000\000\000\000\000\099\000\000\000\000\000\
\000\000\115\000\116\000\117\000\118\000\000\000\100\000\101\000\
\102\000\083\000\084\000\085\000\086\000\087\000\000\000\000\000\
\120\000\088\000\149\000\000\000\000\000\000\000\091\000\000\000\
\000\000\000\000\000\000\072\002\000\000\000\000\000\000\093\000\
\094\000\000\000\000\000\000\000\095\000\096\000\000\000\000\000\
\123\000\124\000\098\000\000\000\000\000\099\000\000\000\000\000\
\000\000\115\000\116\000\117\000\118\000\000\000\100\000\101\000\
\102\000\083\000\084\000\085\000\086\000\087\000\000\000\000\000\
\120\000\088\000\149\000\000\000\000\000\000\000\091\000\000\000\
\048\002\000\000\000\000\000\000\000\000\000\000\000\000\093\000\
\094\000\000\000\000\000\000\000\095\000\096\000\000\000\000\000\
\123\000\124\000\098\000\000\000\000\000\099\000\000\000\000\000\
\000\000\115\000\116\000\117\000\118\000\000\000\100\000\101\000\
\102\000\000\000\000\000\083\000\084\000\085\000\086\000\087\000\
\120\000\000\000\000\000\088\000\149\000\000\000\000\000\000\000\
\091\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\093\000\094\000\000\000\000\000\000\000\095\000\096\000\
\123\000\124\000\097\000\000\000\098\000\000\000\000\000\099\000\
\000\000\115\000\116\000\117\000\118\000\000\000\000\000\000\000\
\100\000\101\000\102\000\083\000\084\000\085\000\086\000\087\000\
\120\000\000\000\000\000\088\000\149\000\000\000\000\000\000\000\
\091\000\000\000\135\002\000\000\000\000\000\000\000\000\000\000\
\000\000\093\000\094\000\000\000\000\000\000\000\095\000\096\000\
\123\000\124\000\000\000\000\000\098\000\000\000\000\000\099\000\
\000\000\000\000\000\000\115\000\116\000\117\000\118\000\000\000\
\100\000\101\000\102\000\083\000\084\000\085\000\086\000\087\000\
\000\000\000\000\120\000\088\000\149\000\000\000\000\000\000\000\
\091\000\000\000\000\000\000\000\000\000\143\002\000\000\000\000\
\000\000\093\000\094\000\000\000\000\000\000\000\095\000\096\000\
\000\000\000\000\123\000\124\000\098\000\000\000\000\000\099\000\
\000\000\000\000\000\000\115\000\116\000\117\000\118\000\000\000\
\100\000\101\000\102\000\083\000\084\000\085\000\086\000\087\000\
\000\000\000\000\120\000\088\000\149\000\000\000\000\000\000\000\
\091\000\211\002\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\093\000\094\000\000\000\000\000\000\000\095\000\096\000\
\000\000\000\000\123\000\124\000\098\000\000\000\000\000\099\000\
\000\000\000\000\000\000\115\000\116\000\117\000\118\000\000\000\
\100\000\101\000\102\000\083\000\084\000\085\000\086\000\087\000\
\000\000\000\000\120\000\088\000\149\000\000\000\000\000\000\000\
\091\000\213\002\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\093\000\094\000\000\000\000\000\000\000\095\000\096\000\
\000\000\000\000\123\000\124\000\098\000\000\000\000\000\099\000\
\000\000\000\000\000\000\115\000\116\000\117\000\118\000\000\000\
\100\000\101\000\102\000\083\000\084\000\085\000\086\000\087\000\
\000\000\000\000\120\000\088\000\149\000\000\000\000\000\000\000\
\091\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\093\000\094\000\000\000\000\000\000\000\095\000\096\000\
\000\000\000\000\123\000\124\000\098\000\000\000\000\000\099\000\
\000\000\000\000\000\000\115\000\116\000\117\000\118\000\000\000\
\100\000\101\000\102\000\050\001\000\000\000\000\000\000\050\001\
\050\001\000\000\120\000\050\001\000\000\000\000\050\001\048\001\
\000\000\000\000\000\000\048\001\048\001\000\000\000\000\048\001\
\000\000\050\001\048\001\000\000\049\001\000\000\050\001\000\000\
\049\001\049\001\123\000\124\000\049\001\048\001\000\000\049\001\
\000\000\050\001\048\001\115\000\116\000\117\000\118\000\000\000\
\000\000\000\000\049\001\000\000\000\000\048\001\000\000\049\001\
\000\000\051\001\120\000\000\000\000\000\051\001\051\001\000\000\
\000\000\051\001\049\001\047\001\051\001\000\000\000\000\047\001\
\047\001\000\000\000\000\047\001\000\000\000\000\047\001\051\001\
\000\000\000\000\123\000\124\000\051\001\000\000\000\000\000\000\
\000\000\047\001\000\000\000\000\000\000\000\000\047\001\051\001\
\000\000\050\001\000\000\000\000\000\000\050\001\000\000\000\000\
\000\000\047\001\000\000\000\000\000\000\048\001\000\000\000\000\
\000\000\048\001\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\050\001\049\001\000\000\000\000\000\000\049\001\000\000\
\050\001\000\000\000\000\000\000\000\000\048\001\000\000\000\000\
\000\000\000\000\000\000\000\000\048\001\000\000\000\000\000\000\
\000\000\000\000\049\001\000\000\000\000\000\000\000\000\051\001\
\000\000\049\001\247\000\051\001\247\000\247\000\000\000\000\000\
\000\000\047\001\247\000\000\000\000\000\047\001\000\000\247\000\
\000\000\000\000\000\000\000\000\247\000\247\000\000\000\051\001\
\000\000\000\000\000\000\000\000\000\000\000\000\051\001\000\000\
\000\000\047\001\000\000\000\000\000\000\000\000\000\000\000\000\
\047\001\000\000\247\000\247\000\247\000\247\000\247\000\247\000\
\247\000\247\000\247\000\247\000\247\000\247\000\247\000\247\000\
\247\000\247\000\247\000\247\000\247\000\247\000\247\000\247\000\
\247\000\009\001\010\001\011\001\012\001\013\001\014\001\015\001\
\016\001\017\001\018\001\019\001\020\001\021\001\022\001\023\001\
\024\001\000\000\247\000\000\000\247\000\247\000\247\000\000\000\
\247\000\247\000\247\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\247\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\247\000\
\247\000\247\000\247\000\247\000\000\000\000\000\246\000\247\000\
\246\000\246\000\000\000\000\000\247\000\000\000\246\000\000\000\
\000\000\000\000\000\000\246\000\000\000\000\000\000\000\000\000\
\246\000\246\000\235\001\236\001\237\001\238\001\239\001\240\001\
\241\001\242\001\243\001\244\001\245\001\246\001\247\001\248\001\
\249\001\250\001\251\001\252\001\253\001\254\001\246\000\246\000\
\246\000\246\000\246\000\246\000\246\000\246\000\246\000\246\000\
\246\000\246\000\246\000\246\000\246\000\246\000\246\000\246\000\
\246\000\246\000\246\000\246\000\246\000\010\001\011\001\012\001\
\013\001\014\001\015\001\016\001\017\001\018\001\019\001\020\001\
\021\001\022\001\023\001\024\001\000\000\000\000\246\000\000\000\
\246\000\246\000\246\000\000\000\246\000\246\000\246\000\000\000\
\000\000\000\000\061\001\000\000\000\000\061\001\061\001\246\000\
\000\000\000\000\061\001\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\246\000\246\000\246\000\246\000\246\000\
\061\001\000\000\000\000\246\000\000\000\061\001\000\000\000\000\
\246\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\061\001\000\000\000\000\000\000\000\000\061\001\061\001\061\001\
\061\001\061\001\061\001\061\001\061\001\061\001\061\001\061\001\
\061\001\061\001\061\001\061\001\061\001\061\001\061\001\061\001\
\061\001\061\001\061\001\061\001\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\009\000\000\000\000\000\011\000\000\000\000\000\000\000\061\001\
\000\000\061\001\000\000\061\001\061\001\000\000\000\000\000\000\
\061\001\000\000\000\000\000\000\061\001\000\000\125\001\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\061\001\000\000\000\000\
\061\001\000\000\045\001\013\000\014\000\015\000\016\000\017\000\
\018\000\019\000\020\000\021\000\022\000\023\000\024\000\000\000\
\000\000\000\000\000\000\000\000\030\000\031\000\032\000\033\000\
\034\000\035\000\006\001\007\001\008\001\009\001\010\001\011\001\
\012\001\013\001\014\001\015\001\016\001\017\001\018\001\019\001\
\020\001\021\001\022\001\023\001\024\001\037\000\000\000\000\000\
\000\000\237\000\041\000\042\000\237\000\237\000\000\000\000\000\
\000\000\237\000\000\000\000\000\043\000\000\000\044\000\045\000\
\046\000\047\000\048\000\049\000\050\000\000\000\011\000\237\000\
\051\000\052\000\053\000\000\000\237\000\000\000\000\000\000\000\
\126\001\000\000\000\000\000\000\000\000\000\000\000\000\237\000\
\000\000\000\000\000\000\000\000\237\000\237\000\237\000\237\000\
\237\000\237\000\237\000\237\000\237\000\237\000\237\000\237\000\
\237\000\237\000\237\000\237\000\237\000\237\000\237\000\237\000\
\237\000\237\000\237\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\136\001\000\000\000\000\136\001\000\000\237\000\000\000\
\237\000\070\001\237\000\237\000\000\000\000\000\070\001\237\000\
\000\000\000\000\000\000\237\000\070\001\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\237\000\000\000\000\000\237\000\
\000\000\136\001\136\001\136\001\136\001\136\001\136\001\136\001\
\136\001\136\001\136\001\136\001\136\001\136\001\136\001\136\001\
\136\001\136\001\136\001\136\001\136\001\136\001\136\001\136\001\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\070\001\000\000\136\001\000\000\136\001\000\000\136\001\
\136\001\136\001\000\000\000\000\000\000\000\000\000\000\000\000\
\137\001\000\000\136\001\137\001\000\000\000\000\000\000\000\000\
\072\001\000\000\000\000\000\000\000\000\072\001\136\001\136\001\
\136\001\136\001\000\000\072\001\000\000\000\000\136\001\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\137\001\137\001\137\001\137\001\137\001\137\001\137\001\137\001\
\137\001\137\001\137\001\137\001\137\001\137\001\137\001\137\001\
\137\001\137\001\137\001\137\001\137\001\137\001\137\001\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\061\001\000\000\011\000\
\072\001\062\001\137\001\000\000\137\001\000\000\137\001\137\001\
\137\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\137\001\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\137\001\137\001\137\001\
\137\001\000\000\000\000\000\000\000\000\137\001\000\000\013\000\
\014\000\015\000\016\000\017\000\018\000\019\000\020\000\021\000\
\022\000\023\000\024\000\025\000\026\000\027\000\028\000\029\000\
\030\000\031\000\032\000\033\000\034\000\035\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\061\001\000\000\
\011\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\037\000\000\000\039\000\000\000\040\000\041\000\000\000\
\000\000\148\002\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\054\000\
\013\000\014\000\015\000\016\000\017\000\018\000\019\000\020\000\
\021\000\022\000\023\000\024\000\025\000\026\000\027\000\028\000\
\029\000\030\000\031\000\032\000\033\000\034\000\035\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\061\001\
\000\000\011\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\037\000\000\000\039\000\000\000\040\000\041\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\054\000\013\000\014\000\015\000\016\000\017\000\018\000\019\000\
\020\000\021\000\022\000\023\000\024\000\025\000\026\000\027\000\
\028\000\029\000\030\000\031\000\032\000\033\000\034\000\035\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\193\001\000\000\193\001\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\037\000\000\000\039\000\000\000\040\000\
\041\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\054\000\193\001\193\001\193\001\193\001\193\001\193\001\
\193\001\193\001\193\001\193\001\193\001\193\001\193\001\193\001\
\193\001\193\001\193\001\193\001\193\001\193\001\193\001\193\001\
\193\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\010\000\011\000\000\000\000\000\000\000\158\002\
\000\000\000\000\000\000\000\000\193\001\000\000\193\001\000\000\
\193\001\193\001\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\193\001\013\000\014\000\015\000\016\000\017\000\
\018\000\019\000\020\000\021\000\022\000\023\000\024\000\025\000\
\026\000\027\000\028\000\029\000\030\000\031\000\032\000\033\000\
\034\000\035\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\010\000\011\000\000\000\000\000\000\000\
\233\002\000\000\000\000\000\000\157\000\037\000\000\000\039\000\
\000\000\040\000\041\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\054\000\013\000\014\000\015\000\016\000\
\017\000\018\000\019\000\020\000\021\000\022\000\023\000\024\000\
\025\000\026\000\027\000\028\000\029\000\030\000\031\000\032\000\
\033\000\034\000\035\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\011\000\000\000\000\000\
\092\000\000\000\000\000\000\000\000\000\157\000\037\000\000\000\
\039\000\000\000\040\000\041\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\054\000\013\000\014\000\015\000\
\016\000\017\000\018\000\019\000\020\000\021\000\022\000\023\000\
\024\000\025\000\026\000\027\000\028\000\029\000\030\000\031\000\
\032\000\033\000\034\000\035\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\011\000\000\000\
\000\000\092\000\000\000\000\000\000\000\000\000\000\000\037\000\
\000\000\039\000\000\000\040\000\041\000\042\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\043\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\051\000\052\000\053\000\054\000\013\000\014\000\
\015\000\016\000\017\000\018\000\019\000\020\000\021\000\022\000\
\023\000\024\000\025\000\026\000\027\000\028\000\029\000\030\000\
\031\000\032\000\033\000\034\000\035\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\037\000\000\000\039\000\000\000\040\000\041\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\008\000\000\000\
\000\000\000\000\008\000\000\000\008\000\008\000\008\000\008\000\
\008\000\008\000\008\000\008\000\000\000\000\000\054\000\010\000\
\008\000\008\000\008\000\008\000\008\000\008\000\008\000\008\000\
\008\000\008\000\008\000\008\000\008\000\008\000\008\000\008\000\
\008\000\008\000\008\000\008\000\008\000\009\000\000\000\000\000\
\000\000\009\000\000\000\009\000\009\000\009\000\009\000\009\000\
\009\000\009\000\009\000\000\000\000\000\000\000\012\000\009\000\
\009\000\009\000\009\000\009\000\009\000\009\000\009\000\009\000\
\009\000\009\000\009\000\009\000\009\000\009\000\009\000\009\000\
\009\000\009\000\009\000\009\000\240\000\000\000\000\000\241\000\
\242\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\008\000\000\000\000\000\000\000\
\000\000\000\000\000\000\240\000\000\000\000\000\241\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\013\000\
\014\000\015\000\016\000\017\000\018\000\019\000\020\000\021\000\
\022\000\023\000\024\000\009\000\000\000\011\000\000\000\000\000\
\000\000\000\000\032\000\033\000\034\000\035\000\013\000\014\000\
\015\000\016\000\017\000\018\000\019\000\020\000\021\000\022\000\
\023\000\024\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\032\000\033\000\034\000\035\000\000\000\041\000\000\000\
\000\000\000\000\000\000\000\000\000\000\013\000\014\000\015\000\
\016\000\017\000\018\000\019\000\020\000\021\000\022\000\023\000\
\024\000\108\000\000\000\000\000\000\000\041\000\030\000\031\000\
\032\000\033\000\034\000\035\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\037\000\
\000\000\000\000\000\000\000\000\041\000\000\000\000\000\000\000\
\000\000\108\000\108\000\108\000\108\000\108\000\108\000\108\000\
\108\000\108\000\108\000\108\000\108\000\000\000\000\000\000\000\
\000\000\000\000\108\000\108\000\108\000\108\000\108\000\108\000\
\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\180\000\180\000\180\000\
\180\000\000\000\000\000\108\000\000\000\000\000\180\000\000\000\
\108\000\180\000\180\000\180\000\180\000\180\000\000\000\000\000\
\000\000\180\000\000\000\180\000\180\000\180\000\180\000\180\000\
\000\000\180\000\000\000\180\000\180\000\180\000\180\000\180\000\
\180\000\180\000\180\000\180\000\180\000\180\000\180\000\180\000\
\180\000\180\000\180\000\180\000\180\000\180\000\180\000\180\000\
\180\000\000\000\000\000\000\000\000\000\176\000\176\000\176\000\
\176\000\000\000\000\000\000\000\000\000\000\000\176\000\000\000\
\000\000\176\000\176\000\176\000\176\000\176\000\000\000\000\000\
\000\000\176\000\180\000\176\000\176\000\176\000\176\000\176\000\
\180\000\176\000\000\000\176\000\176\000\176\000\176\000\176\000\
\176\000\176\000\176\000\176\000\176\000\176\000\176\000\176\000\
\176\000\176\000\176\000\176\000\176\000\176\000\176\000\176\000\
\176\000\000\000\000\000\000\000\000\000\150\001\151\001\152\001\
\153\001\000\000\000\000\000\000\000\000\000\000\154\001\000\000\
\000\000\155\001\156\001\157\001\158\001\159\001\000\000\000\000\
\000\000\160\001\176\000\161\001\162\001\163\001\164\001\165\001\
\176\000\166\001\000\000\167\001\000\000\168\001\169\001\170\001\
\171\001\172\001\173\001\174\001\175\001\176\001\177\001\178\001\
\179\001\180\001\181\001\182\001\183\001\184\001\185\001\186\001\
\187\001\000\000\000\000\000\000\000\000\000\000\000\000\000\000\
\000\000\000\000\000\000\000\000\000\000\000\000\008\000\000\000\
\000\000\008\000\008\000\000\000\008\000\008\000\008\000\008\000\
\008\000\000\000\188\001\008\000\000\000\000\000\000\000\005\000\
\189\001\008\000\008\000\008\000\008\000\008\000\008\000\008\000\
\008\000\008\000\008\000\008\000\008\000\008\000\008\000\008\000\
\008\000\008\000\008\000\008\000\008\000"

let yycheck = "\003\000\
\002\000\010\000\002\000\140\000\069\000\002\000\193\000\003\000\
\069\000\032\000\033\000\008\000\148\000\106\000\033\000\004\000\
\178\000\002\000\002\000\002\000\034\000\122\001\000\000\008\000\
\008\000\000\000\113\000\079\000\000\000\055\001\030\002\005\000\
\249\000\076\001\056\001\031\002\173\000\085\002\118\001\091\000\
\153\000\154\000\178\000\191\001\008\001\121\001\008\001\123\001\
\000\000\018\001\228\000\118\001\030\001\053\002\014\001\021\001\
\001\001\118\000\197\002\014\001\156\000\148\000\076\000\019\001\
\018\001\018\001\047\001\007\003\008\003\025\001\156\000\035\001\
\018\001\040\000\111\001\019\001\065\001\079\000\171\000\019\001\
\019\001\025\001\079\000\170\000\067\002\025\001\025\001\010\001\
\254\000\012\001\149\001\113\001\059\000\206\000\079\000\079\000\
\000\000\037\003\019\001\195\000\067\000\068\000\091\000\103\000\
\025\001\109\000\025\001\074\000\089\001\113\000\177\000\030\001\
\249\000\109\000\018\001\182\000\026\001\036\001\022\001\097\001\
\003\003\075\001\187\000\112\000\113\001\014\001\187\000\025\001\
\017\001\075\001\019\001\020\001\193\000\030\001\020\001\018\001\
\025\001\041\001\036\001\036\001\123\002\164\000\116\000\000\000\
\148\000\204\001\035\001\036\001\052\001\210\000\036\001\148\000\
\148\000\108\001\018\001\036\001\112\001\153\002\111\001\211\000\
\212\000\014\001\136\000\148\000\148\000\018\001\170\000\047\001\
\134\001\133\001\014\001\133\001\195\000\017\001\178\000\242\000\
\176\002\132\001\097\001\153\000\154\000\178\000\178\000\139\001\
\094\001\194\000\247\000\254\000\255\000\178\000\190\002\002\001\
\003\001\178\000\178\000\139\001\077\001\028\001\029\001\139\001\
\139\001\249\002\039\001\177\000\206\000\253\002\100\001\031\002\
\052\001\089\001\212\000\021\001\104\002\053\001\211\000\026\001\
\047\001\054\001\139\001\018\001\014\001\019\001\115\001\206\000\
\018\001\018\001\211\000\211\000\068\001\022\001\230\002\228\000\
\206\000\237\000\021\002\224\000\130\001\035\001\068\001\070\001\
\237\000\230\000\231\000\228\000\228\000\234\000\018\001\221\000\
\018\001\194\001\139\001\091\001\237\000\001\001\020\002\108\001\
\026\002\218\001\089\001\068\001\001\001\091\001\101\001\068\001\
\108\001\239\000\036\001\124\001\088\002\089\002\081\002\004\001\
\001\001\195\001\196\001\112\001\075\001\117\001\135\001\132\001\
\028\001\029\001\091\001\094\001\018\001\018\002\091\001\020\002\
\132\001\014\001\129\001\111\001\017\001\112\001\027\001\205\001\
\206\001\019\001\019\001\047\001\019\001\134\001\112\001\019\001\
\025\001\058\001\047\001\047\001\021\001\025\001\121\001\122\001\
\123\001\118\001\108\001\134\001\208\002\135\001\047\001\047\001\
\009\002\130\001\070\001\019\001\134\001\130\001\136\000\111\001\
\054\002\025\001\093\000\094\000\014\001\025\001\082\001\000\000\
\106\000\218\001\132\001\044\002\106\000\089\001\082\001\076\002\
\036\001\029\001\030\001\117\000\089\001\089\001\117\001\026\002\
\115\000\021\001\014\001\018\001\193\001\110\001\018\001\085\002\
\089\001\089\001\167\001\093\000\094\000\070\002\014\001\177\000\
\138\000\025\001\018\001\019\001\118\001\197\002\022\001\035\001\
\036\001\108\001\124\001\035\001\036\001\041\001\020\001\108\001\
\019\001\115\000\018\001\035\001\036\001\135\001\025\001\025\001\
\052\001\041\001\205\001\206\001\112\001\124\001\035\001\112\001\
\035\001\171\000\036\001\023\001\052\001\171\000\124\001\132\001\
\135\001\135\002\255\002\221\000\018\001\146\002\034\001\025\001\
\112\001\135\001\019\001\044\002\021\001\134\001\023\001\139\001\
\025\001\019\001\036\001\018\001\025\001\239\000\031\001\025\001\
\014\001\034\001\035\001\036\001\037\001\038\001\019\002\036\001\
\024\002\035\001\088\001\139\001\112\001\070\002\194\001\018\001\
\108\001\161\000\139\002\019\001\033\002\194\001\035\002\008\001\
\031\002\025\001\035\001\021\001\108\001\014\001\022\001\168\002\
\024\001\194\001\134\001\105\001\049\002\022\001\030\001\024\002\
\132\001\018\001\018\001\024\002\114\001\026\002\022\001\227\001\
\185\002\214\001\014\001\025\001\132\001\017\001\219\001\227\001\
\126\001\127\001\128\001\005\001\006\001\007\001\008\001\009\001\
\010\001\011\001\012\001\013\001\014\001\015\001\016\001\017\001\
\018\001\019\001\020\001\021\001\022\001\023\001\024\001\112\001\
\067\002\036\001\025\002\014\001\008\002\009\002\025\002\169\002\
\017\002\210\002\000\000\008\002\009\002\039\001\066\002\014\001\
\020\001\039\001\242\000\018\001\081\002\088\002\089\002\008\002\
\009\002\020\001\139\001\031\002\054\001\031\002\254\000\168\002\
\054\001\169\002\034\001\035\001\050\002\037\002\112\001\036\002\
\014\001\014\001\041\001\017\001\017\001\112\001\020\001\020\001\
\185\002\019\001\000\000\036\002\036\002\052\001\019\001\025\001\
\123\002\018\001\026\001\085\001\134\001\018\001\019\001\085\001\
\014\001\022\001\153\002\134\002\018\001\092\002\011\001\014\001\
\014\001\092\002\017\001\014\001\018\001\020\001\017\001\081\002\
\022\001\020\001\020\001\019\001\041\001\035\001\112\001\014\001\
\056\001\025\001\112\001\041\001\018\001\014\001\019\001\052\001\
\022\001\018\001\019\001\021\001\025\001\022\001\052\001\025\001\
\108\002\014\001\009\001\019\001\017\001\108\001\114\002\115\002\
\108\002\025\001\035\001\036\001\034\001\035\001\114\002\115\002\
\041\001\019\001\111\002\112\002\113\002\034\001\094\001\025\001\
\019\001\133\002\014\001\052\001\197\002\132\001\018\001\139\002\
\197\002\133\002\022\001\018\001\172\002\173\002\139\002\124\001\
\125\001\113\001\178\002\019\001\122\002\153\002\147\002\153\002\
\245\002\025\001\139\002\105\001\089\001\041\001\108\001\018\001\
\160\002\070\001\147\002\147\002\114\001\169\002\108\001\193\001\
\052\001\019\001\237\002\193\001\169\002\169\002\022\001\025\001\
\126\001\127\001\128\001\022\001\169\002\024\001\132\001\026\001\
\169\002\169\002\000\000\108\001\255\002\215\001\132\001\023\001\
\019\001\019\001\003\003\197\002\014\001\106\001\003\003\025\001\
\018\001\023\001\018\001\025\001\022\001\035\001\210\002\211\002\
\000\000\213\002\023\001\132\001\025\001\210\002\019\001\211\002\
\205\002\213\002\036\001\018\001\025\001\225\002\019\001\041\001\
\108\001\210\002\019\001\019\001\025\001\225\002\000\002\035\001\
\025\001\025\001\052\001\019\001\018\001\205\001\206\001\239\002\
\022\001\025\001\024\001\054\003\026\001\027\001\028\001\021\001\
\132\001\019\002\019\001\240\002\019\001\019\002\019\001\019\001\
\025\001\003\003\025\001\020\001\025\001\025\001\019\001\033\002\
\012\003\035\002\014\003\033\002\016\003\035\002\025\001\019\001\
\012\003\025\001\014\003\019\001\016\003\025\001\023\001\049\002\
\025\001\025\001\014\001\049\002\054\002\019\001\018\001\021\001\
\054\002\023\001\108\001\025\001\019\001\030\001\019\001\014\001\
\019\001\031\001\025\001\018\001\034\001\035\001\036\001\037\001\
\052\003\053\003\019\001\140\001\020\002\041\001\058\003\023\002\
\052\003\053\003\132\001\085\002\112\001\036\001\058\003\085\002\
\052\001\112\001\041\001\111\001\019\001\019\001\096\002\021\001\
\022\001\023\001\096\002\025\001\018\001\052\001\018\001\029\001\
\030\001\031\001\000\000\021\001\034\001\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\047\001\048\001\049\001\050\001\051\001\052\001\053\001\
\054\001\055\001\056\001\024\001\041\001\135\002\019\001\108\001\
\019\001\135\002\036\001\019\001\025\001\105\001\025\001\052\001\
\108\001\025\001\112\001\018\001\140\001\019\001\114\001\001\000\
\002\000\003\000\004\000\005\000\019\001\108\001\035\001\019\001\
\021\001\023\001\126\001\127\001\128\001\074\001\075\001\035\001\
\132\001\036\001\172\002\173\002\089\001\139\001\172\002\173\002\
\178\002\018\001\035\001\025\001\178\002\132\001\018\001\023\001\
\035\001\014\001\112\001\020\001\014\001\036\001\099\001\019\001\
\101\001\035\001\019\001\018\001\023\001\199\002\018\001\021\001\
\019\001\199\002\019\001\000\000\048\001\049\001\050\001\051\001\
\052\001\053\001\054\001\055\001\056\001\139\001\052\001\053\001\
\054\001\055\001\056\001\025\001\129\001\014\001\014\001\082\001\
\014\001\000\000\036\001\023\001\018\001\019\001\019\001\112\001\
\022\001\021\001\025\001\025\001\019\001\005\001\006\001\007\001\
\008\001\036\001\036\001\245\002\021\001\082\001\014\001\245\002\
\019\001\017\001\018\001\019\001\020\001\021\001\022\001\023\001\
\024\001\025\001\026\001\027\001\028\001\029\001\030\001\031\001\
\036\001\033\001\034\001\035\001\036\001\037\001\038\001\039\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\047\001\
\048\001\049\001\050\001\051\001\052\001\053\001\054\001\055\001\
\056\001\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\071\001\
\072\001\073\001\074\001\075\001\076\001\077\001\078\001\079\001\
\008\001\023\001\082\001\036\001\018\001\125\001\108\001\134\001\
\088\001\019\001\112\001\009\001\000\000\036\001\000\000\021\001\
\036\001\097\001\036\001\099\001\100\001\101\001\035\001\103\001\
\104\001\105\001\019\001\021\001\019\001\021\001\132\001\112\001\
\112\001\112\001\114\001\112\001\000\000\139\001\050\001\051\001\
\052\001\053\001\054\001\055\001\056\001\035\001\126\001\127\001\
\128\001\129\001\130\001\036\001\021\001\019\001\134\001\005\001\
\006\001\007\001\008\001\139\001\112\001\112\001\112\001\112\001\
\014\001\002\000\122\002\017\001\018\001\019\001\020\001\021\001\
\022\001\023\001\024\001\025\001\026\001\027\001\028\001\029\001\
\030\001\031\001\084\001\033\001\034\001\035\001\036\001\037\001\
\038\001\039\001\040\001\041\001\042\001\043\001\044\001\045\001\
\046\001\047\001\048\001\049\001\050\001\051\001\052\001\053\001\
\054\001\055\001\056\001\057\001\058\001\059\001\060\001\061\001\
\062\001\063\001\064\001\065\001\066\001\067\001\068\001\069\001\
\070\001\071\001\072\001\073\001\074\001\075\001\076\001\077\001\
\078\001\079\001\216\000\140\000\082\001\207\001\098\001\054\003\
\239\002\038\002\088\001\203\002\136\001\073\002\192\002\255\002\
\056\002\205\000\124\001\097\001\095\002\099\001\100\001\101\001\
\087\002\103\001\104\001\105\001\135\001\199\002\000\000\169\000\
\070\001\014\001\112\001\151\002\114\001\018\001\019\001\169\002\
\131\002\022\001\255\255\255\255\025\001\255\255\255\255\255\255\
\126\001\127\001\128\001\129\001\130\001\255\255\255\255\014\001\
\134\001\255\255\017\001\018\001\019\001\139\001\021\001\022\001\
\023\001\255\255\025\001\255\255\255\255\255\255\029\001\030\001\
\031\001\000\000\255\255\034\001\035\001\036\001\037\001\038\001\
\039\001\040\001\041\001\042\001\043\001\044\001\045\001\046\001\
\047\001\048\001\049\001\050\001\051\001\052\001\053\001\054\001\
\055\001\056\001\057\001\058\001\059\001\060\001\061\001\062\001\
\063\001\064\001\065\001\066\001\067\001\068\001\069\001\070\001\
\071\001\072\001\073\001\074\001\075\001\076\001\077\001\078\001\
\079\001\255\255\255\255\255\255\255\255\255\255\255\255\108\001\
\255\255\255\255\255\255\112\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\099\001\255\255\101\001\255\255\
\103\001\104\001\255\255\255\255\255\255\108\001\255\255\132\001\
\000\000\112\001\255\255\255\255\255\255\255\255\139\001\019\001\
\255\255\021\001\255\255\023\001\255\255\025\001\255\255\255\255\
\255\255\255\255\129\001\255\255\255\255\132\001\034\001\035\001\
\036\001\255\255\014\001\255\255\139\001\017\001\018\001\019\001\
\255\255\021\001\022\001\023\001\255\255\025\001\255\255\255\255\
\000\000\029\001\030\001\031\001\255\255\255\255\034\001\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\044\001\045\001\046\001\047\001\048\001\049\001\050\001\051\001\
\052\001\053\001\054\001\055\001\056\001\057\001\058\001\059\001\
\060\001\061\001\062\001\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\071\001\072\001\073\001\074\001\075\001\
\076\001\077\001\078\001\079\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\112\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\099\001\
\255\255\101\001\255\255\103\001\104\001\255\255\255\255\000\000\
\108\001\255\255\255\255\255\255\112\001\255\255\255\255\139\001\
\044\001\045\001\046\001\047\001\048\001\049\001\050\001\051\001\
\052\001\053\001\054\001\055\001\056\001\129\001\008\001\014\001\
\132\001\255\255\017\001\255\255\255\255\255\255\255\255\139\001\
\018\001\019\001\255\255\021\001\022\001\023\001\024\001\025\001\
\026\001\027\001\028\001\029\001\030\001\031\001\000\000\255\255\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\048\001\049\001\
\050\001\051\001\052\001\053\001\054\001\055\001\056\001\255\255\
\255\255\255\255\255\255\018\001\019\001\255\255\021\001\022\001\
\023\001\024\001\025\001\026\001\027\001\028\001\029\001\030\001\
\031\001\255\255\255\255\034\001\035\001\036\001\037\001\038\001\
\039\001\040\001\041\001\042\001\043\001\044\001\045\001\046\001\
\047\001\048\001\049\001\050\001\051\001\052\001\053\001\054\001\
\055\001\056\001\105\001\255\255\255\255\108\001\255\255\255\255\
\255\255\255\255\255\255\114\001\255\255\000\000\112\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\126\001\
\127\001\128\001\255\255\255\255\255\255\132\001\255\255\255\255\
\008\001\255\255\255\255\133\001\255\255\255\255\255\255\255\255\
\255\255\139\001\018\001\019\001\255\255\021\001\022\001\023\001\
\024\001\025\001\026\001\027\001\028\001\029\001\030\001\031\001\
\000\000\112\001\034\001\035\001\036\001\037\001\038\001\039\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\047\001\
\048\001\049\001\050\001\051\001\052\001\053\001\054\001\055\001\
\056\001\255\255\018\001\019\001\139\001\021\001\022\001\023\001\
\024\001\025\001\026\001\027\001\028\001\029\001\030\001\031\001\
\000\000\255\255\034\001\035\001\036\001\037\001\038\001\039\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\047\001\
\048\001\049\001\050\001\051\001\052\001\053\001\054\001\055\001\
\056\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\014\001\255\255\255\255\255\255\018\001\019\001\000\000\
\112\001\022\001\039\001\040\001\041\001\042\001\043\001\044\001\
\045\001\046\001\047\001\048\001\049\001\050\001\051\001\052\001\
\053\001\054\001\055\001\056\001\041\001\133\001\255\255\255\255\
\255\255\255\255\019\001\139\001\021\001\255\255\023\001\052\001\
\025\001\255\255\255\255\255\255\029\001\030\001\031\001\000\000\
\112\001\034\001\035\001\036\001\037\001\038\001\039\001\040\001\
\041\001\042\001\043\001\044\001\045\001\046\001\047\001\048\001\
\049\001\050\001\051\001\052\001\053\001\054\001\055\001\056\001\
\255\255\255\255\255\255\139\001\255\255\255\255\255\255\255\255\
\255\255\019\001\255\255\021\001\255\255\023\001\255\255\025\001\
\255\255\000\000\255\255\029\001\030\001\031\001\255\255\108\001\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\048\001\049\001\
\050\001\051\001\052\001\053\001\054\001\055\001\056\001\132\001\
\255\255\255\255\031\001\255\255\255\255\255\255\000\000\112\001\
\037\001\038\001\039\001\040\001\041\001\042\001\043\001\044\001\
\045\001\046\001\047\001\048\001\049\001\050\001\051\001\052\001\
\053\001\054\001\055\001\056\001\255\255\255\255\255\255\255\255\
\255\255\255\255\139\001\255\255\255\255\255\255\255\255\255\255\
\019\001\255\255\021\001\255\255\023\001\255\255\025\001\255\255\
\000\000\255\255\029\001\030\001\031\001\255\255\112\001\034\001\
\035\001\036\001\037\001\038\001\039\001\040\001\041\001\042\001\
\043\001\044\001\045\001\046\001\047\001\048\001\049\001\050\001\
\051\001\052\001\053\001\054\001\055\001\056\001\255\255\255\255\
\255\255\139\001\255\255\019\001\255\255\021\001\000\000\023\001\
\255\255\025\001\255\255\255\255\255\255\029\001\030\001\031\001\
\255\255\255\255\034\001\035\001\036\001\037\001\038\001\039\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\047\001\
\048\001\049\001\050\001\051\001\052\001\053\001\054\001\055\001\
\056\001\255\255\255\255\019\001\255\255\021\001\255\255\023\001\
\000\000\025\001\255\255\255\255\255\255\112\001\255\255\031\001\
\255\255\255\255\034\001\035\001\036\001\037\001\038\001\039\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\047\001\
\048\001\049\001\050\001\051\001\255\255\255\255\255\255\255\255\
\139\001\255\255\019\001\255\255\021\001\000\000\023\001\255\255\
\025\001\255\255\255\255\255\255\255\255\255\255\031\001\255\255\
\112\001\034\001\035\001\036\001\037\001\038\001\039\001\040\001\
\041\001\042\001\043\001\044\001\045\001\046\001\047\001\048\001\
\049\001\050\001\051\001\052\001\053\001\054\001\055\001\056\001\
\255\255\255\255\019\001\139\001\021\001\255\255\023\001\000\000\
\025\001\255\255\255\255\255\255\255\255\255\255\031\001\255\255\
\112\001\034\001\035\001\036\001\037\001\038\001\039\001\040\001\
\041\001\042\001\043\001\044\001\045\001\046\001\047\001\048\001\
\049\001\050\001\051\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\139\001\019\001\000\000\021\001\255\255\
\023\001\255\255\025\001\255\255\255\255\255\255\255\255\112\001\
\031\001\255\255\255\255\034\001\035\001\036\001\037\001\038\001\
\039\001\040\001\041\001\042\001\043\001\044\001\045\001\046\001\
\047\001\048\001\049\001\000\000\255\255\255\255\255\255\255\255\
\255\255\019\001\139\001\021\001\255\255\023\001\255\255\025\001\
\255\255\255\255\255\255\255\255\255\255\031\001\255\255\112\001\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\048\001\049\001\
\255\255\000\000\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\139\001\019\001\255\255\021\001\255\255\023\001\
\255\255\025\001\255\255\255\255\255\255\255\255\255\255\031\001\
\255\255\112\001\034\001\035\001\036\001\037\001\038\001\039\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\047\001\
\255\255\255\255\000\000\255\255\255\255\255\255\255\255\255\255\
\255\255\019\001\255\255\021\001\139\001\023\001\255\255\025\001\
\255\255\255\255\255\255\255\255\255\255\031\001\112\001\255\255\
\034\001\035\001\036\001\037\001\038\001\039\001\040\001\041\001\
\042\001\043\001\044\001\045\001\046\001\047\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\139\001\255\255\019\001\255\255\021\001\255\255\023\001\
\255\255\025\001\255\255\255\255\255\255\255\255\255\255\031\001\
\112\001\255\255\034\001\035\001\036\001\037\001\038\001\039\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\047\001\
\255\255\255\255\255\255\255\255\255\255\000\000\255\255\255\255\
\019\001\255\255\021\001\139\001\023\001\255\255\025\001\255\255\
\255\255\255\255\255\255\255\255\031\001\255\255\112\001\034\001\
\035\001\036\001\037\001\038\001\039\001\040\001\041\001\042\001\
\043\001\044\001\045\001\046\001\047\001\255\255\005\000\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\139\001\019\001\255\255\021\001\255\255\023\001\255\255\
\025\001\255\255\255\255\255\255\255\255\255\255\031\001\255\255\
\112\001\034\001\035\001\036\001\037\001\038\001\039\001\040\001\
\041\001\042\001\043\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\019\001\255\255\021\001\139\001\023\001\255\255\025\001\255\255\
\255\255\255\255\255\255\255\255\031\001\112\001\255\255\034\001\
\035\001\036\001\037\001\038\001\039\001\040\001\041\001\042\001\
\043\001\255\255\255\255\255\255\255\255\255\255\019\001\255\255\
\021\001\255\255\023\001\255\255\025\001\255\255\000\000\255\255\
\139\001\255\255\031\001\255\255\255\255\034\001\035\001\036\001\
\037\001\038\001\039\001\040\001\041\001\255\255\255\255\112\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\019\001\255\255\021\001\255\255\
\023\001\255\255\025\001\255\255\255\255\255\255\255\255\255\255\
\031\001\136\000\139\001\034\001\035\001\036\001\037\001\038\001\
\039\001\040\001\255\255\255\255\255\255\112\001\255\255\255\255\
\255\255\255\255\153\000\154\000\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\019\001\255\255\021\001\
\000\000\023\001\255\255\025\001\255\255\255\255\255\255\255\255\
\139\001\031\001\177\000\112\001\034\001\035\001\036\001\037\001\
\038\001\039\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\195\000\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\139\001\206\000\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\112\001\255\255\255\255\255\255\255\255\221\000\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\005\001\006\001\007\001\008\001\009\001\255\255\
\239\000\255\255\013\001\014\001\139\001\016\001\017\001\018\001\
\255\255\020\001\021\001\255\255\255\255\255\255\255\255\255\255\
\027\001\028\001\112\001\255\255\255\255\032\001\033\001\255\255\
\255\255\036\001\255\255\038\001\255\255\255\255\041\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\050\001\
\051\001\052\001\255\255\255\255\255\255\139\001\057\001\058\001\
\059\001\060\001\061\001\062\001\063\001\064\001\065\001\066\001\
\067\001\068\001\069\001\070\001\071\001\072\001\073\001\074\001\
\075\001\076\001\077\001\078\001\079\001\080\001\081\001\255\255\
\083\001\084\001\085\001\086\001\087\001\088\001\089\001\090\001\
\091\001\092\001\093\001\094\001\095\001\096\001\255\255\255\255\
\099\001\100\001\101\001\255\255\103\001\104\001\105\001\255\255\
\255\255\108\001\255\255\255\255\255\255\112\001\255\255\114\001\
\255\255\116\001\117\001\118\001\119\001\120\001\121\001\122\001\
\123\001\255\255\125\001\126\001\127\001\128\001\129\001\255\255\
\131\001\132\001\133\001\134\001\014\001\136\001\016\001\017\001\
\255\255\255\255\255\255\255\255\255\255\255\255\117\001\255\255\
\255\255\255\255\255\255\255\255\255\255\124\001\255\255\255\255\
\255\255\255\255\036\001\255\255\255\255\255\255\255\255\255\255\
\135\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\057\001\
\058\001\059\001\060\001\061\001\062\001\063\001\064\001\065\001\
\066\001\067\001\068\001\069\001\070\001\071\001\072\001\073\001\
\074\001\075\001\076\001\077\001\078\001\079\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\016\001\017\001\255\255\255\255\255\255\255\255\255\255\255\255\
\098\001\099\001\100\001\101\001\255\255\103\001\104\001\105\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\114\001\255\255\116\001\117\001\118\001\119\001\120\001\121\001\
\122\001\255\255\255\255\255\255\126\001\127\001\128\001\129\001\
\255\255\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\071\001\
\072\001\073\001\074\001\075\001\076\001\077\001\078\001\079\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\047\001\
\048\001\049\001\050\001\051\001\052\001\053\001\054\001\055\001\
\056\001\255\255\098\001\099\001\255\255\101\001\255\255\103\001\
\104\001\005\001\006\001\007\001\008\001\009\001\255\255\255\255\
\255\255\013\001\014\001\015\001\255\255\017\001\018\001\019\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\027\001\
\028\001\129\001\255\255\255\255\032\001\033\001\255\255\255\255\
\255\255\255\255\038\001\255\255\255\255\041\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\050\001\051\001\
\052\001\255\255\255\255\255\255\255\255\057\001\058\001\059\001\
\060\001\061\001\062\001\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\071\001\072\001\073\001\074\001\075\001\
\076\001\077\001\078\001\079\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\093\001\094\001\095\001\096\001\255\255\255\255\099\001\
\255\255\101\001\255\255\103\001\104\001\255\255\255\255\255\255\
\108\001\255\255\255\255\255\255\255\255\255\255\005\001\006\001\
\007\001\008\001\009\001\255\255\255\255\255\255\013\001\014\001\
\015\001\255\255\017\001\018\001\019\001\129\001\255\255\255\255\
\132\001\133\001\255\255\255\255\027\001\028\001\255\255\255\255\
\140\001\032\001\033\001\255\255\255\255\255\255\255\255\038\001\
\255\255\255\255\041\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\050\001\051\001\052\001\255\255\255\255\
\255\255\255\255\057\001\058\001\059\001\060\001\061\001\062\001\
\063\001\064\001\065\001\066\001\067\001\068\001\069\001\070\001\
\071\001\072\001\073\001\074\001\075\001\076\001\077\001\078\001\
\079\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\093\001\094\001\
\095\001\096\001\255\255\255\255\099\001\255\255\101\001\255\255\
\103\001\104\001\255\255\255\255\255\255\108\001\255\255\255\255\
\255\255\255\255\255\255\005\001\006\001\007\001\008\001\009\001\
\255\255\255\255\255\255\013\001\014\001\015\001\255\255\017\001\
\018\001\019\001\129\001\255\255\255\255\132\001\133\001\255\255\
\255\255\027\001\028\001\255\255\255\255\140\001\032\001\033\001\
\255\255\255\255\255\255\255\255\038\001\255\255\255\255\041\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\050\001\051\001\052\001\255\255\255\255\255\255\255\255\057\001\
\058\001\059\001\060\001\061\001\062\001\063\001\064\001\065\001\
\066\001\067\001\068\001\069\001\070\001\071\001\072\001\073\001\
\074\001\075\001\076\001\077\001\078\001\079\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\093\001\094\001\095\001\096\001\255\255\
\255\255\099\001\255\255\101\001\255\255\103\001\104\001\255\255\
\255\255\255\255\108\001\255\255\255\255\255\255\255\255\255\255\
\005\001\006\001\007\001\008\001\009\001\255\255\255\255\255\255\
\013\001\014\001\015\001\255\255\017\001\018\001\019\001\129\001\
\255\255\255\255\132\001\133\001\255\255\255\255\027\001\028\001\
\255\255\255\255\140\001\032\001\033\001\255\255\255\255\255\255\
\255\255\038\001\255\255\255\255\041\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\050\001\051\001\052\001\
\255\255\255\255\255\255\255\255\057\001\058\001\059\001\060\001\
\061\001\062\001\063\001\064\001\065\001\066\001\067\001\068\001\
\069\001\070\001\071\001\072\001\073\001\074\001\075\001\076\001\
\077\001\078\001\079\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\093\001\094\001\095\001\096\001\255\255\255\255\099\001\255\255\
\101\001\255\255\103\001\104\001\255\255\255\255\255\255\108\001\
\255\255\255\255\255\255\255\255\255\255\005\001\006\001\007\001\
\008\001\009\001\255\255\255\255\255\255\013\001\014\001\015\001\
\255\255\017\001\018\001\019\001\129\001\255\255\255\255\132\001\
\133\001\255\255\255\255\027\001\028\001\255\255\255\255\140\001\
\032\001\033\001\255\255\255\255\255\255\255\255\038\001\255\255\
\255\255\041\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\050\001\051\001\052\001\255\255\255\255\255\255\
\255\255\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\071\001\
\072\001\073\001\074\001\075\001\076\001\077\001\078\001\079\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\093\001\094\001\095\001\
\096\001\255\255\255\255\099\001\255\255\101\001\255\255\103\001\
\104\001\255\255\255\255\255\255\108\001\255\255\255\255\255\255\
\255\255\255\255\005\001\006\001\007\001\008\001\009\001\255\255\
\255\255\255\255\013\001\014\001\015\001\255\255\017\001\018\001\
\255\255\129\001\255\255\255\255\132\001\133\001\255\255\255\255\
\027\001\028\001\255\255\255\255\140\001\032\001\033\001\255\255\
\255\255\255\255\255\255\038\001\255\255\255\255\041\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\050\001\
\051\001\052\001\255\255\255\255\255\255\255\255\057\001\058\001\
\059\001\060\001\061\001\062\001\063\001\064\001\065\001\066\001\
\067\001\068\001\069\001\070\001\071\001\072\001\073\001\074\001\
\075\001\076\001\077\001\078\001\079\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\093\001\094\001\095\001\096\001\255\255\255\255\
\099\001\255\255\101\001\255\255\103\001\104\001\255\255\255\255\
\255\255\108\001\255\255\255\255\255\255\255\255\255\255\005\001\
\006\001\007\001\008\001\009\001\255\255\255\255\255\255\013\001\
\014\001\015\001\255\255\017\001\018\001\255\255\129\001\255\255\
\255\255\132\001\133\001\255\255\255\255\027\001\028\001\255\255\
\255\255\140\001\032\001\033\001\255\255\255\255\255\255\255\255\
\038\001\255\255\255\255\041\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\050\001\051\001\052\001\255\255\
\255\255\255\255\255\255\057\001\058\001\059\001\060\001\061\001\
\062\001\063\001\064\001\065\001\066\001\067\001\068\001\069\001\
\070\001\071\001\072\001\073\001\074\001\075\001\076\001\077\001\
\078\001\079\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\093\001\
\094\001\095\001\096\001\255\255\255\255\099\001\255\255\101\001\
\255\255\103\001\104\001\255\255\255\255\255\255\108\001\255\255\
\255\255\255\255\255\255\255\255\255\255\005\001\006\001\007\001\
\008\001\009\001\255\255\255\255\255\255\013\001\014\001\255\255\
\016\001\017\001\018\001\129\001\020\001\255\255\132\001\133\001\
\255\255\255\255\255\255\027\001\028\001\255\255\140\001\255\255\
\032\001\033\001\255\255\255\255\036\001\255\255\038\001\255\255\
\255\255\041\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\050\001\051\001\052\001\255\255\255\255\255\255\
\255\255\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\071\001\
\072\001\073\001\074\001\075\001\076\001\077\001\078\001\079\001\
\080\001\081\001\255\255\083\001\084\001\085\001\086\001\087\001\
\088\001\089\001\090\001\091\001\092\001\093\001\094\001\095\001\
\096\001\255\255\255\255\099\001\100\001\101\001\255\255\103\001\
\104\001\105\001\255\255\255\255\108\001\109\001\110\001\255\255\
\255\255\255\255\114\001\255\255\116\001\117\001\118\001\119\001\
\120\001\121\001\122\001\123\001\255\255\255\255\126\001\127\001\
\128\001\129\001\255\255\131\001\132\001\133\001\255\255\255\255\
\136\001\005\001\006\001\007\001\008\001\009\001\255\255\255\255\
\255\255\013\001\014\001\255\255\016\001\017\001\018\001\255\255\
\020\001\255\255\255\255\255\255\255\255\255\255\255\255\027\001\
\028\001\255\255\255\255\255\255\032\001\033\001\255\255\255\255\
\036\001\255\255\038\001\255\255\255\255\041\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\050\001\051\001\
\052\001\255\255\255\255\255\255\255\255\057\001\058\001\059\001\
\060\001\061\001\062\001\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\071\001\072\001\073\001\074\001\075\001\
\076\001\077\001\078\001\079\001\080\001\081\001\255\255\083\001\
\084\001\085\001\086\001\087\001\088\001\089\001\090\001\091\001\
\092\001\093\001\094\001\095\001\096\001\255\255\255\255\099\001\
\100\001\101\001\255\255\103\001\104\001\105\001\255\255\255\255\
\108\001\255\255\255\255\255\255\112\001\255\255\114\001\255\255\
\116\001\117\001\118\001\119\001\120\001\121\001\122\001\123\001\
\255\255\255\255\126\001\127\001\128\001\129\001\255\255\131\001\
\132\001\133\001\134\001\255\255\136\001\005\001\006\001\007\001\
\008\001\009\001\255\255\255\255\255\255\013\001\014\001\255\255\
\016\001\017\001\018\001\255\255\020\001\255\255\255\255\255\255\
\255\255\255\255\255\255\027\001\028\001\255\255\255\255\255\255\
\032\001\033\001\255\255\255\255\036\001\255\255\038\001\255\255\
\255\255\041\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\050\001\051\001\052\001\255\255\255\255\255\255\
\255\255\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\071\001\
\072\001\073\001\074\001\075\001\076\001\077\001\078\001\079\001\
\080\001\081\001\255\255\083\001\084\001\085\001\086\001\087\001\
\088\001\089\001\090\001\091\001\092\001\093\001\094\001\095\001\
\096\001\255\255\255\255\099\001\100\001\101\001\255\255\103\001\
\104\001\105\001\255\255\255\255\108\001\255\255\255\255\255\255\
\112\001\255\255\114\001\255\255\116\001\117\001\118\001\119\001\
\120\001\121\001\122\001\123\001\255\255\255\255\126\001\127\001\
\128\001\129\001\255\255\131\001\132\001\133\001\134\001\255\255\
\136\001\005\001\006\001\007\001\008\001\009\001\255\255\255\255\
\255\255\013\001\014\001\255\255\016\001\017\001\018\001\255\255\
\020\001\255\255\255\255\255\255\255\255\255\255\255\255\027\001\
\028\001\255\255\255\255\255\255\032\001\033\001\255\255\255\255\
\036\001\255\255\038\001\255\255\255\255\041\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\050\001\051\001\
\052\001\255\255\255\255\255\255\255\255\057\001\058\001\059\001\
\060\001\061\001\062\001\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\071\001\072\001\073\001\074\001\075\001\
\076\001\077\001\078\001\079\001\080\001\081\001\255\255\083\001\
\084\001\085\001\086\001\087\001\088\001\089\001\090\001\091\001\
\092\001\093\001\094\001\095\001\096\001\255\255\255\255\099\001\
\100\001\101\001\255\255\103\001\104\001\105\001\255\255\255\255\
\108\001\255\255\255\255\255\255\112\001\255\255\114\001\255\255\
\116\001\117\001\118\001\119\001\120\001\121\001\122\001\123\001\
\255\255\255\255\126\001\127\001\128\001\129\001\255\255\131\001\
\132\001\133\001\134\001\255\255\136\001\005\001\006\001\007\001\
\008\001\009\001\255\255\255\255\255\255\013\001\014\001\255\255\
\016\001\017\001\018\001\255\255\020\001\255\255\255\255\255\255\
\255\255\255\255\255\255\027\001\028\001\255\255\255\255\255\255\
\032\001\033\001\255\255\255\255\036\001\255\255\038\001\255\255\
\255\255\041\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\050\001\051\001\052\001\255\255\255\255\255\255\
\255\255\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\071\001\
\072\001\073\001\074\001\075\001\076\001\077\001\078\001\079\001\
\080\001\081\001\255\255\083\001\084\001\085\001\086\001\087\001\
\088\001\089\001\090\001\091\001\092\001\093\001\094\001\095\001\
\096\001\255\255\255\255\099\001\100\001\101\001\255\255\103\001\
\104\001\105\001\255\255\255\255\108\001\255\255\110\001\255\255\
\255\255\255\255\114\001\255\255\116\001\117\001\118\001\119\001\
\120\001\121\001\122\001\123\001\255\255\255\255\126\001\127\001\
\128\001\129\001\255\255\131\001\132\001\133\001\255\255\255\255\
\136\001\005\001\006\001\007\001\008\001\009\001\255\255\255\255\
\255\255\013\001\014\001\255\255\016\001\017\001\018\001\255\255\
\020\001\255\255\255\255\255\255\255\255\255\255\255\255\027\001\
\028\001\255\255\255\255\255\255\032\001\033\001\255\255\255\255\
\036\001\255\255\038\001\255\255\255\255\041\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\050\001\051\001\
\052\001\255\255\255\255\255\255\255\255\057\001\058\001\059\001\
\060\001\061\001\062\001\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\071\001\072\001\073\001\074\001\075\001\
\076\001\077\001\078\001\079\001\080\001\081\001\255\255\083\001\
\084\001\085\001\086\001\087\001\088\001\089\001\090\001\091\001\
\092\001\093\001\094\001\095\001\096\001\255\255\255\255\099\001\
\100\001\101\001\255\255\103\001\104\001\105\001\255\255\255\255\
\108\001\255\255\255\255\255\255\255\255\255\255\114\001\255\255\
\116\001\117\001\118\001\119\001\120\001\121\001\122\001\123\001\
\255\255\255\255\126\001\127\001\128\001\129\001\255\255\131\001\
\132\001\133\001\255\255\255\255\136\001\005\001\006\001\007\001\
\008\001\009\001\255\255\255\255\255\255\013\001\014\001\255\255\
\255\255\017\001\018\001\255\255\020\001\255\255\255\255\255\255\
\255\255\255\255\255\255\027\001\028\001\255\255\255\255\255\255\
\032\001\033\001\255\255\255\255\036\001\255\255\038\001\255\255\
\255\255\041\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\050\001\051\001\052\001\255\255\255\255\255\255\
\255\255\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\071\001\
\072\001\073\001\074\001\075\001\076\001\077\001\078\001\079\001\
\080\001\081\001\255\255\083\001\084\001\085\001\086\001\087\001\
\088\001\089\001\090\001\091\001\092\001\093\001\094\001\095\001\
\096\001\255\255\255\255\099\001\100\001\101\001\255\255\103\001\
\104\001\255\255\255\255\255\255\108\001\255\255\255\255\255\255\
\005\001\006\001\007\001\008\001\009\001\255\255\255\255\255\255\
\013\001\014\001\017\001\123\001\017\001\018\001\255\255\020\001\
\255\255\129\001\255\255\131\001\132\001\133\001\027\001\028\001\
\136\001\255\255\255\255\032\001\033\001\255\255\255\255\036\001\
\255\255\038\001\255\255\255\255\041\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\050\001\051\001\052\001\
\255\255\255\255\057\001\058\001\059\001\060\001\061\001\062\001\
\063\001\064\001\065\001\066\001\067\001\068\001\069\001\070\001\
\071\001\072\001\073\001\074\001\075\001\076\001\077\001\078\001\
\079\001\255\255\255\255\080\001\081\001\255\255\083\001\084\001\
\085\001\086\001\087\001\088\001\089\001\090\001\091\001\092\001\
\093\001\094\001\095\001\096\001\099\001\255\255\101\001\100\001\
\103\001\104\001\255\255\255\255\255\255\255\255\255\255\108\001\
\255\255\255\255\255\255\005\001\006\001\007\001\008\001\009\001\
\255\255\255\255\255\255\013\001\014\001\255\255\123\001\017\001\
\018\001\255\255\129\001\255\255\255\255\255\255\131\001\132\001\
\133\001\027\001\028\001\136\001\255\255\255\255\032\001\033\001\
\255\255\255\255\036\001\255\255\038\001\255\255\255\255\041\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\050\001\051\001\052\001\255\255\255\255\255\255\255\255\057\001\
\058\001\059\001\060\001\061\001\062\001\063\001\064\001\065\001\
\066\001\067\001\068\001\069\001\070\001\071\001\072\001\073\001\
\074\001\075\001\076\001\077\001\078\001\079\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\093\001\094\001\095\001\096\001\255\255\
\255\255\099\001\255\255\101\001\255\255\103\001\104\001\255\255\
\255\255\255\255\108\001\255\255\255\255\255\255\005\001\006\001\
\007\001\008\001\009\001\255\255\255\255\255\255\013\001\014\001\
\255\255\255\255\017\001\018\001\255\255\255\255\255\255\129\001\
\255\255\255\255\132\001\133\001\027\001\028\001\255\255\255\255\
\255\255\032\001\033\001\255\255\255\255\255\255\255\255\038\001\
\255\255\255\255\041\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\050\001\051\001\052\001\255\255\255\255\
\255\255\255\255\057\001\058\001\059\001\060\001\061\001\062\001\
\063\001\064\001\065\001\066\001\067\001\068\001\255\255\255\255\
\255\255\255\255\255\255\074\001\075\001\076\001\077\001\078\001\
\079\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\093\001\094\001\
\095\001\096\001\255\255\255\255\099\001\255\255\255\255\255\255\
\255\255\104\001\255\255\255\255\255\255\108\001\255\255\255\255\
\255\255\005\001\006\001\007\001\008\001\009\001\255\255\255\255\
\255\255\013\001\014\001\255\255\255\255\017\001\018\001\255\255\
\020\001\021\001\022\001\255\255\024\001\132\001\133\001\027\001\
\028\001\255\255\255\255\255\255\032\001\033\001\255\255\255\255\
\255\255\255\255\038\001\255\255\255\255\041\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\050\001\051\001\
\052\001\005\001\006\001\007\001\008\001\009\001\255\255\255\255\
\255\255\013\001\014\001\255\255\255\255\017\001\018\001\255\255\
\020\001\021\001\022\001\255\255\024\001\255\255\255\255\027\001\
\028\001\255\255\255\255\255\255\032\001\033\001\255\255\255\255\
\255\255\255\255\038\001\255\255\255\255\041\001\255\255\255\255\
\255\255\093\001\094\001\095\001\096\001\255\255\050\001\051\001\
\052\001\005\001\006\001\007\001\008\001\009\001\255\255\255\255\
\108\001\013\001\014\001\255\255\255\255\017\001\018\001\255\255\
\020\001\255\255\022\001\255\255\024\001\255\255\255\255\027\001\
\028\001\255\255\255\255\255\255\032\001\033\001\255\255\255\255\
\132\001\133\001\038\001\255\255\255\255\041\001\255\255\255\255\
\255\255\093\001\094\001\095\001\096\001\255\255\050\001\051\001\
\052\001\005\001\006\001\007\001\008\001\009\001\255\255\255\255\
\108\001\013\001\014\001\255\255\255\255\255\255\018\001\255\255\
\020\001\255\255\255\255\255\255\255\255\255\255\255\255\027\001\
\028\001\255\255\255\255\255\255\032\001\033\001\255\255\255\255\
\132\001\133\001\038\001\255\255\255\255\041\001\255\255\255\255\
\255\255\093\001\094\001\095\001\096\001\255\255\050\001\051\001\
\052\001\005\001\006\001\007\001\008\001\009\001\255\255\255\255\
\108\001\013\001\014\001\255\255\255\255\255\255\018\001\255\255\
\255\255\255\255\022\001\255\255\255\255\255\255\255\255\027\001\
\028\001\255\255\255\255\255\255\032\001\033\001\255\255\255\255\
\132\001\133\001\038\001\255\255\255\255\041\001\255\255\255\255\
\255\255\093\001\094\001\095\001\096\001\255\255\050\001\051\001\
\052\001\005\001\006\001\007\001\008\001\009\001\255\255\255\255\
\108\001\013\001\014\001\255\255\255\255\255\255\018\001\255\255\
\255\255\255\255\255\255\023\001\255\255\255\255\255\255\027\001\
\028\001\255\255\255\255\255\255\032\001\033\001\255\255\255\255\
\132\001\133\001\038\001\255\255\255\255\041\001\255\255\255\255\
\255\255\093\001\094\001\095\001\096\001\255\255\050\001\051\001\
\052\001\005\001\006\001\007\001\008\001\009\001\255\255\255\255\
\108\001\013\001\014\001\255\255\255\255\255\255\018\001\255\255\
\255\255\255\255\255\255\023\001\255\255\255\255\255\255\027\001\
\028\001\255\255\255\255\255\255\032\001\033\001\255\255\255\255\
\132\001\133\001\038\001\255\255\255\255\041\001\255\255\255\255\
\255\255\093\001\094\001\095\001\096\001\255\255\050\001\051\001\
\052\001\005\001\006\001\007\001\008\001\009\001\255\255\255\255\
\108\001\013\001\014\001\255\255\255\255\255\255\018\001\255\255\
\020\001\255\255\255\255\255\255\255\255\255\255\255\255\027\001\
\028\001\255\255\255\255\255\255\032\001\033\001\255\255\255\255\
\132\001\133\001\038\001\255\255\255\255\041\001\255\255\255\255\
\255\255\093\001\094\001\095\001\096\001\255\255\050\001\051\001\
\052\001\255\255\255\255\005\001\006\001\007\001\008\001\009\001\
\108\001\255\255\255\255\013\001\014\001\255\255\255\255\255\255\
\018\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\027\001\028\001\255\255\255\255\255\255\032\001\033\001\
\132\001\133\001\036\001\255\255\038\001\255\255\255\255\041\001\
\255\255\093\001\094\001\095\001\096\001\255\255\255\255\255\255\
\050\001\051\001\052\001\005\001\006\001\007\001\008\001\009\001\
\108\001\255\255\255\255\013\001\014\001\255\255\255\255\255\255\
\018\001\255\255\020\001\255\255\255\255\255\255\255\255\255\255\
\255\255\027\001\028\001\255\255\255\255\255\255\032\001\033\001\
\132\001\133\001\255\255\255\255\038\001\255\255\255\255\041\001\
\255\255\255\255\255\255\093\001\094\001\095\001\096\001\255\255\
\050\001\051\001\052\001\005\001\006\001\007\001\008\001\009\001\
\255\255\255\255\108\001\013\001\014\001\255\255\255\255\255\255\
\018\001\255\255\255\255\255\255\255\255\023\001\255\255\255\255\
\255\255\027\001\028\001\255\255\255\255\255\255\032\001\033\001\
\255\255\255\255\132\001\133\001\038\001\255\255\255\255\041\001\
\255\255\255\255\255\255\093\001\094\001\095\001\096\001\255\255\
\050\001\051\001\052\001\005\001\006\001\007\001\008\001\009\001\
\255\255\255\255\108\001\013\001\014\001\255\255\255\255\255\255\
\018\001\019\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\027\001\028\001\255\255\255\255\255\255\032\001\033\001\
\255\255\255\255\132\001\133\001\038\001\255\255\255\255\041\001\
\255\255\255\255\255\255\093\001\094\001\095\001\096\001\255\255\
\050\001\051\001\052\001\005\001\006\001\007\001\008\001\009\001\
\255\255\255\255\108\001\013\001\014\001\255\255\255\255\255\255\
\018\001\019\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\027\001\028\001\255\255\255\255\255\255\032\001\033\001\
\255\255\255\255\132\001\133\001\038\001\255\255\255\255\041\001\
\255\255\255\255\255\255\093\001\094\001\095\001\096\001\255\255\
\050\001\051\001\052\001\005\001\006\001\007\001\008\001\009\001\
\255\255\255\255\108\001\013\001\014\001\255\255\255\255\255\255\
\018\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\027\001\028\001\255\255\255\255\255\255\032\001\033\001\
\255\255\255\255\132\001\133\001\038\001\255\255\255\255\041\001\
\255\255\255\255\255\255\093\001\094\001\095\001\096\001\255\255\
\050\001\051\001\052\001\014\001\255\255\255\255\255\255\018\001\
\019\001\255\255\108\001\022\001\255\255\255\255\025\001\014\001\
\255\255\255\255\255\255\018\001\019\001\255\255\255\255\022\001\
\255\255\036\001\025\001\255\255\014\001\255\255\041\001\255\255\
\018\001\019\001\132\001\133\001\022\001\036\001\255\255\025\001\
\255\255\052\001\041\001\093\001\094\001\095\001\096\001\255\255\
\255\255\255\255\036\001\255\255\255\255\052\001\255\255\041\001\
\255\255\014\001\108\001\255\255\255\255\018\001\019\001\255\255\
\255\255\022\001\052\001\014\001\025\001\255\255\255\255\018\001\
\019\001\255\255\255\255\022\001\255\255\255\255\025\001\036\001\
\255\255\255\255\132\001\133\001\041\001\255\255\255\255\255\255\
\255\255\036\001\255\255\255\255\255\255\255\255\041\001\052\001\
\255\255\108\001\255\255\255\255\255\255\112\001\255\255\255\255\
\255\255\052\001\255\255\255\255\255\255\108\001\255\255\255\255\
\255\255\112\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\132\001\108\001\255\255\255\255\255\255\112\001\255\255\
\139\001\255\255\255\255\255\255\255\255\132\001\255\255\255\255\
\255\255\255\255\255\255\255\255\139\001\255\255\255\255\255\255\
\255\255\255\255\132\001\255\255\255\255\255\255\255\255\108\001\
\255\255\139\001\017\001\112\001\019\001\020\001\255\255\255\255\
\255\255\108\001\025\001\255\255\255\255\112\001\255\255\030\001\
\255\255\255\255\255\255\255\255\035\001\036\001\255\255\132\001\
\255\255\255\255\255\255\255\255\255\255\255\255\139\001\255\255\
\255\255\132\001\255\255\255\255\255\255\255\255\255\255\255\255\
\139\001\255\255\057\001\058\001\059\001\060\001\061\001\062\001\
\063\001\064\001\065\001\066\001\067\001\068\001\069\001\070\001\
\071\001\072\001\073\001\074\001\075\001\076\001\077\001\078\001\
\079\001\041\001\042\001\043\001\044\001\045\001\046\001\047\001\
\048\001\049\001\050\001\051\001\052\001\053\001\054\001\055\001\
\056\001\255\255\097\001\255\255\099\001\100\001\101\001\255\255\
\103\001\104\001\105\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\114\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\126\001\
\127\001\128\001\129\001\130\001\255\255\255\255\017\001\134\001\
\019\001\020\001\255\255\255\255\139\001\255\255\025\001\255\255\
\255\255\255\255\255\255\030\001\255\255\255\255\255\255\255\255\
\035\001\036\001\005\001\006\001\007\001\008\001\009\001\010\001\
\011\001\012\001\013\001\014\001\015\001\016\001\017\001\018\001\
\019\001\020\001\021\001\022\001\023\001\024\001\057\001\058\001\
\059\001\060\001\061\001\062\001\063\001\064\001\065\001\066\001\
\067\001\068\001\069\001\070\001\071\001\072\001\073\001\074\001\
\075\001\076\001\077\001\078\001\079\001\042\001\043\001\044\001\
\045\001\046\001\047\001\048\001\049\001\050\001\051\001\052\001\
\053\001\054\001\055\001\056\001\255\255\255\255\097\001\255\255\
\099\001\100\001\101\001\255\255\103\001\104\001\105\001\255\255\
\255\255\255\255\014\001\255\255\255\255\017\001\018\001\114\001\
\255\255\255\255\022\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\126\001\127\001\128\001\129\001\130\001\
\036\001\255\255\255\255\134\001\255\255\041\001\255\255\255\255\
\139\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\052\001\255\255\255\255\255\255\255\255\057\001\058\001\059\001\
\060\001\061\001\062\001\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\071\001\072\001\073\001\074\001\075\001\
\076\001\077\001\078\001\079\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\014\001\255\255\255\255\017\001\255\255\255\255\255\255\099\001\
\255\255\101\001\255\255\103\001\104\001\255\255\255\255\255\255\
\108\001\255\255\255\255\255\255\112\001\255\255\036\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\129\001\255\255\255\255\
\132\001\255\255\134\001\057\001\058\001\059\001\060\001\061\001\
\062\001\063\001\064\001\065\001\066\001\067\001\068\001\255\255\
\255\255\255\255\255\255\255\255\074\001\075\001\076\001\077\001\
\078\001\079\001\038\001\039\001\040\001\041\001\042\001\043\001\
\044\001\045\001\046\001\047\001\048\001\049\001\050\001\051\001\
\052\001\053\001\054\001\055\001\056\001\099\001\255\255\255\255\
\255\255\014\001\104\001\105\001\017\001\018\001\255\255\255\255\
\255\255\022\001\255\255\255\255\114\001\255\255\116\001\117\001\
\118\001\119\001\120\001\121\001\122\001\255\255\035\001\036\001\
\126\001\127\001\128\001\255\255\041\001\255\255\255\255\255\255\
\134\001\255\255\255\255\255\255\255\255\255\255\255\255\052\001\
\255\255\255\255\255\255\255\255\057\001\058\001\059\001\060\001\
\061\001\062\001\063\001\064\001\065\001\066\001\067\001\068\001\
\069\001\070\001\071\001\072\001\073\001\074\001\075\001\076\001\
\077\001\078\001\079\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\017\001\255\255\255\255\020\001\255\255\099\001\255\255\
\101\001\025\001\103\001\104\001\255\255\255\255\030\001\108\001\
\255\255\255\255\255\255\112\001\036\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\129\001\255\255\255\255\132\001\
\255\255\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\071\001\
\072\001\073\001\074\001\075\001\076\001\077\001\078\001\079\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\097\001\255\255\099\001\255\255\101\001\255\255\103\001\
\104\001\105\001\255\255\255\255\255\255\255\255\255\255\255\255\
\017\001\255\255\114\001\020\001\255\255\255\255\255\255\255\255\
\025\001\255\255\255\255\255\255\255\255\030\001\126\001\127\001\
\128\001\129\001\255\255\036\001\255\255\255\255\134\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\057\001\058\001\059\001\060\001\061\001\062\001\063\001\064\001\
\065\001\066\001\067\001\068\001\069\001\070\001\071\001\072\001\
\073\001\074\001\075\001\076\001\077\001\078\001\079\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\015\001\255\255\017\001\
\097\001\019\001\099\001\255\255\101\001\255\255\103\001\104\001\
\105\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\114\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\126\001\127\001\128\001\
\129\001\255\255\255\255\255\255\255\255\134\001\255\255\057\001\
\058\001\059\001\060\001\061\001\062\001\063\001\064\001\065\001\
\066\001\067\001\068\001\069\001\070\001\071\001\072\001\073\001\
\074\001\075\001\076\001\077\001\078\001\079\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\015\001\255\255\
\017\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\099\001\255\255\101\001\255\255\103\001\104\001\255\255\
\255\255\034\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\129\001\
\057\001\058\001\059\001\060\001\061\001\062\001\063\001\064\001\
\065\001\066\001\067\001\068\001\069\001\070\001\071\001\072\001\
\073\001\074\001\075\001\076\001\077\001\078\001\079\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\015\001\
\255\255\017\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\099\001\255\255\101\001\255\255\103\001\104\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\129\001\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\064\001\065\001\066\001\067\001\068\001\069\001\070\001\071\001\
\072\001\073\001\074\001\075\001\076\001\077\001\078\001\079\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\015\001\255\255\017\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\099\001\255\255\101\001\255\255\103\001\
\104\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\129\001\057\001\058\001\059\001\060\001\061\001\062\001\
\063\001\064\001\065\001\066\001\067\001\068\001\069\001\070\001\
\071\001\072\001\073\001\074\001\075\001\076\001\077\001\078\001\
\079\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\016\001\017\001\255\255\255\255\255\255\021\001\
\255\255\255\255\255\255\255\255\099\001\255\255\101\001\255\255\
\103\001\104\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\129\001\057\001\058\001\059\001\060\001\061\001\
\062\001\063\001\064\001\065\001\066\001\067\001\068\001\069\001\
\070\001\071\001\072\001\073\001\074\001\075\001\076\001\077\001\
\078\001\079\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\016\001\017\001\255\255\255\255\255\255\
\021\001\255\255\255\255\255\255\098\001\099\001\255\255\101\001\
\255\255\103\001\104\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\129\001\057\001\058\001\059\001\060\001\
\061\001\062\001\063\001\064\001\065\001\066\001\067\001\068\001\
\069\001\070\001\071\001\072\001\073\001\074\001\075\001\076\001\
\077\001\078\001\079\001\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\017\001\255\255\255\255\
\020\001\255\255\255\255\255\255\255\255\098\001\099\001\255\255\
\101\001\255\255\103\001\104\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\129\001\057\001\058\001\059\001\
\060\001\061\001\062\001\063\001\064\001\065\001\066\001\067\001\
\068\001\069\001\070\001\071\001\072\001\073\001\074\001\075\001\
\076\001\077\001\078\001\079\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\017\001\255\255\
\255\255\020\001\255\255\255\255\255\255\255\255\255\255\099\001\
\255\255\101\001\255\255\103\001\104\001\105\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\114\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\126\001\127\001\128\001\129\001\057\001\058\001\
\059\001\060\001\061\001\062\001\063\001\064\001\065\001\066\001\
\067\001\068\001\069\001\070\001\071\001\072\001\073\001\074\001\
\075\001\076\001\077\001\078\001\079\001\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\099\001\255\255\101\001\255\255\103\001\104\001\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\018\001\255\255\
\255\255\255\255\022\001\255\255\024\001\025\001\026\001\027\001\
\028\001\029\001\030\001\031\001\255\255\255\255\129\001\035\001\
\036\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\044\001\045\001\046\001\047\001\048\001\049\001\050\001\051\001\
\052\001\053\001\054\001\055\001\056\001\018\001\255\255\255\255\
\255\255\022\001\255\255\024\001\025\001\026\001\027\001\028\001\
\029\001\030\001\031\001\255\255\255\255\255\255\035\001\036\001\
\037\001\038\001\039\001\040\001\041\001\042\001\043\001\044\001\
\045\001\046\001\047\001\048\001\049\001\050\001\051\001\052\001\
\053\001\054\001\055\001\056\001\014\001\255\255\255\255\017\001\
\018\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\112\001\255\255\255\255\255\255\
\255\255\255\255\255\255\014\001\255\255\255\255\017\001\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\057\001\
\058\001\059\001\060\001\061\001\062\001\063\001\064\001\065\001\
\066\001\067\001\068\001\112\001\255\255\017\001\255\255\255\255\
\255\255\255\255\076\001\077\001\078\001\079\001\057\001\058\001\
\059\001\060\001\061\001\062\001\063\001\064\001\065\001\066\001\
\067\001\068\001\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\076\001\077\001\078\001\079\001\255\255\104\001\255\255\
\255\255\255\255\255\255\255\255\255\255\057\001\058\001\059\001\
\060\001\061\001\062\001\063\001\064\001\065\001\066\001\067\001\
\068\001\017\001\255\255\255\255\255\255\104\001\074\001\075\001\
\076\001\077\001\078\001\079\001\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\099\001\
\255\255\255\255\255\255\255\255\104\001\255\255\255\255\255\255\
\255\255\057\001\058\001\059\001\060\001\061\001\062\001\063\001\
\064\001\065\001\066\001\067\001\068\001\255\255\255\255\255\255\
\255\255\255\255\074\001\075\001\076\001\077\001\078\001\079\001\
\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\005\001\006\001\007\001\
\008\001\255\255\255\255\099\001\255\255\255\255\014\001\255\255\
\104\001\017\001\018\001\019\001\020\001\021\001\255\255\255\255\
\255\255\025\001\255\255\027\001\028\001\029\001\030\001\031\001\
\255\255\033\001\255\255\035\001\036\001\037\001\038\001\039\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\047\001\
\048\001\049\001\050\001\051\001\052\001\053\001\054\001\055\001\
\056\001\255\255\255\255\255\255\255\255\005\001\006\001\007\001\
\008\001\255\255\255\255\255\255\255\255\255\255\014\001\255\255\
\255\255\017\001\018\001\019\001\020\001\021\001\255\255\255\255\
\255\255\025\001\082\001\027\001\028\001\029\001\030\001\031\001\
\088\001\033\001\255\255\035\001\036\001\037\001\038\001\039\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\047\001\
\048\001\049\001\050\001\051\001\052\001\053\001\054\001\055\001\
\056\001\255\255\255\255\255\255\255\255\005\001\006\001\007\001\
\008\001\255\255\255\255\255\255\255\255\255\255\014\001\255\255\
\255\255\017\001\018\001\019\001\020\001\021\001\255\255\255\255\
\255\255\025\001\082\001\027\001\028\001\029\001\030\001\031\001\
\088\001\033\001\255\255\035\001\255\255\037\001\038\001\039\001\
\040\001\041\001\042\001\043\001\044\001\045\001\046\001\047\001\
\048\001\049\001\050\001\051\001\052\001\053\001\054\001\055\001\
\056\001\255\255\255\255\255\255\255\255\255\255\255\255\255\255\
\255\255\255\255\255\255\255\255\255\255\255\255\018\001\255\255\
\255\255\021\001\022\001\255\255\024\001\025\001\026\001\027\001\
\028\001\255\255\082\001\031\001\255\255\255\255\255\255\035\001\
\088\001\037\001\038\001\039\001\040\001\041\001\042\001\043\001\
\044\001\045\001\046\001\047\001\048\001\049\001\050\001\051\001\
\052\001\053\001\054\001\055\001\056\001"

let yynames_const = "\
  "

let yynames_block = "\
  TUnknown\000\
  TCommentSpace\000\
  TCommentNewline\000\
  TComment\000\
  TInt\000\
  TFloat\000\
  TChar\000\
  TString\000\
  TQuote\000\
  TPct\000\
  TFormat\000\
  TSubString\000\
  TDecimal\000\
  TIdent\000\
  TKRParam\000\
  Tconstructorname\000\
  TypedefIdent\000\
  TOPar\000\
  TCPar\000\
  TOBrace\000\
  TCBrace\000\
  TOCro\000\
  TCCro\000\
  TDot\000\
  TComma\000\
  TPtrOp\000\
  TInc\000\
  TDec\000\
  TAssign\000\
  TEq\000\
  TWhy\000\
  TTilde\000\
  TBang\000\
  TEllipsis\000\
  TDotDot\000\
  TPtVirg\000\
  TOrLog\000\
  TAndLog\000\
  TOr\000\
  TXor\000\
  TAnd\000\
  TEqEq\000\
  TNotEq\000\
  TInf\000\
  TSup\000\
  TInfEq\000\
  TSupEq\000\
  TShl\000\
  TShr\000\
  TPlus\000\
  TMinus\000\
  TMul\000\
  TDiv\000\
  TMod\000\
  TMax\000\
  TMin\000\
  Tchar\000\
  Tshort\000\
  Tint\000\
  Tdouble\000\
  Tfloat\000\
  Tlong\000\
  Tunsigned\000\
  Tsigned\000\
  Tvoid\000\
  Tsize_t\000\
  Tssize_t\000\
  Tptrdiff_t\000\
  Tauto\000\
  Tregister\000\
  Textern\000\
  Tstatic\000\
  Ttypedef\000\
  Tconst\000\
  Tvolatile\000\
  Tstruct\000\
  Tunion\000\
  Tenum\000\
  Tdecimal\000\
  Texec\000\
  Tbreak\000\
  Telse\000\
  Tswitch\000\
  Tcase\000\
  Tcontinue\000\
  Tfor\000\
  Tdo\000\
  Tif\000\
  Twhile\000\
  Treturn\000\
  Tgoto\000\
  Tdefault\000\
  Tsizeof\000\
  Tnew\000\
  Tdelete\000\
  Tdefined\000\
  TOParCplusplusInit\000\
  Tnamespace\000\
  Trestrict\000\
  Tasm\000\
  Tattribute\000\
  TattributeNoarg\000\
  Tinline\000\
  Ttypeof\000\
  TDefine\000\
  TDefParamVariadic\000\
  TCppEscapedNewline\000\
  TCppConcatOp\000\
  TOParDefine\000\
  TOBraceDefineInit\000\
  TIdentDefine\000\
  TDefEOL\000\
  TInclude\000\
  TIncludeStart\000\
  TIncludeFilename\000\
  TIfdef\000\
  TIfdefelif\000\
  TIfdefelse\000\
  TEndif\000\
  TIfdefBool\000\
  TIfdefMisc\000\
  TIfdefVersion\000\
  TUifdef\000\
  TUelseif\000\
  TUendif\000\
  TUndef\000\
  TPragma\000\
  TCppDirectiveOther\000\
  TMacroAttr\000\
  TMacroEndAttr\000\
  TMacroStmt\000\
  TMacroIdentBuilder\000\
  TMacroString\000\
  TMacroDecl\000\
  TMacroDeclConst\000\
  TMacroIterator\000\
  TCommentSkipTagStart\000\
  TCommentSkipTagEnd\000\
  TCParEOL\000\
  TAction\000\
  TCommentMisc\000\
  TCommentCpp\000\
  EOF\000\
  TTODO\000\
  "

let yyact = [|
  (fun _ -> failwith "parser")
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'translation_unit) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 680 "parsing_c/parser_c.mly"
                          ( _1 )
# 3203 "parsing_c/parser_c.ml"
               : Ast_c.program))
; (fun __caml_parser_env ->
    Obj.repr(
# 684 "parsing_c/parser_c.mly"
     ( [] )
# 3209 "parsing_c/parser_c.ml"
               : 'translation_unit))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'translation_unit) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'external_declaration) in
    Obj.repr(
# 686 "parsing_c/parser_c.mly"
     ( !LP._lexer_hint.context_stack <- [LP.InTopLevel]; _1 @ [_2] )
# 3217 "parsing_c/parser_c.ml"
               : 'translation_unit))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : 'translation_unit) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : string * Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : 'translation_unit) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 688 "parsing_c/parser_c.mly"
     ( !LP._lexer_hint.context_stack <- [LP.InTopLevel];
       _1 @ [Namespace (_5, [_2; snd _3; _4; _6])] )
# 3230 "parsing_c/parser_c.ml"
               : 'translation_unit))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 701 "parsing_c/parser_c.mly"
                ( _1 )
# 3237 "parsing_c/parser_c.ml"
               : 'ident))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 702 "parsing_c/parser_c.mly"
                ( _1 )
# 3244 "parsing_c/parser_c.ml"
               : 'ident))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 706 "parsing_c/parser_c.mly"
                ( _1 )
# 3251 "parsing_c/parser_c.ml"
               : 'identifier))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 715 "parsing_c/parser_c.mly"
     ( RegularName (mk_string_wrap _1) )
# 3258 "parsing_c/parser_c.ml"
               : 'identifier_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ident_extra_cpp) in
    Obj.repr(
# 716 "parsing_c/parser_c.mly"
                   ( _1 )
# 3265 "parsing_c/parser_c.ml"
               : 'identifier_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 720 "parsing_c/parser_c.mly"
     ( RegularName (mk_string_wrap _1) )
# 3272 "parsing_c/parser_c.ml"
               : 'ident_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 722 "parsing_c/parser_c.mly"
     ( RegularName (mk_string_wrap _1) )
# 3279 "parsing_c/parser_c.ml"
               : 'ident_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ident_extra_cpp) in
    Obj.repr(
# 723 "parsing_c/parser_c.mly"
                   ( _1 )
# 3286 "parsing_c/parser_c.ml"
               : 'ident_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'identifier_cpp_list) in
    Obj.repr(
# 727 "parsing_c/parser_c.mly"
     (
       CppConcatenatedName (
         match _3 with
         | [] -> raise (Impossible 87)
         | (x,concatnull)::xs ->
             assert (concatnull = []);
             (mk_string_wrap _1, [])::(x,[_2])::xs
       )
   )
# 3303 "parsing_c/parser_c.ml"
               : 'ident_extra_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 737 "parsing_c/parser_c.mly"
     ( CppVariadicName (fst _2, [_1; snd _2]) )
# 3311 "parsing_c/parser_c.ml"
               : 'ident_extra_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : (string * Ast_c.info)) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'param_define_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 739 "parsing_c/parser_c.mly"
     ( CppIdentBuilder ((fst _1, [snd _1;_2;_4]), _3) )
# 3321 "parsing_c/parser_c.ml"
               : 'ident_extra_cpp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 742 "parsing_c/parser_c.mly"
          ( [mk_string_wrap _1, []] )
# 3328 "parsing_c/parser_c.ml"
               : 'identifier_cpp_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'identifier_cpp_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 743 "parsing_c/parser_c.mly"
                                           ( _1 @ [mk_string_wrap _3, [_2]] )
# 3337 "parsing_c/parser_c.ml"
               : 'identifier_cpp_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 750 "parsing_c/parser_c.mly"
                           ( _1 )
# 3344 "parsing_c/parser_c.ml"
               : Ast_c.expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 751 "parsing_c/parser_c.mly"
                           ( mk_e (Sequence (_1,_3)) [_2] )
# 3353 "parsing_c/parser_c.ml"
               : Ast_c.expression))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cond_expr) in
    Obj.repr(
# 757 "parsing_c/parser_c.mly"
                                 ( _1 )
# 3360 "parsing_c/parser_c.ml"
               : 'assign_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'cast_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.assignOp) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 758 "parsing_c/parser_c.mly"
                                 ( mk_e(Assignment (_1, _2, _3)) [])
# 3369 "parsing_c/parser_c.ml"
               : 'assign_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'cast_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 759 "parsing_c/parser_c.mly"
                                 ( mk_e (Assignment (_1, (SimpleAssign, [_2]),_3)) [])
# 3378 "parsing_c/parser_c.ml"
               : 'assign_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 767 "parsing_c/parser_c.mly"
     ( _1 )
# 3385 "parsing_c/parser_c.ml"
               : 'cond_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'gcc_opt_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 769 "parsing_c/parser_c.mly"
     ( mk_e (CondExpr (_1,_3,_5)) [_2;_4] )
# 3396 "parsing_c/parser_c.ml"
               : 'cond_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cast_expr) in
    Obj.repr(
# 773 "parsing_c/parser_c.mly"
                                 ( _1 )
# 3403 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 774 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Mul,[_2]), _3)) [] )
# 3412 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 775 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Div, [_2]), _3)) [] )
# 3421 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 776 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Min, [_2]), _3)) [] )
# 3430 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 777 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Max, [_2]), _3)) [] )
# 3439 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 778 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Mod, [_2]), _3)) [] )
# 3448 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 779 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Plus, [_2]), _3)) [] )
# 3457 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 780 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Minus, [_2]), _3)) [] )
# 3466 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 781 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith DecLeft, [_2]), _3)) [] )
# 3475 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 782 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith DecRight, [_2]), _3)) [] )
# 3484 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 783 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical Inf, [_2]), _3)) [] )
# 3493 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 784 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical Sup, [_2]), _3)) [] )
# 3502 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 785 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical InfEq, [_2]), _3)) [] )
# 3511 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 786 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical SupEq, [_2]), _3)) [] )
# 3520 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 787 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical Eq, [_2]), _3)) [] )
# 3529 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 788 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical NotEq, [_2]), _3)) [] )
# 3538 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 789 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith And, [_2]), _3)) [] )
# 3547 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 790 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Or, [_2]), _3)) [] )
# 3556 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 791 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Arith Xor, [_2]), _3)) [] )
# 3565 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 792 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical AndLog, [_2]), _3)) [] )
# 3574 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'arith_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'arith_expr) in
    Obj.repr(
# 793 "parsing_c/parser_c.mly"
                                 ( mk_e(Binary (_1, (Logical OrLog, [_2]), _3)) [] )
# 3583 "parsing_c/parser_c.ml"
               : 'arith_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'unary_expr) in
    Obj.repr(
# 796 "parsing_c/parser_c.mly"
                                     ( _1 )
# 3590 "parsing_c/parser_c.ml"
               : 'cast_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'topar2) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.fullType) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'tcpar2) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'cast_expr) in
    Obj.repr(
# 797 "parsing_c/parser_c.mly"
                                     ( mk_e(Cast (_2, _4)) [_1;_3] )
# 3600 "parsing_c/parser_c.ml"
               : 'cast_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'postfix_expr) in
    Obj.repr(
# 805 "parsing_c/parser_c.mly"
                                   ( _1 )
# 3607 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'unary_expr) in
    Obj.repr(
# 806 "parsing_c/parser_c.mly"
                                   ( mk_e(Infix (_2, Inc))    [_1] )
# 3615 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'unary_expr) in
    Obj.repr(
# 807 "parsing_c/parser_c.mly"
                                   ( mk_e(Infix (_2, Dec))    [_1] )
# 3623 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'unary_op) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'cast_expr) in
    Obj.repr(
# 808 "parsing_c/parser_c.mly"
                                   ( mk_e(Unary (_2, fst _1)) [snd _1] )
# 3631 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'unary_expr) in
    Obj.repr(
# 809 "parsing_c/parser_c.mly"
                                   ( mk_e(SizeOfExpr (_2))    [_1] )
# 3639 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'topar2) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.fullType) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar2) in
    Obj.repr(
# 810 "parsing_c/parser_c.mly"
                                   ( mk_e(SizeOfType (_3))    [_1;_2;_4] )
# 3649 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'new_argument) in
    Obj.repr(
# 811 "parsing_c/parser_c.mly"
                                   ( mk_e(New (None, _2))     [_1] )
# 3657 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list_ne) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'new_argument) in
    Obj.repr(
# 812 "parsing_c/parser_c.mly"
                                                  ( mk_e(New (Some _3, _5))             [_1; _2; _4] )
# 3668 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'cast_expr) in
    Obj.repr(
# 813 "parsing_c/parser_c.mly"
                                   ( mk_e(Delete(false, _2))  [_1] )
# 3676 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'cast_expr) in
    Obj.repr(
# 814 "parsing_c/parser_c.mly"
                                   ( mk_e(Delete(true, _4))   [_1;_2;_3] )
# 3686 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'identifier_cpp) in
    Obj.repr(
# 815 "parsing_c/parser_c.mly"
                                   ( mk_e(Defined _2)         [_1] )
# 3694 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'identifier_cpp) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 817 "parsing_c/parser_c.mly"
 ( mk_e(Defined _3) [_1;_2;_4] )
# 3704 "parsing_c/parser_c.ml"
               : 'unary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list_ne) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 821 "parsing_c/parser_c.mly"
     ( let fn = mk_e(Ident (RegularName (mk_string_wrap _1))) [] in
       Left (mk_e(FunCall (fn, _3)) [_2;_4]) )
# 3715 "parsing_c/parser_c.ml"
               : 'new_argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 824 "parsing_c/parser_c.mly"
     ( let fn = mk_e(Ident (RegularName (mk_string_wrap _1))) [] in
       Left(mk_e(FunCall (fn, [])) [_2;_3]) )
# 3725 "parsing_c/parser_c.ml"
               : 'new_argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list_ne) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 827 "parsing_c/parser_c.mly"
     ( let fn = mk_e(Ident (RegularName (mk_string_wrap _1))) [] in
       Left (mk_e(FunCall (fn, _3)) [_2;_4]) )
# 3736 "parsing_c/parser_c.ml"
               : 'new_argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 830 "parsing_c/parser_c.mly"
     ( let fn = mk_e(Ident (RegularName (mk_string_wrap _1))) [] in
       Left (mk_e(FunCall (fn, [])) [_2;_3]) )
# 3746 "parsing_c/parser_c.ml"
               : 'new_argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_spec) in
    Obj.repr(
# 833 "parsing_c/parser_c.mly"
     ( let ty = addTypeD (_1,nullDecl) in
       let ((returnType,hasreg), iihasreg) = fixDeclSpecForParam ty in
       Right (ArgType { p_namei = None; p_type = returnType;
			p_register = hasreg, iihasreg;
		      } )
     )
# 3758 "parsing_c/parser_c.ml"
               : 'new_argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'new_argument) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.expression) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 840 "parsing_c/parser_c.mly"
     (
       match _1 with
	 Left(e) -> Left(mk_e(ArrayAccess (e, _3)) [_2;_4])
       | Right(ArgType(ty)) -> (* lots of hacks to make the right type *)
	   let fty = mk_ty (Array (Some _3, ty.Ast_c.p_type)) [_2;_4] in
	   let pty = { ty with p_type = fty } in
	   Right(ArgType pty)
       | _ -> raise (Impossible 88)
     )
# 3776 "parsing_c/parser_c.ml"
               : 'new_argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 851 "parsing_c/parser_c.mly"
          ( GetRef,     _1 )
# 3783 "parsing_c/parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 852 "parsing_c/parser_c.mly"
          ( DeRef,      _1 )
# 3790 "parsing_c/parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 853 "parsing_c/parser_c.mly"
          ( UnPlus,     _1 )
# 3797 "parsing_c/parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 854 "parsing_c/parser_c.mly"
          ( UnMinus,    _1 )
# 3804 "parsing_c/parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 855 "parsing_c/parser_c.mly"
          ( Tilde,      _1 )
# 3811 "parsing_c/parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 856 "parsing_c/parser_c.mly"
          ( Not,        _1 )
# 3818 "parsing_c/parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 860 "parsing_c/parser_c.mly"
           ( GetRefLabel, _1 )
# 3825 "parsing_c/parser_c.ml"
               : 'unary_op))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'primary_expr) in
    Obj.repr(
# 863 "parsing_c/parser_c.mly"
                              ( _1 )
# 3832 "parsing_c/parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.expression) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 865 "parsing_c/parser_c.mly"
     ( mk_e(ArrayAccess (_1, _3)) [_2;_4] )
# 3842 "parsing_c/parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list_ne) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 867 "parsing_c/parser_c.mly"
     ( mk_e(FunCall (_1, _3)) [_2;_4] )
# 3852 "parsing_c/parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 868 "parsing_c/parser_c.mly"
                              ( mk_e(FunCall (_1, [])) [_2;_3] )
# 3861 "parsing_c/parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'ident_cpp) in
    Obj.repr(
# 869 "parsing_c/parser_c.mly"
                                 ( mk_e(RecordAccess   (_1,_3)) [_2] )
# 3870 "parsing_c/parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'ident_cpp) in
    Obj.repr(
# 870 "parsing_c/parser_c.mly"
                                 ( mk_e(RecordPtAccess (_1,_3)) [_2] )
# 3879 "parsing_c/parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 871 "parsing_c/parser_c.mly"
                              ( mk_e(Postfix (_1, Inc)) [_2] )
# 3887 "parsing_c/parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'postfix_expr) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 872 "parsing_c/parser_c.mly"
                              ( mk_e(Postfix (_1, Dec)) [_2] )
# 3895 "parsing_c/parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'topar2) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.fullType) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'tcpar2) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 876 "parsing_c/parser_c.mly"
     ( mk_e(Constructor (_2, (InitList [], [_4;_5]))) [_1;_3] )
# 3906 "parsing_c/parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : 'topar2) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.fullType) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : 'tcpar2) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : 'initialize_list) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : 'gcc_comma_opt_struct) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 878 "parsing_c/parser_c.mly"
     ( mk_e(Constructor (_2, (InitList (List.rev _5),[_4;_7] @ _6))) [_1;_3] )
# 3919 "parsing_c/parser_c.ml"
               : 'postfix_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'identifier_cpp) in
    Obj.repr(
# 882 "parsing_c/parser_c.mly"
                   ( mk_e(Ident  (_1)) [] )
# 3926 "parsing_c/parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * (Ast_c.sign * Ast_c.base)) * Ast_c.info) in
    Obj.repr(
# 884 "parsing_c/parser_c.mly"
    ( let (str,(sign,base)) = fst _1 in
      mk_e(Constant (Int (str,Si(sign,base)))) [snd _1] )
# 3934 "parsing_c/parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.floatType) * Ast_c.info) in
    Obj.repr(
# 886 "parsing_c/parser_c.mly"
           ( mk_e(Constant (Float  (fst _1))) [snd _1] )
# 3941 "parsing_c/parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 887 "parsing_c/parser_c.mly"
           ( mk_e(Constant (String (fst _1))) [snd _1] )
# 3948 "parsing_c/parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : (string * Ast_c.isWchar) * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'string_fragments) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 889 "parsing_c/parser_c.mly"
     ( let ((fullstring,isW),lqinfo) = _1 in
       let (_,rqinfo) = _3 in
       mk_e (Ast_c.StringConstant(_2, fullstring, isW)) [lqinfo;rqinfo] )
# 3959 "parsing_c/parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 892 "parsing_c/parser_c.mly"
           ( mk_e(Constant (Char   (fst _1))) [snd _1] )
# 3966 "parsing_c/parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * string (*n*) * string (*p*)) * Ast_c.info) in
    Obj.repr(
# 893 "parsing_c/parser_c.mly"
            ( let (a,b,c) = fst _1 in
              mk_e(Constant (DecimalConst (a,b,c))) [snd _1] )
# 3974 "parsing_c/parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 895 "parsing_c/parser_c.mly"
                    ( mk_e(ParenExpr (_2)) [_1;_3] )
# 3983 "parsing_c/parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 898 "parsing_c/parser_c.mly"
                ( mk_e(Constant (MultiString [fst _1])) [snd _1] )
# 3990 "parsing_c/parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'string_elem) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'string_list) in
    Obj.repr(
# 900 "parsing_c/parser_c.mly"
     ( mk_e(Constant (MultiString ["TODO: MultiString"])) (_1 @ _2) )
# 3998 "parsing_c/parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'compound) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 903 "parsing_c/parser_c.mly"
                         ( mk_e(StatementExpr (_2)) [_1;_3] )
# 4007 "parsing_c/parser_c.ml"
               : 'primary_expr))
; (fun __caml_parser_env ->
    Obj.repr(
# 906 "parsing_c/parser_c.mly"
               ( [] )
# 4013 "parsing_c/parser_c.ml"
               : 'string_fragments))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'string_fragment) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'string_fragments) in
    Obj.repr(
# 907 "parsing_c/parser_c.mly"
                                    ( _1 :: _2 )
# 4021 "parsing_c/parser_c.ml"
               : 'string_fragments))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'string_format) in
    Obj.repr(
# 910 "parsing_c/parser_c.mly"
                      ( Ast_c.FormatFragment(_2), [_1] )
# 4029 "parsing_c/parser_c.ml"
               : 'string_fragment))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 911 "parsing_c/parser_c.mly"
              ( Ast_c.ConstantFragment(fst _1), [snd _1] )
# 4036 "parsing_c/parser_c.ml"
               : 'string_fragment))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 914 "parsing_c/parser_c.mly"
           ( Ast_c.ConstantFormat(fst _1), [snd _1] )
# 4043 "parsing_c/parser_c.ml"
               : 'string_format))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 923 "parsing_c/parser_c.mly"
               ( Left _1 )
# 4050 "parsing_c/parser_c.ml"
               : 'argument_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_decl) in
    Obj.repr(
# 924 "parsing_c/parser_c.mly"
                  ( Right (ArgType _1)  )
# 4057 "parsing_c/parser_c.ml"
               : 'argument_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'action_higherordermacro_ne) in
    Obj.repr(
# 925 "parsing_c/parser_c.mly"
                              ( Right (ArgAction _1) )
# 4064 "parsing_c/parser_c.ml"
               : 'argument_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 929 "parsing_c/parser_c.mly"
               ( Left _1 )
# 4071 "parsing_c/parser_c.ml"
               : 'argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_decl) in
    Obj.repr(
# 930 "parsing_c/parser_c.mly"
                  ( Right (ArgType _1)  )
# 4078 "parsing_c/parser_c.ml"
               : 'argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'action_higherordermacro) in
    Obj.repr(
# 932 "parsing_c/parser_c.mly"
                           ( Right (ArgAction _1) )
# 4085 "parsing_c/parser_c.ml"
               : 'argument))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'taction_list_ne) in
    Obj.repr(
# 936 "parsing_c/parser_c.mly"
     ( if _1=[]
       then ActMisc [Ast_c.fakeInfo()]
       else ActMisc _1
     )
# 4095 "parsing_c/parser_c.ml"
               : 'action_higherordermacro_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'taction_list) in
    Obj.repr(
# 944 "parsing_c/parser_c.mly"
     ( if _1=[]
       then ActMisc [Ast_c.fakeInfo()]
       else ActMisc _1
     )
# 4105 "parsing_c/parser_c.ml"
               : 'action_higherordermacro))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cond_expr) in
    Obj.repr(
# 955 "parsing_c/parser_c.mly"
                      ( _1  )
# 4112 "parsing_c/parser_c.ml"
               : 'const_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 958 "parsing_c/parser_c.mly"
              ( et "topar2" (); _1  )
# 4119 "parsing_c/parser_c.ml"
               : 'topar2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 959 "parsing_c/parser_c.mly"
              ( et "tcpar2" (); _1 (*TODO? et ? sure ? c pas dt plutot ? *) )
# 4126 "parsing_c/parser_c.ml"
               : 'tcpar2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'statement2) in
    Obj.repr(
# 967 "parsing_c/parser_c.mly"
                      ( mk_st (fst _1) (snd _1) )
# 4133 "parsing_c/parser_c.ml"
               : Ast_c.statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'labeled) in
    Obj.repr(
# 970 "parsing_c/parser_c.mly"
                   ( Labeled      (fst _1), snd _1 )
# 4140 "parsing_c/parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'compound) in
    Obj.repr(
# 971 "parsing_c/parser_c.mly"
                   ( Compound     (fst _1), snd _1 )
# 4147 "parsing_c/parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'expr_statement) in
    Obj.repr(
# 972 "parsing_c/parser_c.mly"
                   ( ExprStatement(fst _1), snd _1 )
# 4154 "parsing_c/parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'selection) in
    Obj.repr(
# 973 "parsing_c/parser_c.mly"
                   ( Selection    (fst _1), snd _1 @ [fakeInfo()] )
# 4161 "parsing_c/parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'iteration) in
    Obj.repr(
# 974 "parsing_c/parser_c.mly"
                   ( Iteration    (fst _1), snd _1 @ [fakeInfo()] )
# 4168 "parsing_c/parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'jump) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 975 "parsing_c/parser_c.mly"
                   ( Jump         (fst _1), snd _1 @ [_2] )
# 4176 "parsing_c/parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'asmbody) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 978 "parsing_c/parser_c.mly"
                                                ( Asm _3, [_1;_2;_4;_5] )
# 4187 "parsing_c/parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'asmbody) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 979 "parsing_c/parser_c.mly"
                                                ( Asm _4, [_1;_2;_3;_5;_6] )
# 4199 "parsing_c/parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 982 "parsing_c/parser_c.mly"
              ( MacroStmt, [snd _1] )
# 4206 "parsing_c/parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'identifier) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'exec_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 984 "parsing_c/parser_c.mly"
                                      ( Exec(_3), [_1;snd _2;_4] )
# 4216 "parsing_c/parser_c.ml"
               : 'statement2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'ident_cpp) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'sw_stat_or_decl) in
    Obj.repr(
# 991 "parsing_c/parser_c.mly"
                                              ( Label (_1, _3),  [_2] )
# 4225 "parsing_c/parser_c.ml"
               : 'labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'const_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'sw_stat_or_decl) in
    Obj.repr(
# 992 "parsing_c/parser_c.mly"
                                              ( Case (_2, _4),       [_1; _3] )
# 4235 "parsing_c/parser_c.ml"
               : 'labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : 'const_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'const_expr) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : 'sw_stat_or_decl) in
    Obj.repr(
# 994 "parsing_c/parser_c.mly"
     ( CaseRange (_2, _4, _6), [_1;_3;_5] )
# 4247 "parsing_c/parser_c.ml"
               : 'labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'sw_stat_or_decl) in
    Obj.repr(
# 995 "parsing_c/parser_c.mly"
                                         ( Default _3,             [_1; _2] )
# 4256 "parsing_c/parser_c.ml"
               : 'labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl) in
    Obj.repr(
# 998 "parsing_c/parser_c.mly"
             ( mk_st (Decl (_1 Ast_c.LocalDecl)) Ast_c.noii )
# 4263 "parsing_c/parser_c.ml"
               : 'sw_stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 999 "parsing_c/parser_c.mly"
             ( _1 )
# 4270 "parsing_c/parser_c.ml"
               : 'sw_stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'ident_cpp) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1010 "parsing_c/parser_c.mly"
     ( Label (_1, (mk_st (ExprStatement None) Ast_c.noii)), [_2] )
# 4278 "parsing_c/parser_c.ml"
               : 'end_labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1012 "parsing_c/parser_c.mly"
     ( Case (_2, (mk_st (ExprStatement None) Ast_c.noii)), [_1;_3] )
# 4287 "parsing_c/parser_c.ml"
               : 'end_labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1014 "parsing_c/parser_c.mly"
     ( Default (mk_st (ExprStatement None) Ast_c.noii),    [_1; _2] )
# 4295 "parsing_c/parser_c.ml"
               : 'end_labeled))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'tobrace) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'compound2) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace) in
    Obj.repr(
# 1020 "parsing_c/parser_c.mly"
                                    ( _2, [_1; _3]  )
# 4304 "parsing_c/parser_c.ml"
               : 'compound))
; (fun __caml_parser_env ->
    Obj.repr(
# 1032 "parsing_c/parser_c.mly"
                     ( ([]) )
# 4310 "parsing_c/parser_c.ml"
               : 'compound2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'stat_or_decl_list) in
    Obj.repr(
# 1033 "parsing_c/parser_c.mly"
                     ( _1 )
# 4317 "parsing_c/parser_c.ml"
               : 'compound2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'stat_or_decl) in
    Obj.repr(
# 1037 "parsing_c/parser_c.mly"
                                  ( [_1] )
# 4324 "parsing_c/parser_c.ml"
               : 'stat_or_decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'end_labeled) in
    Obj.repr(
# 1039 "parsing_c/parser_c.mly"
                ( [StmtElem (mk_st (Labeled  (fst _1)) (snd _1))] )
# 4331 "parsing_c/parser_c.ml"
               : 'stat_or_decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'stat_or_decl) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'stat_or_decl_list) in
    Obj.repr(
# 1041 "parsing_c/parser_c.mly"
                                  ( _1 :: _2 )
# 4339 "parsing_c/parser_c.ml"
               : 'stat_or_decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl) in
    Obj.repr(
# 1044 "parsing_c/parser_c.mly"
             ( StmtElem (mk_st (Decl (_1 Ast_c.LocalDecl)) Ast_c.noii) )
# 4346 "parsing_c/parser_c.ml"
               : 'stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1045 "parsing_c/parser_c.mly"
             ( StmtElem _1 )
# 4353 "parsing_c/parser_c.ml"
               : 'stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'function_definition) in
    Obj.repr(
# 1048 "parsing_c/parser_c.mly"
                       ( StmtElem (mk_st (NestedFunc _1) Ast_c.noii) )
# 4360 "parsing_c/parser_c.ml"
               : 'stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_directive) in
    Obj.repr(
# 1052 "parsing_c/parser_c.mly"
     ( CppDirectiveStmt _1 )
# 4367 "parsing_c/parser_c.ml"
               : 'stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_directive) in
    Obj.repr(
# 1054 "parsing_c/parser_c.mly"
     ( IfdefStmt _1 )
# 4374 "parsing_c/parser_c.ml"
               : 'stat_or_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1058 "parsing_c/parser_c.mly"
                ( None,    [_1] )
# 4381 "parsing_c/parser_c.ml"
               : 'expr_statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.expression) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1059 "parsing_c/parser_c.mly"
                ( Some _1, [_2] )
# 4389 "parsing_c/parser_c.ml"
               : 'expr_statement))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1063 "parsing_c/parser_c.mly"
     ( If (_3, _5, (mk_st (ExprStatement None) Ast_c.noii)),   [_1;_2;_4] )
# 4400 "parsing_c/parser_c.ml"
               : 'selection))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.expression) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.statement) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1065 "parsing_c/parser_c.mly"
     ( If (_3, _5, _7),  [_1;_2;_4;_6] )
# 4413 "parsing_c/parser_c.ml"
               : 'selection))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1067 "parsing_c/parser_c.mly"
     ( Switch (_3,_5),   [_1;_2;_4]  )
# 4424 "parsing_c/parser_c.ml"
               : 'selection))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 8 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 7 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.expression) in
    let _5 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.statement) in
    let _7 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _8 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _9 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1070 "parsing_c/parser_c.mly"
     ( Ifdef_Ite (_4,_6,_9), [_1;_2;_3;_5;_7;_8] )
# 4439 "parsing_c/parser_c.ml"
               : 'selection))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 10 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 9 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 8 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 7 : Ast_c.expression) in
    let _5 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.statement) in
    let _7 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _8 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _9 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.statement) in
    let _10 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _11 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1073 "parsing_c/parser_c.mly"
     ( Ifdef_Ite2 (_4,_6,_9,_11), [_1;_2;_3;_5;_7;_8;_10] )
# 4456 "parsing_c/parser_c.ml"
               : 'selection))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1077 "parsing_c/parser_c.mly"
     ( While (_3,_5),                [_1;_2;_4] )
# 4467 "parsing_c/parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.statement) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1079 "parsing_c/parser_c.mly"
     ( DoWhile (_2,_5),              [_1;_3;_4;_6;_7] )
# 4480 "parsing_c/parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : 'expr_statement) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'expr_statement) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1081 "parsing_c/parser_c.mly"
     ( For (ForExp _3,_4,(None, []),_6),    [_1;_2;_5])
# 4492 "parsing_c/parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : 'expr_statement) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : 'expr_statement) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1083 "parsing_c/parser_c.mly"
     ( For (ForExp _3,_4,(Some _5, []),_7), [_1;_2;_6] )
# 4505 "parsing_c/parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : 'decl) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'expr_statement) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1086 "parsing_c/parser_c.mly"
     ( For (ForDecl (_3 Ast_c.LocalDecl),_4,(None, []),_6),    [_1;_2;_5])
# 4517 "parsing_c/parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : 'decl) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : 'expr_statement) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1088 "parsing_c/parser_c.mly"
     ( For (ForDecl (_3 Ast_c.LocalDecl),_4,(Some _5, []),_7), [_1;_2;_6] )
# 4530 "parsing_c/parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : (string * Ast_c.info)) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list_ne) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1091 "parsing_c/parser_c.mly"
     ( MacroIteration (fst _1, _3, _5), [snd _1;_2;_4] )
# 4541 "parsing_c/parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : (string * Ast_c.info)) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1093 "parsing_c/parser_c.mly"
     ( MacroIteration (fst _1, [], _4), [snd _1;_2;_3] )
# 4551 "parsing_c/parser_c.ml"
               : 'iteration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'ident_cpp) in
    Obj.repr(
# 1097 "parsing_c/parser_c.mly"
                    ( Goto (_2),  [_1] )
# 4559 "parsing_c/parser_c.ml"
               : 'jump))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1098 "parsing_c/parser_c.mly"
                ( Continue,       [_1] )
# 4566 "parsing_c/parser_c.ml"
               : 'jump))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1099 "parsing_c/parser_c.mly"
                ( Break,          [_1] )
# 4573 "parsing_c/parser_c.ml"
               : 'jump))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1100 "parsing_c/parser_c.mly"
                ( Return,         [_1] )
# 4580 "parsing_c/parser_c.ml"
               : 'jump))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.expression) in
    Obj.repr(
# 1101 "parsing_c/parser_c.mly"
                ( ReturnExpr _2,  [_1] )
# 4588 "parsing_c/parser_c.ml"
               : 'jump))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.expression) in
    Obj.repr(
# 1102 "parsing_c/parser_c.mly"
                   ( GotoComputed _3, [_1;_2] )
# 4597 "parsing_c/parser_c.ml"
               : 'jump))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 1110 "parsing_c/parser_c.mly"
           ( [snd _1] )
# 4604 "parsing_c/parser_c.ml"
               : 'string_elem))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 1112 "parsing_c/parser_c.mly"
                ( [snd _1] )
# 4611 "parsing_c/parser_c.ml"
               : 'string_elem))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'string_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'colon_asm_list) in
    Obj.repr(
# 1116 "parsing_c/parser_c.mly"
                               ( _1, _2 )
# 4619 "parsing_c/parser_c.ml"
               : 'asmbody))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'string_list) in
    Obj.repr(
# 1117 "parsing_c/parser_c.mly"
               ( _1, [] )
# 4626 "parsing_c/parser_c.ml"
               : 'asmbody))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'colon_option_list) in
    Obj.repr(
# 1120 "parsing_c/parser_c.mly"
                                     ( Colon _2, [_1]   )
# 4634 "parsing_c/parser_c.ml"
               : 'colon_asm))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 1123 "parsing_c/parser_c.mly"
                                ( ColonMisc, [snd _1] )
# 4641 "parsing_c/parser_c.ml"
               : 'colon_option))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : (string * Ast_c.isWchar) * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'asm_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1124 "parsing_c/parser_c.mly"
                                ( ColonExpr _3, [snd _1; _2;_4] )
# 4651 "parsing_c/parser_c.ml"
               : 'colon_option))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : 'identifier) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : (string * Ast_c.isWchar) * Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : 'asm_expr) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1127 "parsing_c/parser_c.mly"
     ( ColonExpr _6, [_1;snd _2;_3;snd _4; _5; _7 ] )
# 4664 "parsing_c/parser_c.ml"
               : 'colon_option))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'identifier) in
    Obj.repr(
# 1128 "parsing_c/parser_c.mly"
                                    ( ColonMisc, [snd _1] )
# 4671 "parsing_c/parser_c.ml"
               : 'colon_option))
; (fun __caml_parser_env ->
    Obj.repr(
# 1129 "parsing_c/parser_c.mly"
                                    ( ColonMisc, [] )
# 4677 "parsing_c/parser_c.ml"
               : 'colon_option))
; (fun __caml_parser_env ->
    Obj.repr(
# 1133 "parsing_c/parser_c.mly"
                ( [] )
# 4683 "parsing_c/parser_c.ml"
               : 'exec_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'identifier_cpp) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'exec_ident) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'exec_list) in
    Obj.repr(
# 1135 "parsing_c/parser_c.mly"
      ( (ExecEval (_3 (mk_e (Ident _2) [])), [_1]) :: _4 )
# 4693 "parsing_c/parser_c.ml"
               : 'exec_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'exec_ident2) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'exec_list) in
    Obj.repr(
# 1137 "parsing_c/parser_c.mly"
      ( (ExecToken, [snd _1]) :: _2 @ _3 )
# 4702 "parsing_c/parser_c.ml"
               : 'exec_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'token) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'exec_list) in
    Obj.repr(
# 1138 "parsing_c/parser_c.mly"
                    ( (ExecToken, [_1]) :: _2 )
# 4710 "parsing_c/parser_c.ml"
               : 'exec_list))
; (fun __caml_parser_env ->
    Obj.repr(
# 1141 "parsing_c/parser_c.mly"
    ( function prev -> prev )
# 4716 "parsing_c/parser_c.ml"
               : 'exec_ident))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : string * Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'exec_ident) in
    Obj.repr(
# 1143 "parsing_c/parser_c.mly"
     ( function prev ->
       let fld = RegularName (mk_string_wrap _2) in
       _3 (mk_e(RecordAccess   (prev,fld)) [_1]) )
# 4727 "parsing_c/parser_c.ml"
               : 'exec_ident))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : string * Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'exec_ident) in
    Obj.repr(
# 1147 "parsing_c/parser_c.mly"
     ( function prev ->
       let fld = RegularName (mk_string_wrap _2) in
       _3 (mk_e(RecordPtAccess   (prev,fld)) [_1]) )
# 4738 "parsing_c/parser_c.ml"
               : 'exec_ident))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.expression) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'exec_ident) in
    Obj.repr(
# 1151 "parsing_c/parser_c.mly"
     ( function prev ->
       _4 (mk_e(ArrayAccess   (prev,_2)) [_1;_3]) )
# 4749 "parsing_c/parser_c.ml"
               : 'exec_ident))
; (fun __caml_parser_env ->
    Obj.repr(
# 1155 "parsing_c/parser_c.mly"
    ( [] )
# 4755 "parsing_c/parser_c.ml"
               : 'exec_ident2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : string * Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'exec_ident2) in
    Obj.repr(
# 1157 "parsing_c/parser_c.mly"
    ( (ExecToken, [_1]) :: (ExecToken, [snd _2]) :: _3 )
# 4764 "parsing_c/parser_c.ml"
               : 'exec_ident2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 1159 "parsing_c/parser_c.mly"
                      ( _1 )
# 4771 "parsing_c/parser_c.ml"
               : 'asm_expr))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1162 "parsing_c/parser_c.mly"
            ( _1 )
# 4778 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1163 "parsing_c/parser_c.mly"
            ( _1 )
# 4785 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1164 "parsing_c/parser_c.mly"
            ( _1 )
# 4792 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1165 "parsing_c/parser_c.mly"
            ( _1 )
# 4799 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1166 "parsing_c/parser_c.mly"
            ( _1 )
# 4806 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1167 "parsing_c/parser_c.mly"
            ( _1 )
# 4813 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1168 "parsing_c/parser_c.mly"
            ( _1 )
# 4820 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1169 "parsing_c/parser_c.mly"
            ( _1 )
# 4827 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1170 "parsing_c/parser_c.mly"
            ( _1 )
# 4834 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1171 "parsing_c/parser_c.mly"
            ( _1 )
# 4841 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.assignOp) in
    Obj.repr(
# 1172 "parsing_c/parser_c.mly"
            ( List.hd (snd _1) )
# 4848 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1174 "parsing_c/parser_c.mly"
            ( _1 )
# 4855 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1175 "parsing_c/parser_c.mly"
            ( _1 )
# 4862 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1176 "parsing_c/parser_c.mly"
            ( _1 )
# 4869 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1177 "parsing_c/parser_c.mly"
            ( _1 )
# 4876 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1178 "parsing_c/parser_c.mly"
            ( _1 )
# 4883 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1179 "parsing_c/parser_c.mly"
            ( _1 )
# 4890 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1181 "parsing_c/parser_c.mly"
            ( _1 )
# 4897 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1182 "parsing_c/parser_c.mly"
            ( _1 )
# 4904 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1183 "parsing_c/parser_c.mly"
            ( _1 )
# 4911 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1184 "parsing_c/parser_c.mly"
            ( _1 )
# 4918 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1185 "parsing_c/parser_c.mly"
            ( _1 )
# 4925 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1186 "parsing_c/parser_c.mly"
            ( _1 )
# 4932 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1187 "parsing_c/parser_c.mly"
            ( _1 )
# 4939 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1189 "parsing_c/parser_c.mly"
            ( _1 )
# 4946 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1190 "parsing_c/parser_c.mly"
            ( _1 )
# 4953 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1193 "parsing_c/parser_c.mly"
            ( _1 )
# 4960 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1194 "parsing_c/parser_c.mly"
            ( _1 )
# 4967 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1198 "parsing_c/parser_c.mly"
            ( _1 )
# 4974 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1199 "parsing_c/parser_c.mly"
            ( _1 )
# 4981 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1200 "parsing_c/parser_c.mly"
            ( _1 )
# 4988 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 1202 "parsing_c/parser_c.mly"
                 ( snd _1 )
# 4995 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1204 "parsing_c/parser_c.mly"
            ( _1 )
# 5002 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1205 "parsing_c/parser_c.mly"
            ( _1 )
# 5009 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * (Ast_c.sign * Ast_c.base)) * Ast_c.info) in
    Obj.repr(
# 1206 "parsing_c/parser_c.mly"
            ( snd _1 )
# 5016 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.floatType) * Ast_c.info) in
    Obj.repr(
# 1207 "parsing_c/parser_c.mly"
            ( snd _1 )
# 5023 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 1208 "parsing_c/parser_c.mly"
            ( snd _1 )
# 5030 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.isWchar) * Ast_c.info) in
    Obj.repr(
# 1209 "parsing_c/parser_c.mly"
            ( snd _1 )
# 5037 "parsing_c/parser_c.ml"
               : 'token))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1220 "parsing_c/parser_c.mly"
                        ( Right3 (BaseType Void),            [_1] )
# 5044 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1221 "parsing_c/parser_c.mly"
                        ( Right3 (BaseType (IntType CChar)), [_1])
# 5051 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1222 "parsing_c/parser_c.mly"
                        ( Right3 (BaseType (IntType (Si (Signed,CInt)))), [_1])
# 5058 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1223 "parsing_c/parser_c.mly"
                        ( Right3 (BaseType (FloatType CFloat)),  [_1])
# 5065 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1224 "parsing_c/parser_c.mly"
                        ( Right3 (BaseType (FloatType CDouble)), [_1] )
# 5072 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1225 "parsing_c/parser_c.mly"
                        ( Right3 (BaseType SizeType),            [_1] )
# 5079 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1226 "parsing_c/parser_c.mly"
                        ( Right3 (BaseType SSizeType),           [_1] )
# 5086 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1227 "parsing_c/parser_c.mly"
                        ( Right3 (BaseType PtrDiffType),         [_1] )
# 5093 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1228 "parsing_c/parser_c.mly"
                        ( Middle3 Short,  [_1])
# 5100 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1229 "parsing_c/parser_c.mly"
                        ( Middle3 Long,   [_1])
# 5107 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1230 "parsing_c/parser_c.mly"
                        ( Left3 Signed,   [_1])
# 5114 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1231 "parsing_c/parser_c.mly"
                        ( Left3 UnSigned, [_1])
# 5121 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'struct_or_union_spec) in
    Obj.repr(
# 1232 "parsing_c/parser_c.mly"
                        ( Right3 (fst _1), snd _1 )
# 5128 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'enum_spec) in
    Obj.repr(
# 1233 "parsing_c/parser_c.mly"
                        ( Right3 (fst _1), snd _1 )
# 5135 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : 'const_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1235 "parsing_c/parser_c.mly"
     ( Right3 (Decimal(_3,Some _5)), [_1;_2;_4;_6] )
# 5147 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1237 "parsing_c/parser_c.mly"
     ( Right3 (Decimal(_3,None)), [_1;_2;_4] )
# 5157 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 1253 "parsing_c/parser_c.mly"
     ( let name = RegularName (mk_string_wrap _1) in
       Right3 (TypeName (name, Ast_c.noTypedefDef())),[] )
# 5165 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'assign_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1256 "parsing_c/parser_c.mly"
                                   ( Right3 (TypeOfExpr (_3)), [_1;_2;_4] )
# 5175 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.fullType) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1257 "parsing_c/parser_c.mly"
                                   ( Right3 (TypeOfType (_3)), [_1;_2;_4] )
# 5185 "parsing_c/parser_c.ml"
               : 'type_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_spec2) in
    Obj.repr(
# 1263 "parsing_c/parser_c.mly"
                         ( dt "type" (); _1   )
# 5192 "parsing_c/parser_c.ml"
               : 'type_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1270 "parsing_c/parser_c.mly"
             ( {const=true  ; volatile=false}, _1 )
# 5199 "parsing_c/parser_c.ml"
               : 'type_qualif))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1271 "parsing_c/parser_c.mly"
             ( {const=false ; volatile=true},  _1 )
# 5206 "parsing_c/parser_c.ml"
               : 'type_qualif))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1273 "parsing_c/parser_c.mly"
             ( (* TODO *) {const=false ; volatile=false},  _1 )
# 5213 "parsing_c/parser_c.ml"
               : 'type_qualif))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1281 "parsing_c/parser_c.mly"
                                    ( raise Todo )
# 5222 "parsing_c/parser_c.ml"
               : 'attribute))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 1283 "parsing_c/parser_c.mly"
              ( Attribute (fst _1), [snd _1] )
# 5229 "parsing_c/parser_c.ml"
               : 'attribute))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'pointer) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'direct_d) in
    Obj.repr(
# 1298 "parsing_c/parser_c.mly"
                    ( let (attr,ptr) = _1 in
                      (attr, (fst _2, fun x -> x +> ptr +> (snd _2))) )
# 5238 "parsing_c/parser_c.ml"
               : 'declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'direct_d) in
    Obj.repr(
# 1300 "parsing_c/parser_c.mly"
                    ( (Ast_c.noattr, _1)  )
# 5245 "parsing_c/parser_c.ml"
               : 'declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'tmul) in
    Obj.repr(
# 1304 "parsing_c/parser_c.mly"
                          ( (Ast_c.noattr,fun x -> mk_ty (Pointer x) [_1]) )
# 5252 "parsing_c/parser_c.ml"
               : 'pointer))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'tmul) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'pointer) in
    Obj.repr(
# 1306 "parsing_c/parser_c.mly"
     ( let (attr,ptr) = _2 in
       (attr,fun x -> mk_ty (Pointer (ptr x)) [_1]) )
# 5261 "parsing_c/parser_c.ml"
               : 'pointer))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'tmul) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'type_qualif_list) in
    Obj.repr(
# 1309 "parsing_c/parser_c.mly"
     ( let (attr,tq) = _2 in
       (attr,fun x -> (tq.qualifD, mk_tybis (Pointer x) [_1])))
# 5270 "parsing_c/parser_c.ml"
               : 'pointer))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'tmul) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'type_qualif_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'pointer) in
    Obj.repr(
# 1312 "parsing_c/parser_c.mly"
     ( let (attr1,tq) = _2 in
       let (attr2,ptr) = _3 in
       (attr1@attr2,fun x -> (tq.qualifD, mk_tybis (Pointer (ptr x)) [_1])) )
# 5281 "parsing_c/parser_c.ml"
               : 'pointer))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1317 "parsing_c/parser_c.mly"
        ( _1 )
# 5288 "parsing_c/parser_c.ml"
               : 'tmul))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1319 "parsing_c/parser_c.mly"
     ( if !Flag.c_plus_plus
     then _1
     else
       let i = Ast_c.parse_info_of_info _1 in
       raise (Semantic("& not allowed in C types, try -c++ option", i)) )
# 5299 "parsing_c/parser_c.ml"
               : 'tmul))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'identifier_cpp) in
    Obj.repr(
# 1328 "parsing_c/parser_c.mly"
     ( (_1, fun x -> x) )
# 5306 "parsing_c/parser_c.ml"
               : 'direct_d))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'declarator) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1330 "parsing_c/parser_c.mly"
     ( let (attr,dec) = _2 in  (* attr gets ignored... *)
       (fst dec, fun x -> mk_ty (ParenType ((snd dec) x)) [_1;_3]) )
# 5316 "parsing_c/parser_c.ml"
               : 'direct_d))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'direct_d) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'tocro) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tccro) in
    Obj.repr(
# 1333 "parsing_c/parser_c.mly"
     ( (fst _1,fun x->(snd _1) (mk_ty (Array (None,x)) [_2;_3])) )
# 5325 "parsing_c/parser_c.ml"
               : 'direct_d))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'direct_d) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'tocro) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tccro) in
    Obj.repr(
# 1335 "parsing_c/parser_c.mly"
     ( (fst _1,fun x->(snd _1) (mk_ty (Array (Some _3,x)) [_2;_4])) )
# 5335 "parsing_c/parser_c.ml"
               : 'direct_d))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'direct_d) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'topar) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1337 "parsing_c/parser_c.mly"
     ( (fst _1,
       fun x->(snd _1)
         (mk_ty (FunctionType (x,(([],(false, []))))) [_2;_3]))
     )
# 5347 "parsing_c/parser_c.ml"
               : 'direct_d))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'direct_d) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'topar) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'parameter_type_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1342 "parsing_c/parser_c.mly"
     ( (fst _1,fun x->(snd _1)
       (mk_ty (FunctionType (x, _3)) [_2;_4]))
     )
# 5359 "parsing_c/parser_c.ml"
               : 'direct_d))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1351 "parsing_c/parser_c.mly"
             ( et "tocro" ();_1 )
# 5366 "parsing_c/parser_c.ml"
               : 'tocro))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1352 "parsing_c/parser_c.mly"
             ( dt "tccro" ();_1 )
# 5373 "parsing_c/parser_c.ml"
               : 'tccro))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'pointer) in
    Obj.repr(
# 1356 "parsing_c/parser_c.mly"
                                      ( snd _1 )
# 5380 "parsing_c/parser_c.ml"
               : 'abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'direct_abstract_declarator) in
    Obj.repr(
# 1357 "parsing_c/parser_c.mly"
                                      ( _1 )
# 5387 "parsing_c/parser_c.ml"
               : 'abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'pointer) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'direct_abstract_declarator) in
    Obj.repr(
# 1358 "parsing_c/parser_c.mly"
                                      ( fun x -> x +> _2 +> (snd _1) )
# 5395 "parsing_c/parser_c.ml"
               : 'abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'abstract_declarator) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1362 "parsing_c/parser_c.mly"
     ( fun x -> mk_ty (ParenType (_2 x)) [_1;_3] )
# 5404 "parsing_c/parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1365 "parsing_c/parser_c.mly"
     ( fun x -> mk_ty (Array (None, x)) [_1;_2] )
# 5412 "parsing_c/parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1367 "parsing_c/parser_c.mly"
     ( fun x -> mk_ty (Array (Some _2, x)) [_1;_3] )
# 5421 "parsing_c/parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'direct_abstract_declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1369 "parsing_c/parser_c.mly"
     ( fun x -> _1 (mk_ty (Array (None, x))  [_2;_3]) )
# 5430 "parsing_c/parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'direct_abstract_declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1371 "parsing_c/parser_c.mly"
     ( fun x -> _1 (mk_ty (Array (Some _3,x))  [_2;_4]) )
# 5440 "parsing_c/parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1373 "parsing_c/parser_c.mly"
     ( fun x -> mk_ty (FunctionType (x, ([], (false,  [])))) [_1;_2] )
# 5448 "parsing_c/parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'topar) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'parameter_type_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1375 "parsing_c/parser_c.mly"
     ( fun x -> mk_ty (FunctionType (x, _2))  [_1;_3] )
# 5457 "parsing_c/parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'direct_abstract_declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'topar) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1386 "parsing_c/parser_c.mly"
     ( fun x -> _1 (mk_ty (FunctionType (x, (([], (false, []))))) [_2;_3]) )
# 5466 "parsing_c/parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'direct_abstract_declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'topar) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'parameter_type_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1388 "parsing_c/parser_c.mly"
     ( fun x -> _1 (mk_ty (FunctionType (x, _3)) [_2;_4]) )
# 5476 "parsing_c/parser_c.ml"
               : 'direct_abstract_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_list) in
    Obj.repr(
# 1394 "parsing_c/parser_c.mly"
                                   ( (_1, (false, [])))
# 5483 "parsing_c/parser_c.ml"
               : 'parameter_type_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'parameter_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1395 "parsing_c/parser_c.mly"
                                   ( (_1, (true,  [_2;_3])) )
# 5492 "parsing_c/parser_c.ml"
               : 'parameter_type_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 1399 "parsing_c/parser_c.mly"
            (
     let name = RegularName (mk_string_wrap _1) in
     LP.add_ident (str_of_name name);
     { p_namei = Some name;
       p_type = mk_ty NoType [];
       p_register = (false, []);
     }
   )
# 5506 "parsing_c/parser_c.ml"
               : 'parameter_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'declaratorp) in
    Obj.repr(
# 1408 "parsing_c/parser_c.mly"
     ( LP.kr_impossible();
       let ((returnType,hasreg),iihasreg) = fixDeclSpecForParam (snd _1) in
       let (name, ftyp) = _2 in
       { p_namei = Some (name);
         p_type = ftyp returnType;
         p_register = (hasreg, iihasreg);
       }
     )
# 5521 "parsing_c/parser_c.ml"
               : 'parameter_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'abstract_declaratorp) in
    Obj.repr(
# 1417 "parsing_c/parser_c.mly"
     ( LP.kr_impossible();
       let ((returnType,hasreg), iihasreg) = fixDeclSpecForParam (snd _1) in
       { p_namei = None;
         p_type = _2 returnType;
         p_register = hasreg, iihasreg;
       }
     )
# 5535 "parsing_c/parser_c.ml"
               : 'parameter_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec) in
    Obj.repr(
# 1425 "parsing_c/parser_c.mly"
     ( LP.kr_impossible();
       let ((returnType,hasreg), iihasreg) = fixDeclSpecForParam (snd _1) in
       { p_namei = None;
         p_type = returnType;
         p_register = hasreg, iihasreg;
       }
     )
# 5548 "parsing_c/parser_c.ml"
               : 'parameter_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_decl2) in
    Obj.repr(
# 1438 "parsing_c/parser_c.mly"
                                ( et "param" ();  _1 )
# 5555 "parsing_c/parser_c.ml"
               : 'parameter_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declarator) in
    Obj.repr(
# 1441 "parsing_c/parser_c.mly"
               ( let (attr,dec) = _1 in (* attr gets ignored *)
                 LP.add_ident (str_of_name (fst dec)); dec )
# 5563 "parsing_c/parser_c.ml"
               : 'declaratorp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attributes) in
    Obj.repr(
# 1445 "parsing_c/parser_c.mly"
               ( let (attr,dec) = _1 in (* attr gets ignored *)
                 LP.add_ident (str_of_name (fst dec)); dec )
# 5572 "parsing_c/parser_c.ml"
               : 'declaratorp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'abstract_declarator) in
    Obj.repr(
# 1449 "parsing_c/parser_c.mly"
                       ( _1 )
# 5579 "parsing_c/parser_c.ml"
               : 'abstract_declaratorp))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_spec) in
    Obj.repr(
# 1459 "parsing_c/parser_c.mly"
                                ( addTypeD (_1, nullDecl) )
# 5586 "parsing_c/parser_c.ml"
               : 'spec_qualif_list2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_qualif) in
    Obj.repr(
# 1460 "parsing_c/parser_c.mly"
                                ( {nullDecl with qualifD = (fst _1,[snd _1])})
# 5593 "parsing_c/parser_c.ml"
               : 'spec_qualif_list2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'spec_qualif_list) in
    Obj.repr(
# 1461 "parsing_c/parser_c.mly"
                                ( addTypeD (_1,_2)   )
# 5601 "parsing_c/parser_c.ml"
               : 'spec_qualif_list2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_qualif) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'spec_qualif_list) in
    Obj.repr(
# 1462 "parsing_c/parser_c.mly"
                                ( addQualifD (_1,_2) )
# 5609 "parsing_c/parser_c.ml"
               : 'spec_qualif_list2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'spec_qualif_list2) in
    Obj.repr(
# 1464 "parsing_c/parser_c.mly"
                                               (  dt "spec_qualif" (); _1 )
# 5616 "parsing_c/parser_c.ml"
               : 'spec_qualif_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_qualif) in
    Obj.repr(
# 1469 "parsing_c/parser_c.mly"
               ( (Ast_c.noattr,{nullDecl with qualifD = (fst _1,[snd _1])}) )
# 5623 "parsing_c/parser_c.ml"
               : 'type_qualif_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'attribute) in
    Obj.repr(
# 1470 "parsing_c/parser_c.mly"
                                ( ([_1],nullDecl) )
# 5630 "parsing_c/parser_c.ml"
               : 'type_qualif_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_qualif_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'type_qualif) in
    Obj.repr(
# 1471 "parsing_c/parser_c.mly"
                                ( (fst _1,addQualifD (_2,snd _1)) )
# 5638 "parsing_c/parser_c.ml"
               : 'type_qualif_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_qualif_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attribute) in
    Obj.repr(
# 1472 "parsing_c/parser_c.mly"
                                ( ((fst _1)@[_2],snd _1) )
# 5646 "parsing_c/parser_c.ml"
               : 'type_qualif_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'spec_qualif_list) in
    Obj.repr(
# 1480 "parsing_c/parser_c.mly"
     ( let (returnType, _) = fixDeclSpecForDecl _1 in  returnType )
# 5653 "parsing_c/parser_c.ml"
               : Ast_c.fullType))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'spec_qualif_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'abstract_declaratort) in
    Obj.repr(
# 1482 "parsing_c/parser_c.mly"
     ( let (returnType, _) = fixDeclSpecForDecl _1 in _2 returnType )
# 5661 "parsing_c/parser_c.ml"
               : Ast_c.fullType))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'abstract_declarator) in
    Obj.repr(
# 1487 "parsing_c/parser_c.mly"
                       ( _1 )
# 5668 "parsing_c/parser_c.ml"
               : 'abstract_declaratort))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1497 "parsing_c/parser_c.mly"
     ( function local ->
       let (returnType,storage) = fixDeclSpecForDecl (snd _1) in
       let iistart = Ast_c.fakeInfo () in
       DeclList ([{v_namei = None; v_type = returnType;
                   v_storage = unwrap storage; v_local = local;
                   v_attr = fst _1; v_endattr = Ast_c.noattr;
                   v_type_bis = ref None;
                },[]],
                (_2::iistart::snd storage))
     )
# 5685 "parsing_c/parser_c.ml"
               : 'decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'decl_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'init_declarator_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1508 "parsing_c/parser_c.mly"
     ( function local ->
       let (returnType,storage) = fixDeclSpecForDecl (snd _1) in
       let iistart = Ast_c.fakeInfo () in
       DeclList (
         (_2 +> List.map (fun ((((name,f),attrs,endattrs), ini), iivirg) ->
           let s = str_of_name name in
	   if fst (unwrap storage) = StoTypedef
	   then LP.add_typedef s;
           {v_namei = Some (name, ini);
            v_type = f returnType;
            v_storage = unwrap storage;
            v_local = local;
            v_attr = (fst _1)@attrs;
            v_endattr = endattrs;
            v_type_bis = ref None;
           },
           iivirg
         )
         ),  (_3::iistart::snd storage))
     )
# 5713 "parsing_c/parser_c.ml"
               : 'decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : 'storage_const_opt) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : (string * Ast_c.info)) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1531 "parsing_c/parser_c.mly"
     ( function _ ->
       match _1 with
	 Some (sto,stoii) ->
	   MacroDecl
	     ((sto, fst _2, _4, true), (snd _2::_3::_5::_6::fakeInfo()::stoii))
       | None ->
	   MacroDecl
	     ((NoSto, fst _2, _4, true), [snd _2;_3;_5;_6;fakeInfo()]) )
# 5732 "parsing_c/parser_c.ml"
               : 'decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 7 : 'storage_const_opt) in
    let _2 = (Parsing.peek_val __caml_parser_env 6 : (string * Ast_c.info)) in
    let _3 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 4 : 'argument_list) in
    let _5 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 2 : 'teq) in
    let _7 = (Parsing.peek_val __caml_parser_env 1 : 'initialize) in
    let _8 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1542 "parsing_c/parser_c.mly"
     ( function _ ->
       match _1 with
	 Some (sto,stoii) ->
	   MacroDeclInit
	     ((sto, fst _2, _4, _7),
	      (snd _2::_3::_5::_6::_8::fakeInfo()::stoii))
       | None ->
	   MacroDeclInit
	     ((NoSto, fst _2, _4, _7), [snd _2;_3;_5;_6;_8;fakeInfo()]) )
# 5754 "parsing_c/parser_c.ml"
               : 'decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'storage_class_spec_nt) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1553 "parsing_c/parser_c.mly"
                                         ( Some (fst _1,[snd _1; _2]) )
# 5762 "parsing_c/parser_c.ml"
               : 'storage_const_opt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'storage_class_spec_nt) in
    Obj.repr(
# 1554 "parsing_c/parser_c.mly"
                         ( Some (fst _1,[snd _1]) )
# 5769 "parsing_c/parser_c.ml"
               : 'storage_const_opt))
; (fun __caml_parser_env ->
    Obj.repr(
# 1555 "parsing_c/parser_c.mly"
                         ( None )
# 5775 "parsing_c/parser_c.ml"
               : 'storage_const_opt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'storage_class_spec) in
    Obj.repr(
# 1559 "parsing_c/parser_c.mly"
                      ( ([], {nullDecl with storageD = (fst _1, [snd _1]) }) )
# 5782 "parsing_c/parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_spec) in
    Obj.repr(
# 1560 "parsing_c/parser_c.mly"
                      ( ([], addTypeD (_1,nullDecl)) )
# 5789 "parsing_c/parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'type_qualif) in
    Obj.repr(
# 1561 "parsing_c/parser_c.mly"
                      ( ([], {nullDecl with qualifD  = (fst _1, [snd _1]) }) )
# 5796 "parsing_c/parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1562 "parsing_c/parser_c.mly"
                      ( ([], {nullDecl with inlineD = (true, [_1]) }) )
# 5803 "parsing_c/parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'attribute) in
    Obj.repr(
# 1563 "parsing_c/parser_c.mly"
                      ( ([_1], nullDecl) )
# 5810 "parsing_c/parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'storage_class_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2) in
    Obj.repr(
# 1564 "parsing_c/parser_c.mly"
                                 ( (fst _2, addStorageD (_1, snd _2)) )
# 5818 "parsing_c/parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2) in
    Obj.repr(
# 1565 "parsing_c/parser_c.mly"
                                 ( (fst _2, addTypeD    (_1, snd _2)) )
# 5826 "parsing_c/parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'type_qualif) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2) in
    Obj.repr(
# 1566 "parsing_c/parser_c.mly"
                                 ( (fst _2, addQualifD  (_1, snd _2)) )
# 5834 "parsing_c/parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2) in
    Obj.repr(
# 1567 "parsing_c/parser_c.mly"
                                 ( (fst _2, addInlineD ((true, _1), snd _2)) )
# 5842 "parsing_c/parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'attribute) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2) in
    Obj.repr(
# 1568 "parsing_c/parser_c.mly"
                                 ( (_1::(fst _2), snd _2) )
# 5850 "parsing_c/parser_c.ml"
               : 'decl_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1576 "parsing_c/parser_c.mly"
                ( Sto Static,  _1 )
# 5857 "parsing_c/parser_c.ml"
               : 'storage_class_spec_nt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1577 "parsing_c/parser_c.mly"
                ( Sto Extern,  _1 )
# 5864 "parsing_c/parser_c.ml"
               : 'storage_class_spec_nt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1578 "parsing_c/parser_c.mly"
                ( Sto Auto,    _1 )
# 5871 "parsing_c/parser_c.ml"
               : 'storage_class_spec_nt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1579 "parsing_c/parser_c.mly"
                ( Sto Register,_1 )
# 5878 "parsing_c/parser_c.ml"
               : 'storage_class_spec_nt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'storage_class_spec_nt) in
    Obj.repr(
# 1582 "parsing_c/parser_c.mly"
                         ( _1 )
# 5885 "parsing_c/parser_c.ml"
               : 'storage_class_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1583 "parsing_c/parser_c.mly"
                ( StoTypedef,  _1 )
# 5892 "parsing_c/parser_c.ml"
               : 'storage_class_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl2) in
    Obj.repr(
# 1590 "parsing_c/parser_c.mly"
                         ( et "decl" (); _1 )
# 5899 "parsing_c/parser_c.ml"
               : 'decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec2) in
    Obj.repr(
# 1591 "parsing_c/parser_c.mly"
                         ( dt "declspec" (); _1  )
# 5906 "parsing_c/parser_c.ml"
               : 'decl_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declaratori) in
    Obj.repr(
# 1597 "parsing_c/parser_c.mly"
                                ( (_1, NoInit) )
# 5913 "parsing_c/parser_c.ml"
               : 'init_declarator2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'declaratori) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'teq) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'initialize) in
    Obj.repr(
# 1598 "parsing_c/parser_c.mly"
                                ( (_1, ValInit(_2, _3)) )
# 5922 "parsing_c/parser_c.ml"
               : 'init_declarator2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'declaratori) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1601 "parsing_c/parser_c.mly"
     ( (_1, ConstrInit(_3,[_2;_4])) )
# 5932 "parsing_c/parser_c.ml"
               : 'init_declarator2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1607 "parsing_c/parser_c.mly"
          ( et "teq" (); _1 )
# 5939 "parsing_c/parser_c.ml"
               : 'teq))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'init_declarator2) in
    Obj.repr(
# 1609 "parsing_c/parser_c.mly"
                                   ( dt "init" (); _1 )
# 5946 "parsing_c/parser_c.ml"
               : 'init_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declarator) in
    Obj.repr(
# 1618 "parsing_c/parser_c.mly"
     ( let (attr,dec) = _1 in
       LP.add_ident (str_of_name (fst dec)); dec, attr, [] )
# 5954 "parsing_c/parser_c.ml"
               : 'declaratori))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'gcc_asm_decl) in
    Obj.repr(
# 1622 "parsing_c/parser_c.mly"
     ( let (attr,dec) = _1 in
       LP.add_ident (str_of_name (fst dec)); dec, attr, [] )
# 5963 "parsing_c/parser_c.ml"
               : 'declaratori))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'end_attributes) in
    Obj.repr(
# 1626 "parsing_c/parser_c.mly"
     ( let (attr,dec) = _1 in
       LP.add_ident (str_of_name (fst dec)); dec, attr, _2 (* TODO *) )
# 5972 "parsing_c/parser_c.ml"
               : 'declaratori))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'asmbody) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1631 "parsing_c/parser_c.mly"
                                         (  )
# 5982 "parsing_c/parser_c.ml"
               : 'gcc_asm_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'asmbody) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1632 "parsing_c/parser_c.mly"
                                        (  )
# 5993 "parsing_c/parser_c.ml"
               : 'gcc_asm_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'assign_expr) in
    Obj.repr(
# 1638 "parsing_c/parser_c.mly"
     ( InitExpr _1,                [] )
# 6000 "parsing_c/parser_c.ml"
               : 'initialize))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'tobrace_ini) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'initialize_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'gcc_comma_opt_struct) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_ini) in
    Obj.repr(
# 1640 "parsing_c/parser_c.mly"
     ( InitList (List.rev _2),     [_1;_4] @ _3 )
# 6010 "parsing_c/parser_c.ml"
               : 'initialize))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'tobrace_ini) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_ini) in
    Obj.repr(
# 1642 "parsing_c/parser_c.mly"
     ( InitList [],       [_1;_2] )
# 6018 "parsing_c/parser_c.ml"
               : 'initialize))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'initialize2) in
    Obj.repr(
# 1653 "parsing_c/parser_c.mly"
                                      ( [_1,   []] )
# 6025 "parsing_c/parser_c.ml"
               : 'initialize_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'initialize_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'initialize2) in
    Obj.repr(
# 1654 "parsing_c/parser_c.mly"
                                      ( (_3,  [_2])::_1 )
# 6034 "parsing_c/parser_c.ml"
               : 'initialize_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cond_expr) in
    Obj.repr(
# 1660 "parsing_c/parser_c.mly"
     ( InitExpr _1,   [] )
# 6041 "parsing_c/parser_c.ml"
               : 'initialize2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'tobrace_ini) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'initialize_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'gcc_comma_opt_struct) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_ini) in
    Obj.repr(
# 1662 "parsing_c/parser_c.mly"
     ( InitList (List.rev _2),   [_1;_4] @ _3 )
# 6051 "parsing_c/parser_c.ml"
               : 'initialize2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'tobrace_ini) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_ini) in
    Obj.repr(
# 1664 "parsing_c/parser_c.mly"
     ( InitList [],  [_1;_2]  )
# 6059 "parsing_c/parser_c.ml"
               : 'initialize2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'designator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'initialize2) in
    Obj.repr(
# 1668 "parsing_c/parser_c.mly"
     ( InitDesignators (_1, _3), [_2] )
# 6068 "parsing_c/parser_c.ml"
               : 'initialize2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'ident) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'initialize2) in
    Obj.repr(
# 1672 "parsing_c/parser_c.mly"
     ( InitFieldOld (fst _1, _3),     [snd _1; _2] )
# 6077 "parsing_c/parser_c.ml"
               : 'initialize2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'ident) in
    Obj.repr(
# 1683 "parsing_c/parser_c.mly"
     ( DesignatorField (fst _2), [_1;snd _2] )
# 6085 "parsing_c/parser_c.ml"
               : 'designator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1685 "parsing_c/parser_c.mly"
     ( DesignatorIndex (_2),  [_1;_3] )
# 6094 "parsing_c/parser_c.ml"
               : 'designator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : 'const_expr) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'const_expr) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1687 "parsing_c/parser_c.mly"
     ( DesignatorRange (_2, _4),  [_1;_3;_5] )
# 6105 "parsing_c/parser_c.ml"
               : 'designator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1695 "parsing_c/parser_c.mly"
          (  [_1] )
# 6112 "parsing_c/parser_c.ml"
               : 'gcc_comma_opt_struct))
; (fun __caml_parser_env ->
    Obj.repr(
# 1696 "parsing_c/parser_c.mly"
                    (  [Ast_c.fakeInfo() +> Ast_c.rewrap_str ","]  )
# 6118 "parsing_c/parser_c.ml"
               : 'gcc_comma_opt_struct))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'struct_or_union) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : 'ident) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'tobrace_struct) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'struct_decl_list_gcc) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_struct) in
    Obj.repr(
# 1711 "parsing_c/parser_c.mly"
     ( StructUnion (fst _1, Some (fst _2), _4),  [snd _1;snd _2;_3;_5]  )
# 6129 "parsing_c/parser_c.ml"
               : 's_or_u_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'struct_or_union) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'tobrace_struct) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'struct_decl_list_gcc) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_struct) in
    Obj.repr(
# 1713 "parsing_c/parser_c.mly"
     ( StructUnion (fst _1, None, _3), [snd _1;_2;_4] )
# 6139 "parsing_c/parser_c.ml"
               : 's_or_u_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'struct_or_union) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'ident) in
    Obj.repr(
# 1715 "parsing_c/parser_c.mly"
     ( StructUnionName (fst _1, fst _2), [snd _1;snd _2] )
# 6147 "parsing_c/parser_c.ml"
               : 's_or_u_spec2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1718 "parsing_c/parser_c.mly"
             ( Struct, _1 )
# 6154 "parsing_c/parser_c.ml"
               : 'struct_or_union2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1719 "parsing_c/parser_c.mly"
             ( Union, _1 )
# 6161 "parsing_c/parser_c.ml"
               : 'struct_or_union2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attributes) in
    Obj.repr(
# 1721 "parsing_c/parser_c.mly"
                        ( Struct, _1 (* TODO *) )
# 6169 "parsing_c/parser_c.ml"
               : 'struct_or_union2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attributes) in
    Obj.repr(
# 1722 "parsing_c/parser_c.mly"
                        ( Union, _1  (* TODO *) )
# 6177 "parsing_c/parser_c.ml"
               : 'struct_or_union2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'field_declaration) in
    Obj.repr(
# 1727 "parsing_c/parser_c.mly"
                     ( DeclarationField _1 )
# 6184 "parsing_c/parser_c.ml"
               : 'struct_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1728 "parsing_c/parser_c.mly"
           ( EmptyField _1  )
# 6191 "parsing_c/parser_c.ml"
               : 'struct_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'identifier) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1734 "parsing_c/parser_c.mly"
     ( MacroDeclField ((fst _1, _3), [snd _1;_2;_4;_5;fakeInfo()]) )
# 6202 "parsing_c/parser_c.ml"
               : 'struct_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : (string * Ast_c.info)) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1737 "parsing_c/parser_c.mly"
     ( MacroDeclField ((fst _1, _3), [snd _1;_2;_4;_5;fakeInfo()]) )
# 6213 "parsing_c/parser_c.ml"
               : 'struct_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_directive) in
    Obj.repr(
# 1741 "parsing_c/parser_c.mly"
     ( CppDirectiveStruct _1 )
# 6220 "parsing_c/parser_c.ml"
               : 'struct_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_directive) in
    Obj.repr(
# 1743 "parsing_c/parser_c.mly"
     ( IfdefStruct _1 )
# 6227 "parsing_c/parser_c.ml"
               : 'struct_decl2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'spec_qualif_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'struct_declarator_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1748 "parsing_c/parser_c.mly"
     (
       let (returnType,storage) = fixDeclSpecForDecl _1 in
       if fst (unwrap storage) <> NoSto
       then internal_error "parsing dont allow this";

       let iistart = Ast_c.fakeInfo () in (* for parallelism with DeclList *)
       FieldDeclList (_2 +> (List.map (fun (f, iivirg) ->
         f returnType, iivirg))
                         ,[_3;iistart])
         (* dont need to check if typedef or func initialised cos
          * grammar dont allow typedef nor initialiser in struct
          *)
     )
# 6248 "parsing_c/parser_c.ml"
               : 'field_declaration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'spec_qualif_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1763 "parsing_c/parser_c.mly"
     (
       (* gccext: allow empty elements if it is a structdef or enumdef *)
       let (returnType,storage) = fixDeclSpecForDecl _1 in
       if fst (unwrap storage) <> NoSto
       then internal_error "parsing dont allow this";

       let iistart = Ast_c.fakeInfo () in (* for parallelism with DeclList *)
       FieldDeclList ([(Simple (None, returnType)) , []], [_2;iistart])
     )
# 6264 "parsing_c/parser_c.ml"
               : 'field_declaration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declaratorsd) in
    Obj.repr(
# 1779 "parsing_c/parser_c.mly"
     ( (fun x -> Simple   (Some (fst _1), (snd _1) x)) )
# 6271 "parsing_c/parser_c.ml"
               : 'struct_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'dotdot) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'const_expr2) in
    Obj.repr(
# 1781 "parsing_c/parser_c.mly"
     ( (fun x -> BitField (None, x, _1, _2)) )
# 6279 "parsing_c/parser_c.ml"
               : 'struct_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'declaratorsd) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'dotdot) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'const_expr2) in
    Obj.repr(
# 1783 "parsing_c/parser_c.mly"
     ( (fun x -> BitField (Some (fst _1), ((snd _1) x), _2, _3)) )
# 6288 "parsing_c/parser_c.ml"
               : 'struct_declarator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declarator) in
    Obj.repr(
# 1791 "parsing_c/parser_c.mly"
     ( let (attr,dec) = _1 in (* attr ignored *)
       (*also ? LP.add_ident (fst (fst dec)); *) dec )
# 6296 "parsing_c/parser_c.ml"
               : 'declaratorsd))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attributes) in
    Obj.repr(
# 1794 "parsing_c/parser_c.mly"
                           ( let (attr,dec) = _1 in dec )
# 6304 "parsing_c/parser_c.ml"
               : 'declaratorsd))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 's_or_u_spec2) in
    Obj.repr(
# 1799 "parsing_c/parser_c.mly"
                                   ( dt "su" (); _1 )
# 6311 "parsing_c/parser_c.ml"
               : 'struct_or_union_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'struct_or_union2) in
    Obj.repr(
# 1800 "parsing_c/parser_c.mly"
                                  ( et "su" (); _1 )
# 6318 "parsing_c/parser_c.ml"
               : 'struct_or_union))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'struct_decl2) in
    Obj.repr(
# 1801 "parsing_c/parser_c.mly"
                           ( et "struct" (); _1 )
# 6325 "parsing_c/parser_c.ml"
               : 'struct_decl))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1803 "parsing_c/parser_c.mly"
                 ( et "dotdot" (); _1 )
# 6332 "parsing_c/parser_c.ml"
               : 'dotdot))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'const_expr) in
    Obj.repr(
# 1804 "parsing_c/parser_c.mly"
                        ( dt "const_expr2" (); _1 )
# 6339 "parsing_c/parser_c.ml"
               : 'const_expr2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'struct_decl_list) in
    Obj.repr(
# 1807 "parsing_c/parser_c.mly"
                     ( _1 )
# 6346 "parsing_c/parser_c.ml"
               : 'struct_decl_list_gcc))
; (fun __caml_parser_env ->
    Obj.repr(
# 1808 "parsing_c/parser_c.mly"
                         ( [] )
# 6352 "parsing_c/parser_c.ml"
               : 'struct_decl_list_gcc))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : 'tobrace_enum) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'enumerator_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'gcc_comma_opt_struct) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_enum) in
    Obj.repr(
# 1816 "parsing_c/parser_c.mly"
     ( Enum (None,    _3),           [_1;_2;_5] @ _4 )
# 6363 "parsing_c/parser_c.ml"
               : 'enum_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : 'ident) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : 'tobrace_enum) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : 'enumerator_list) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : 'gcc_comma_opt_struct) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : 'tcbrace_enum) in
    Obj.repr(
# 1818 "parsing_c/parser_c.mly"
     ( Enum (Some (fst _2), _4),     [_1; snd _2; _3;_6] @ _5 )
# 6375 "parsing_c/parser_c.ml"
               : 'enum_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'ident) in
    Obj.repr(
# 1820 "parsing_c/parser_c.mly"
     ( EnumName (fst _2),       [_1; snd _2] )
# 6383 "parsing_c/parser_c.ml"
               : 'enum_spec))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'idente) in
    Obj.repr(
# 1823 "parsing_c/parser_c.mly"
                          ( _1, None     )
# 6390 "parsing_c/parser_c.ml"
               : 'enumerator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'idente) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'const_expr) in
    Obj.repr(
# 1824 "parsing_c/parser_c.mly"
                          ( _1, Some (_2, _3) )
# 6399 "parsing_c/parser_c.ml"
               : 'enumerator))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ident_cpp) in
    Obj.repr(
# 1831 "parsing_c/parser_c.mly"
                  ( LP.add_ident (str_of_name _1); _1 )
# 6406 "parsing_c/parser_c.ml"
               : 'idente))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'function_def) in
    Obj.repr(
# 1838 "parsing_c/parser_c.mly"
                                     ( fixFunc _1 )
# 6413 "parsing_c/parser_c.ml"
               : 'function_definition))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl) in
    Obj.repr(
# 1841 "parsing_c/parser_c.mly"
                  ( [_1 Ast_c.LocalDecl]   )
# 6420 "parsing_c/parser_c.ml"
               : 'decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'decl) in
    Obj.repr(
# 1842 "parsing_c/parser_c.mly"
                  ( _1 @ [_2 Ast_c.LocalDecl] )
# 6428 "parsing_c/parser_c.ml"
               : 'decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_directive) in
    Obj.repr(
# 1846 "parsing_c/parser_c.mly"
                                    ( )
# 6435 "parsing_c/parser_c.ml"
               : 'cpp_directive_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'cpp_directive_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_directive) in
    Obj.repr(
# 1847 "parsing_c/parser_c.mly"
                                    ( )
# 6443 "parsing_c/parser_c.ml"
               : 'cpp_directive_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'start_fun) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'compound) in
    Obj.repr(
# 1850 "parsing_c/parser_c.mly"
                           ( LP.del_scope(); (_1, _2, None) )
# 6451 "parsing_c/parser_c.ml"
               : 'function_def))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'start_fun) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'cpp_directive_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'compound) in
    Obj.repr(
# 1851 "parsing_c/parser_c.mly"
                                         ( LP.del_scope(); (_1, _3, None) )
# 6460 "parsing_c/parser_c.ml"
               : 'function_def))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'start_fun) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'decl_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'compound) in
    Obj.repr(
# 1852 "parsing_c/parser_c.mly"
                                     (
     (* TODO: undo the typedef added ? *)
     LP.del_scope();
     (_1, _3, Some _2)
   )
# 6473 "parsing_c/parser_c.ml"
               : 'function_def))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'start_fun2) in
    Obj.repr(
# 1859 "parsing_c/parser_c.mly"
  ( LP.new_scope();
    fix_add_params_ident _1;
    (* toreput? !LP._lexer_hint.toplevel <- false;  *)
    _1
  )
# 6484 "parsing_c/parser_c.ml"
               : 'start_fun))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'declaratorfd) in
    Obj.repr(
# 1866 "parsing_c/parser_c.mly"
     ( let (returnType,storage) = fixDeclSpecForFuncDef (snd _1) in
       let (id, attrs) = _2 in
       (fst id, fixOldCDecl ((snd id) returnType) , storage, (fst _1)@attrs)
     )
# 6495 "parsing_c/parser_c.ml"
               : 'start_fun2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ctor_dtor) in
    Obj.repr(
# 1870 "parsing_c/parser_c.mly"
               ( _1 )
# 6502 "parsing_c/parser_c.ml"
               : 'start_fun2))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'topar) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1873 "parsing_c/parser_c.mly"
                                (
     let id = RegularName (mk_string_wrap _1) in
     let ret = mk_ty NoType [] in
     let ty = mk_ty (FunctionType (ret, (([], (false, []))))) [_2;_3] in
     let storage = ((NoSto,false),[]) in
     let attrs = [] in
     (id, ty, storage, attrs) )
# 6517 "parsing_c/parser_c.ml"
               : 'ctor_dtor))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : string * Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : 'topar) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'parameter_type_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'tcpar) in
    Obj.repr(
# 1880 "parsing_c/parser_c.mly"
                                                    (
     let id = RegularName (mk_string_wrap _1) in
     let ret = mk_ty NoType [] in
     let ty = mk_ty (FunctionType (ret, _3)) [_2;_4] in
     let storage = ((NoSto,false),[]) in
     let attrs = [] in
     (id, ty, storage, attrs) )
# 6533 "parsing_c/parser_c.ml"
               : 'ctor_dtor))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'declarator) in
    Obj.repr(
# 1902 "parsing_c/parser_c.mly"
   ( et "declaratorfd" (); let (attr,dec) = _1 in dec, attr )
# 6540 "parsing_c/parser_c.ml"
               : 'declaratorfd))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'declarator) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'end_attributes) in
    Obj.repr(
# 1905 "parsing_c/parser_c.mly"
   ( et "declaratorfd" (); let (attr,dec) = _1 in dec, attr )
# 6548 "parsing_c/parser_c.ml"
               : 'declaratorfd))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : (Ast_c.info * bool ref)) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 1914 "parsing_c/parser_c.mly"
     (
       let (i1, in_ifdef) = _1 in
       let (s, i2) = _2 in

       (* redo some lexing work :( *)
       let inc_file =
         match () with
         | _ when s =~ "^\"\\(.*\\)\"$" ->
             Local (Common.split "/" (matched1 s))
         | _ when s =~ "^\\<\\(.*\\)\\>$" ->
             NonLocal (Common.split "/" (matched1 s))
         | _ ->
             Weird s
       in
       Include { i_include = (inc_file, [i1;i2]);
                 i_rel_pos = Ast_c.noRelPos();
                 i_overall_rel_pos = Ast_c.noRelPos();
                 i_is_in_ifdef = !in_ifdef;
                 i_content = Ast_c.noi_content;
       }
     )
# 6576 "parsing_c/parser_c.ml"
               : 'cpp_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : (string * Ast_c.info)) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'define_val) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1937 "parsing_c/parser_c.mly"
     ( Define ((fst _2, [_1; snd _2;_4]), (DefineVar, _3)) )
# 6586 "parsing_c/parser_c.ml"
               : 'cpp_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 6 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 5 : (string * Ast_c.info)) in
    let _3 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 3 : 'param_define_list) in
    let _5 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _6 = (Parsing.peek_val __caml_parser_env 1 : 'define_val) in
    let _7 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1944 "parsing_c/parser_c.mly"
     ( Define
         ((fst _2, [_1; snd _2; _7]),
           (DefineFunc (_4, [_3;_5]), _6))
     )
# 6602 "parsing_c/parser_c.ml"
               : 'cpp_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : (string * Ast_c.info)) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1950 "parsing_c/parser_c.mly"
     ( Define((fst _2, [_1; snd _2; _3]), (Undef,DefineEmpty)) )
# 6611 "parsing_c/parser_c.ml"
               : 'cpp_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : (string * Ast_c.info)) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'pragmainfo) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1953 "parsing_c/parser_c.mly"
     ( Pragma((fst _2, [_1; snd _2; _4]), _3) )
# 6621 "parsing_c/parser_c.ml"
               : 'cpp_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1955 "parsing_c/parser_c.mly"
                      ( OtherDirective ([_1]) )
# 6628 "parsing_c/parser_c.ml"
               : 'cpp_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list_ne) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1958 "parsing_c/parser_c.mly"
                                ( (PragmaTuple (_2, [_1;_3])) )
# 6637 "parsing_c/parser_c.ml"
               : 'pragmainfo))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 1959 "parsing_c/parser_c.mly"
               ( PragmaTuple ([], [_1;_2]) )
# 6645 "parsing_c/parser_c.ml"
               : 'pragmainfo))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'ident_define_list_ne) in
    Obj.repr(
# 1960 "parsing_c/parser_c.mly"
                        ( PragmaIdList _1 )
# 6652 "parsing_c/parser_c.ml"
               : 'pragmainfo))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.expression) in
    Obj.repr(
# 1966 "parsing_c/parser_c.mly"
             ( DefineExpr _1 )
# 6659 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.statement) in
    Obj.repr(
# 1967 "parsing_c/parser_c.mly"
             ( DefineStmt _1 )
# 6666 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl) in
    Obj.repr(
# 1968 "parsing_c/parser_c.mly"
             ( DefineStmt (mk_st (Decl (_1 Ast_c.NotLocalDecl)) Ast_c.noii) )
# 6673 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl_spec) in
    Obj.repr(
# 1978 "parsing_c/parser_c.mly"
     ( let returnType = fixDeclSpecForMacro (snd _1) in
       DefineType returnType
     )
# 6682 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'decl_spec) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'abstract_declarator) in
    Obj.repr(
# 1982 "parsing_c/parser_c.mly"
     ( let returnType = fixDeclSpecForMacro (snd _1) in
       let typ = _2 returnType in
       DefineType typ
     )
# 6693 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'stat_or_decl) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'stat_or_decl_list) in
    Obj.repr(
# 1994 "parsing_c/parser_c.mly"
     ( DefineMulti
	 (List.map
	    (function
		StmtElem e -> e
	      | _ -> failwith "unexpected statement for DefineMulti")
	    (_1 :: _2)) )
# 6706 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'function_definition) in
    Obj.repr(
# 2008 "parsing_c/parser_c.mly"
                       ( DefineFunction _1 )
# 6713 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : 'initialize_list) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'gcc_comma_opt_struct) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'comma_opt) in
    Obj.repr(
# 2011 "parsing_c/parser_c.mly"
    ( DefineInit (InitList (List.rev _2), [_1;_4] @ _3 @ _5)  )
# 6724 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 5 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.statement) in
    let _3 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.expression) in
    let _6 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2015 "parsing_c/parser_c.mly"
     (
       (* TOREPUT
       if fst $5 <> "0"
       then pr2 "WEIRD: in macro and have not a while(0)";
       *)
       DefineDoWhileZero ((_2,_5),   [_1;_3;_4;_6])
     )
# 6742 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'asmbody) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2023 "parsing_c/parser_c.mly"
                                         ( DefineTodo )
# 6752 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'asmbody) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2024 "parsing_c/parser_c.mly"
                                         ( DefineTodo )
# 6763 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    Obj.repr(
# 2028 "parsing_c/parser_c.mly"
                   ( DefineEmpty )
# 6769 "parsing_c/parser_c.ml"
               : 'define_val))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 2034 "parsing_c/parser_c.mly"
                        ( mk_string_wrap _1 )
# 6776 "parsing_c/parser_c.ml"
               : 'param_define))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : string * Ast_c.info) in
    Obj.repr(
# 2035 "parsing_c/parser_c.mly"
                        ( mk_string_wrap _1 )
# 6783 "parsing_c/parser_c.ml"
               : 'param_define))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 2036 "parsing_c/parser_c.mly"
                        ( mk_string_wrap _1 )
# 6790 "parsing_c/parser_c.ml"
               : 'param_define))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2037 "parsing_c/parser_c.mly"
                        ( "...", [_1] )
# 6797 "parsing_c/parser_c.ml"
               : 'param_define))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2039 "parsing_c/parser_c.mly"
                        ( "register", [_1] )
# 6804 "parsing_c/parser_c.ml"
               : 'param_define))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (Ast_c.ifdef_guard * (int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 2046 "parsing_c/parser_c.mly"
     ( let (cond,tag,ii) = _1 in
       IfdefDirective ((Ifdef cond, IfdefTag (Common.some !tag)),  [ii]) )
# 6812 "parsing_c/parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : ((int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 2049 "parsing_c/parser_c.mly"
     ( let (tag,ii) = _1 in
       IfdefDirective ((IfdefElse, IfdefTag (Common.some !tag)), [ii]) )
# 6820 "parsing_c/parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (Ast_c.ifdef_guard * (int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 2052 "parsing_c/parser_c.mly"
     ( let (cond,tag,ii) = _1 in
       IfdefDirective ((IfdefElseif cond, IfdefTag (Common.some !tag)), [ii]) )
# 6828 "parsing_c/parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : ((int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 2055 "parsing_c/parser_c.mly"
     ( let (tag,ii) = _1 in
       IfdefDirective ((IfdefEndif, IfdefTag (Common.some !tag)), [ii]) )
# 6836 "parsing_c/parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (bool * (int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 2059 "parsing_c/parser_c.mly"
     ( let (_b, tag,ii) = _1 in
       IfdefDirective ((Ifdef Gnone, IfdefTag (Common.some !tag)), [ii]) )
# 6844 "parsing_c/parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (bool * (int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 2062 "parsing_c/parser_c.mly"
     ( let (_b, tag,ii) = _1 in
       IfdefDirective ((Ifdef Gnone, IfdefTag (Common.some !tag)), [ii]) )
# 6852 "parsing_c/parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (bool * (int * int) option ref * Ast_c.info)) in
    Obj.repr(
# 2065 "parsing_c/parser_c.mly"
     ( let (_b, tag,ii) = _1 in
       IfdefDirective ((Ifdef Gnone, IfdefTag (Common.some !tag)), [ii]) )
# 6860 "parsing_c/parser_c.ml"
               : 'cpp_ifdef_directive))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'identifier) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2076 "parsing_c/parser_c.mly"
     (
       if args_are_params _3
       then
	 (* if all args are params, assume it is a prototype of a function
	    with no return type *)
	 let parameters = args_to_params _3 None in
	 let paramlist = (parameters, (false, [])) in (* no varargs *)
	 let id = RegularName (mk_string_wrap _1) in
	 let ret =
	   warning "type defaults to 'int'"
	     (mk_ty defaultInt [fakeInfo fake_pi]) in
	 let ty =
	   fixOldCDecl (mk_ty (FunctionType (ret, paramlist)) [_2;_4]) in
	 let attrs = Ast_c.noattr in
	 let sto = (NoSto, false), [] in
	 let iistart = Ast_c.fakeInfo () in
	 Declaration(
	 DeclList ([{v_namei = Some (id,NoInit); v_type = ty;
                      v_storage = unwrap sto; v_local = NotLocalDecl;
                      v_attr = attrs; v_endattr = Ast_c.noattr;
		      v_type_bis = ref None;
                    },[]],
                   (_5::iistart::snd sto)))
       else
	 Declaration
	   (MacroDecl((NoSto, fst _1, _3, true), [snd _1;_2;_4;_5;fakeInfo()]))
           (* old: MacroTop (fst $1, $3,    [snd $1;$2;$4;$5])  *)
     )
# 6898 "parsing_c/parser_c.ml"
               : 'cpp_other))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : 'identifier) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : 'compound) in
    Obj.repr(
# 2107 "parsing_c/parser_c.mly"
                                                 (
   let parameters = args_to_params _3 (Some (snd _1)) in
   let paramlist = (parameters, (false, [])) in (* no varargs *)
   let fninfo =
     let id = RegularName (mk_string_wrap _1) in
     let ret =
       warning "type defaults to 'int'"
	 (mk_ty defaultInt [fakeInfo fake_pi]) in
     let ty = mk_ty (FunctionType (ret, paramlist)) [_2;_4] in
     let attrs = Ast_c.noattr in
     let sto = (NoSto, false), [] in
     (id, fixOldCDecl ty, sto, attrs) in
   let fundef = fixFunc (fninfo, _5, None) in
   Definition fundef
 )
# 6923 "parsing_c/parser_c.ml"
               : 'cpp_other))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'identifier) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'argument_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2125 "parsing_c/parser_c.mly"
     ( Declaration
	 (MacroDecl ((NoSto, fst _1, _3, false), [snd _1;_2;_4;fakeInfo()])) )
# 6934 "parsing_c/parser_c.ml"
               : 'cpp_other))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'identifier) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2129 "parsing_c/parser_c.mly"
                      ( EmptyDef [snd _1;_2] )
# 6942 "parsing_c/parser_c.ml"
               : 'cpp_other))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'function_definition) in
    Obj.repr(
# 2138 "parsing_c/parser_c.mly"
                                     ( Definition _1 )
# 6949 "parsing_c/parser_c.ml"
               : 'external_declaration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'decl) in
    Obj.repr(
# 2139 "parsing_c/parser_c.mly"
                                     ( Declaration (_1 Ast_c.NotLocalDecl) )
# 6956 "parsing_c/parser_c.ml"
               : 'external_declaration))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : string * Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : 'translation_unit) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2144 "parsing_c/parser_c.mly"
     ( !LP._lexer_hint.context_stack <- [LP.InTopLevel];
       Namespace (_4, [_1; snd _2; _3; _5]) )
# 6968 "parsing_c/parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'external_declaration) in
    Obj.repr(
# 2147 "parsing_c/parser_c.mly"
                                                ( _1 )
# 6975 "parsing_c/parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_directive) in
    Obj.repr(
# 2151 "parsing_c/parser_c.mly"
     ( CppTop _1 )
# 6982 "parsing_c/parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_other) in
    Obj.repr(
# 2153 "parsing_c/parser_c.mly"
     ( _1 )
# 6989 "parsing_c/parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'cpp_ifdef_directive) in
    Obj.repr(
# 2155 "parsing_c/parser_c.mly"
     ( IfdefTop _1 )
# 6996 "parsing_c/parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 4 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 3 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 2 : 'asmbody) in
    let _4 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _5 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2158 "parsing_c/parser_c.mly"
                                                ( EmptyDef [_1;_2;_4;_5] )
# 7007 "parsing_c/parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2165 "parsing_c/parser_c.mly"
              ( EmptyDef [_1] )
# 7014 "parsing_c/parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2168 "parsing_c/parser_c.mly"
              ( FinalDef _1 )
# 7021 "parsing_c/parser_c.ml"
               : Ast_c.toplevel))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2177 "parsing_c/parser_c.mly"
                  ( LP.push_context LP.InFunction; LP.new_scope (); _1 )
# 7028 "parsing_c/parser_c.ml"
               : 'tobrace))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2178 "parsing_c/parser_c.mly"
                  ( LP.pop_context();              LP.del_scope (); _1 )
# 7035 "parsing_c/parser_c.ml"
               : 'tcbrace))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2180 "parsing_c/parser_c.mly"
                      ( LP.push_context LP.InEnum; _1 )
# 7042 "parsing_c/parser_c.ml"
               : 'tobrace_enum))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2181 "parsing_c/parser_c.mly"
                      ( LP.pop_context (); _1 )
# 7049 "parsing_c/parser_c.ml"
               : 'tcbrace_enum))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2183 "parsing_c/parser_c.mly"
                     ( LP.push_context LP.InInitializer; _1 )
# 7056 "parsing_c/parser_c.ml"
               : 'tobrace_ini))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2184 "parsing_c/parser_c.mly"
                     ( LP.pop_context (); _1 )
# 7063 "parsing_c/parser_c.ml"
               : 'tcbrace_ini))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2186 "parsing_c/parser_c.mly"
                        ( LP.push_context LP.InStruct; _1)
# 7070 "parsing_c/parser_c.ml"
               : 'tobrace_struct))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2187 "parsing_c/parser_c.mly"
                        ( LP.pop_context (); _1 )
# 7077 "parsing_c/parser_c.ml"
               : 'tcbrace_struct))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2193 "parsing_c/parser_c.mly"
     ( LP.new_scope ();et "topar" ();
       LP.push_context LP.InParameter;
       _1
     )
# 7087 "parsing_c/parser_c.ml"
               : 'topar))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2198 "parsing_c/parser_c.mly"
     ( LP.del_scope ();dt "tcpar" ();
       LP.pop_context ();
       _1
     )
# 7097 "parsing_c/parser_c.ml"
               : 'tcpar))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'string_elem) in
    Obj.repr(
# 2237 "parsing_c/parser_c.mly"
               ( _1 )
# 7104 "parsing_c/parser_c.ml"
               : 'string_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'string_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'string_elem) in
    Obj.repr(
# 2238 "parsing_c/parser_c.mly"
                           ( _1 @ _2 )
# 7112 "parsing_c/parser_c.ml"
               : 'string_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'colon_asm) in
    Obj.repr(
# 2241 "parsing_c/parser_c.mly"
             ( [_1] )
# 7119 "parsing_c/parser_c.ml"
               : 'colon_asm_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'colon_asm_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'colon_asm) in
    Obj.repr(
# 2242 "parsing_c/parser_c.mly"
                             ( _1 @ [_2] )
# 7127 "parsing_c/parser_c.ml"
               : 'colon_asm_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'colon_option) in
    Obj.repr(
# 2245 "parsing_c/parser_c.mly"
                ( [_1, []] )
# 7134 "parsing_c/parser_c.ml"
               : 'colon_option_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'colon_option_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'colon_option) in
    Obj.repr(
# 2246 "parsing_c/parser_c.mly"
                                         ( _1 @ [_3, [_2]] )
# 7143 "parsing_c/parser_c.ml"
               : 'colon_option_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'argument_ne) in
    Obj.repr(
# 2250 "parsing_c/parser_c.mly"
                                         ( [_1, []] )
# 7150 "parsing_c/parser_c.ml"
               : 'argument_list_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list_ne) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'argument) in
    Obj.repr(
# 2251 "parsing_c/parser_c.mly"
                                    ( _1 @ [_3,    [_2]] )
# 7159 "parsing_c/parser_c.ml"
               : 'argument_list_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'argument) in
    Obj.repr(
# 2254 "parsing_c/parser_c.mly"
                                      ( [_1, []] )
# 7166 "parsing_c/parser_c.ml"
               : 'argument_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'argument_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'argument) in
    Obj.repr(
# 2255 "parsing_c/parser_c.mly"
                                 ( _1 @ [_3,    [_2]] )
# 7175 "parsing_c/parser_c.ml"
               : 'argument_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 2265 "parsing_c/parser_c.mly"
                             ( [RegularName (mk_string_wrap _1), []] )
# 7182 "parsing_c/parser_c.ml"
               : 'ident_define_list_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'ident_define_list_ne) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 2267 "parsing_c/parser_c.mly"
     ( _1 @ [RegularName (mk_string_wrap _2), []] )
# 7190 "parsing_c/parser_c.ml"
               : 'ident_define_list_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'struct_decl) in
    Obj.repr(
# 2271 "parsing_c/parser_c.mly"
                                 ( [_1] )
# 7197 "parsing_c/parser_c.ml"
               : 'struct_decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'struct_decl_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'struct_decl) in
    Obj.repr(
# 2272 "parsing_c/parser_c.mly"
                                 ( _1 @ [_2] )
# 7205 "parsing_c/parser_c.ml"
               : 'struct_decl_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'struct_declarator) in
    Obj.repr(
# 2276 "parsing_c/parser_c.mly"
                                                   ( [_1,           []] )
# 7212 "parsing_c/parser_c.ml"
               : 'struct_declarator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'struct_declarator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'cpp_directive_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'struct_declarator) in
    Obj.repr(
# 2278 "parsing_c/parser_c.mly"
     ( _1 @ [_4, [_2]] )
# 7222 "parsing_c/parser_c.ml"
               : 'struct_declarator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'struct_declarator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'struct_declarator) in
    Obj.repr(
# 2279 "parsing_c/parser_c.mly"
                                                   ( _1 @ [_3,     [_2]] )
# 7231 "parsing_c/parser_c.ml"
               : 'struct_declarator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'enumerator) in
    Obj.repr(
# 2283 "parsing_c/parser_c.mly"
                                     ( [_1,          []]   )
# 7238 "parsing_c/parser_c.ml"
               : 'enumerator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'enumerator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'cpp_directive_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'enumerator) in
    Obj.repr(
# 2285 "parsing_c/parser_c.mly"
     ( _1 @ [_4, [_2]] )
# 7248 "parsing_c/parser_c.ml"
               : 'enumerator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'enumerator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'enumerator) in
    Obj.repr(
# 2286 "parsing_c/parser_c.mly"
                                     ( _1 @ [_3,    [_2]] )
# 7257 "parsing_c/parser_c.ml"
               : 'enumerator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'init_declarator) in
    Obj.repr(
# 2290 "parsing_c/parser_c.mly"
                                               ( [_1,   []] )
# 7264 "parsing_c/parser_c.ml"
               : 'init_declarator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 3 : 'init_declarator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 2 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 1 : 'cpp_directive_list) in
    let _4 = (Parsing.peek_val __caml_parser_env 0 : 'init_declarator) in
    Obj.repr(
# 2292 "parsing_c/parser_c.mly"
     ( _1 @ [_4, [_2]] )
# 7274 "parsing_c/parser_c.ml"
               : 'init_declarator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'init_declarator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'init_declarator) in
    Obj.repr(
# 2293 "parsing_c/parser_c.mly"
                                               ( _1 @ [_3,     [_2]] )
# 7283 "parsing_c/parser_c.ml"
               : 'init_declarator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_decl) in
    Obj.repr(
# 2297 "parsing_c/parser_c.mly"
                                        ( [_1, []] )
# 7290 "parsing_c/parser_c.ml"
               : 'parameter_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'parameter_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'parameter_decl) in
    Obj.repr(
# 2298 "parsing_c/parser_c.mly"
                                        ( _1 @ [_3,  [_2]] )
# 7299 "parsing_c/parser_c.ml"
               : 'parameter_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2301 "parsing_c/parser_c.mly"
                           ( [_1] )
# 7306 "parsing_c/parser_c.ml"
               : 'taction_list_ne))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'taction_list_ne) in
    Obj.repr(
# 2302 "parsing_c/parser_c.mly"
                           ( _1 :: _2 )
# 7314 "parsing_c/parser_c.ml"
               : 'taction_list_ne))
; (fun __caml_parser_env ->
    Obj.repr(
# 2310 "parsing_c/parser_c.mly"
                        ( [] )
# 7320 "parsing_c/parser_c.ml"
               : 'taction_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'taction_list) in
    Obj.repr(
# 2311 "parsing_c/parser_c.mly"
                        ( _1 :: _2 )
# 7328 "parsing_c/parser_c.ml"
               : 'taction_list))
; (fun __caml_parser_env ->
    Obj.repr(
# 2314 "parsing_c/parser_c.mly"
                   ( [] )
# 7334 "parsing_c/parser_c.ml"
               : 'param_define_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'param_define) in
    Obj.repr(
# 2315 "parsing_c/parser_c.mly"
                                          ( [_1, []] )
# 7341 "parsing_c/parser_c.ml"
               : 'param_define_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 2 : 'param_define_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 1 : Ast_c.info) in
    let _3 = (Parsing.peek_val __caml_parser_env 0 : 'param_define) in
    Obj.repr(
# 2316 "parsing_c/parser_c.mly"
                                          ( _1 @ [_3, [_2]] )
# 7350 "parsing_c/parser_c.ml"
               : 'param_define_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'designator) in
    Obj.repr(
# 2319 "parsing_c/parser_c.mly"
              ( [_1] )
# 7357 "parsing_c/parser_c.ml"
               : 'designator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'designator_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'designator) in
    Obj.repr(
# 2320 "parsing_c/parser_c.mly"
                              ( _1 @ [_2] )
# 7365 "parsing_c/parser_c.ml"
               : 'designator_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'attribute) in
    Obj.repr(
# 2323 "parsing_c/parser_c.mly"
             ( [_1] )
# 7372 "parsing_c/parser_c.ml"
               : 'attribute_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 1 : 'attribute_list) in
    let _2 = (Parsing.peek_val __caml_parser_env 0 : 'attribute) in
    Obj.repr(
# 2324 "parsing_c/parser_c.mly"
                            ( _1 @ [_2] )
# 7380 "parsing_c/parser_c.ml"
               : 'attribute_list))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : 'attribute_list) in
    Obj.repr(
# 2326 "parsing_c/parser_c.mly"
                           ( _1 )
# 7387 "parsing_c/parser_c.ml"
               : 'attributes))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : (string * Ast_c.info)) in
    Obj.repr(
# 2329 "parsing_c/parser_c.mly"
                 ( [Attribute (fst _1), [snd _1]] )
# 7394 "parsing_c/parser_c.ml"
               : 'end_attributes))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.info) in
    Obj.repr(
# 2332 "parsing_c/parser_c.mly"
          (  [_1] )
# 7401 "parsing_c/parser_c.ml"
               : 'comma_opt))
; (fun __caml_parser_env ->
    Obj.repr(
# 2333 "parsing_c/parser_c.mly"
                    (  []  )
# 7407 "parsing_c/parser_c.ml"
               : 'comma_opt))
; (fun __caml_parser_env ->
    let _1 = (Parsing.peek_val __caml_parser_env 0 : Ast_c.expression) in
    Obj.repr(
# 2342 "parsing_c/parser_c.mly"
               ( Some _1 )
# 7414 "parsing_c/parser_c.ml"
               : 'gcc_opt_expr))
; (fun __caml_parser_env ->
    Obj.repr(
# 2343 "parsing_c/parser_c.mly"
                   ( None  )
# 7420 "parsing_c/parser_c.ml"
               : 'gcc_opt_expr))
(* Entry main *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
(* Entry celem *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
(* Entry statement *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
(* Entry expr *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
(* Entry type_name *)
; (fun __caml_parser_env -> raise (Parsing.YYexit (Parsing.peek_val __caml_parser_env 0)))
|]
let yytables =
  { Parsing.actions=yyact;
    Parsing.transl_const=yytransl_const;
    Parsing.transl_block=yytransl_block;
    Parsing.lhs=yylhs;
    Parsing.len=yylen;
    Parsing.defred=yydefred;
    Parsing.dgoto=yydgoto;
    Parsing.sindex=yysindex;
    Parsing.rindex=yyrindex;
    Parsing.gindex=yygindex;
    Parsing.tablesize=yytablesize;
    Parsing.table=yytable;
    Parsing.check=yycheck;
    Parsing.error_function=parse_error;
    Parsing.names_const=yynames_const;
    Parsing.names_block=yynames_block }
let main (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 1 lexfun lexbuf : Ast_c.program)
let celem (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 2 lexfun lexbuf : Ast_c.toplevel)
let statement (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 3 lexfun lexbuf : Ast_c.statement)
let expr (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 4 lexfun lexbuf : Ast_c.expression)
let type_name (lexfun : Lexing.lexbuf -> token) (lexbuf : Lexing.lexbuf) =
   (Parsing.yyparse yytables 5 lexfun lexbuf : Ast_c.fullType)
